; Davids Sound demo v0.1a
;
; most of this code is a rework of Chris Busch's
; code. I felt that I hade changed it enough to 
; call it my own.  Feal free to use it just dont blame
; me when things go wrong.
;
;  Special thanks to Eric Linenberg for fixing up the code!
;
; intro:
; just a demo of sound from the link port, use a 2.5mm
; to 3.5mm (standard) hedphone adaptor, avalible from radio
; shack.  Its ok if the adaptor is mono thoe sterio would 
; alow you more divercity. Try holding down more than one arow at a
; time for interesting sound efects
;
; Remember!!! if you want to modify this for sterio you must build your 
; own adapter, or you will only get sound from one ear!!!!
; you need to swap the red and black wires coming out of the calc
;
; 2.5mm plug     tip-----------outer ring 3.5mm jack
;         midle ring-----------midle ring
;         outer ring-----------tip
;
; I have tried to comment thouraly, because I dont know asm 
; enough to keep it all strait without comments, if I messed 
; sompthing up or left you confused, tell me.
;
; Revision History
;  v0.01  First introdused, just squalked
;  v0.1a  mutch faster and simpler model, alows for sepret adjustment
;          of the delay loops for more interesting sounds!
;  v0.1b  same as v0.1a but adjustible volume (sort of)
;
; coming soon:
;  Sterio Paning
;  sound efects (zaps, pops ect.)
;  wave player/sound recorder!
;
; David Tucker
; dh90791@goodnet.com
;
; ELinenberg@gnn.com (Eric Linenberg)

#include "ti-85.h"
;===========================================
;  DEFINES
;===========================================

#define   P_HI      %11000000        ;code to put port high
#define   P_LO      %11111100        ;code to put port low
#define   C_PORT    %00000111        ;addres of com port

.org 0
.db "Sound Gen v0.1a",0
;============================================================
;    this just setus up the home screen and loads DE with 255
;============================================================
main:
   LD  HL,$8641            ;init loop counter-- the initial delay
   LD  (HL),$FF
   LD  HL,$8642
   LD  (HL),$FF

   ROM_CALL(CLEARLCD)      ; Clear the display
   ld  hl, $0000           ;set the cursor to 0
   ld  (CURSOR_ROW), hl
   ld  hl, (PROGRAM_ADDR)  ;load prog addres
   ld  de, TitleStr        ;and add the offset of text
   add hl, de
   ROM_CALL(D_ZT_STR)      ;display text
                
big_loop:                  ;start of event loop!

set_low:
   ld  b,P_LO         ;set w(white) and r(red) low, 0 0
   ld  c,C_PORT       ;port 7 (link port)
   out (c),b          ;output 0 0

   ld   a,($8641)     ;first delay loop
   ld   b,a
delay1:
   djnz delay1

set_high:
   ld   b,P_HI         ;set w & r high, 1 1 (default)
   ld   c,C_PORT       ;port 7 (com port)
   out  (c),b          ;output 1 1,make sure this is the last to be outputted!
                      ;pulse the port high, must be high when quiting

testkey:
        xor     a
        out     (1),a       ;send 0 to the keyboard port
        in      a,(1)       ;check the keyboard port directly.
       
        bit     6,a         ;EXIT (among others) pressed?
        jr      z,quit      ;jump to quit

        bit     3,a         ;UP (among others) pressed?
        CALL_Z(up)  
        
        bit     0,a         ;DOWN (among other) pressed?
        CALL_Z(down)
        
        bit     2,a         ;LEFT (among others) pressed?
        CALL_Z(left)  
        
        bit     1,a         ;RIGHT (among other) pressed?
        CALL_Z(right)

        ld      a,($8642)   ;second delay loop
        ld      b,a
delay2:
        djnz delay2

   jr   big_loop            ;end of event loop

quit:
   ret
   
;===========================================
;   gotten keypresses
;===========================================  
up:                 ;Decrease delay
   LD  HL,$8642
   DEC (HL)
   ret              ; & return
down:               ;Increase delay
   LD  HL,$8642
   INC (HL)
   ret              ; & return

left:               ;Decrease delay
   LD  HL,$8641
   DEC (HL)
   ret              ; & return
right:              ;Increase delay
   LD  HL,$8641
   INC (HL)
   ret              ; & return

;===========================================

TitleStr:           ;Intro to program, rahter wasteful but cute
  .db " David's Sound Demo  "
  .db "    Ver. 0.1a        "
  .db " dh90791@goodnet.com "
  .db "   with help from    "
  .db " ELinenberg@gnn.com  "
  .db " up/down/left/right  "
  .db "   to change pitch   "
  .db "    exit to exit    ",0

.END
