; Davids Sound demo v0.1b
;
; most of this code is a rework of Chris Busch's
; code. I felt that I hade changed it enough to 
; call it my own.  Feal free to use it just dont blame
; me when things go wrong.
;
;  Special thanks to Eric Linenberg for fixing up the code!
;
; intro:
; just a demo of sound from the link port, use a 2.5mm
; to 3.5mm (standard) hedphone adaptor, avalible from radio
; shack.  Its ok if the adaptor is mono thoe sterio would 
; alow you more divercity. Left and Right arows adjust volume (sort of)
; there is an error in the second delay loop, so ocasionaly it changes
; the pitch as well!
;
; Remember!!! if you want to modify this for sterio you must build your 
; own adapter, or you will only get sound from one ear!!!!
; you need to swap the red and black wires coming out of the calc
;
; 2.5mm plug     tip-----------outer ring 3.5mm jack
;         midle ring-----------midle ring
;         outer ring-----------tip
;
; I have tried to comment thouraly, because I dont know asm 
; enough to keep it all strait without comments, if I messed 
; sompthing up or left you confused, tell me.
;
; Revision History
;  v0.01  First introdused, just squalked
;  v0.1a  mutch faster and simpler model, alows for sepret adjustment
;          of the delay loops for more interesting sounds!
;  v0.1b  same as v0.1a but adjustible volume (sort of)
;
; coming soon:
;  Sterio Paning
;  sound efects (zaps, pops ect.)
;  wave player/sound recorder!
;
; David Tucker
; dh90791@goodnet.com
;
; ELinenberg@gnn.com (Eric Linenberg)

#include "ti-85.h"

;===========================================
;  DEFINES
;===========================================

#define   P_HI      %11000000        ;code to put port high
#define   P_LO      %11111100        ;code to put port low
#define   C_PORT    %00000111        ;addres of com port

.org 0
.db "Sound Gen v0.1b",0
;============================================================
;    this just setus up the home screen and loads DE with 255
;============================================================
main:
   LD  HL,$8641            ;init loop counter-- the initial delay
   LD  (HL),$FF
   LD  HL,$8642
   LD  (HL),$FF

   ROM_CALL(CLEARLCD)      ; Clear the display
   ld  hl, $0000           ;set the cursor to 0
   ld  (CURSOR_ROW), hl
   ld  hl, (PROGRAM_ADDR)  ;load prog addres
   ld  de, TitleStr        ;and add the offset of text
   add hl, de
   ROM_CALL(D_ZT_STR)      ;display text
                
big_loop:

set_low:
   ld    b,P_LO         ;set w(white) and r(red) low, 0 0
   ld    c,C_PORT       ;port 7 (link port)
   out   (c),b          ;output 0 0

   ld    a,($8641)      ;First delay loop
   ld    b,a            ;the one that controlls volume
delay1:                 ;the longer the loop
   djnz  delay1         ;the louder the volume

set_high:
   ld  b,P_HI         ;set w & r high, 1 1 (default)
   ld  c,C_PORT       ;port 7 (com port)
   out (c),b          ;output 1 1,make sure this is the last to be outputted!
                      ;pulse the port high, must be high when quiting

testkey:
        xor     a
        out     (1),a       ;send 0 to the keyboard port
        in      a,(1)       ;check the keyboard port directly.
       
        bit     6,a         ;EXIT (among others) pressed?
        jr      z,quit      ;jump to quit

        bit     3,a         ;UP (among others) pressed?
        CALL_Z(up)  
        
        bit     0,a         ;DOWN (among other) pressed?
        CALL_Z(down)
        
        bit     2,a         ;LEFT (among others) pressed?
        CALL_Z(left)  
        
        bit     1,a         ;RIGHT (among other) pressed?
        CALL_Z(right)

        ld      a,($8641)   ;second delay loop
        dec     a           ;corect for the rolover error
        ld      b,a         ;used to compensate for the change in the first loop
        ld      a,$FF       ;too keep the over all time constant
        sub     b           ;so there is no change in pitch
;        add     a,$01
        ld      b,a
delay2:                         ;delay loop
        djnz delay2

        ld      a,($8642)       ;Third delay loop
        ld      b,a             ;loop 2 and 3 could be combined into a
delay3:                         ;bigger loop
        nop                  ;extra delays to bring down the pitch
        nop                  ;if you turnd the loop into a 16 bit loop
        nop                  ;you could get the full range without the delay
        nop
        nop
        nop
        djnz delay3

   jr   big_loop

quit:
   ret
   
;===========================================
;   gotten keypresses
;===========================================  
up:
   LD  HL,$8642     ;Increase Tone
   DEC (HL)
   ret              ; & return
down:
   LD  HL,$8642     ;Decrease Tone
   INC (HL)
   ret              ; & return

left:
   LD  HL,$8641     ;Decrease volume
   DEC (HL)
   ret              ; & return
right:
   LD  HL,$8641     ;Increase volume
   INC (HL)
   ret              ; & return


TitleStr:           ;Intro to program, rahter wasteful but cute
  .db " David's Sound Demo  "
  .db "     Ver 0.1b        "
  .db " dh90791@goodnet.com "
  .db "     modified by     "
  .db " ELinenberg@gnn.com  " 
  .db "up/down change pitch "
  .db "left/right change vol"
  .db "    exit to exit    ",0

.END
