/////
/////

#include "ti-85.h"

.org 0
.db "TI85 fade effect",0

cont = $80DF

start:
      ld a,(CONTRAST)        
      ld (cont),a

      CALL_(fadedown_loop)
      ROM_CALL(CLEARLCD)
      ld a,30
      ld (CURSOR_X),a
      ld (CURSOR_Y),a
      ld de, message          
      ld hl, (PROGRAM_ADDR)  
      add hl, de             
      ROM_CALL(D_ZM_STR)     
      CALL_(fadeup_loop)

keyloop:
      call GET_KEY            ; wait until key is pressed to go to end
      cp $00
      jr nz,end
      jr keyloop

end:
    CALL_(fadedown_loop)
    ROM_CALL(CLEARLCD)
    CALL_(fadeup_loop)
    ret z

; ****** ;
; ****** ;
; ****** ;

fadedown_loop:
      CALL_(delay)
      ld a,(CONTRAST)
      dec a
      ld (CONTRAST),a         
      out (2),a
      cp 0
      jr nz,fadedown_loop
      ret

fadeup_loop:
      CALL_(delay)
      ld a,(cont)
      ld e,a
      ld a,(CONTRAST)
      inc a
      ld (CONTRAST),a
      out (2),a
      cp e
      jr nz,fadeup_loop
      ret
       
delay:
        ld   bc,14000
delay_loop:
        dec  bc
        ld   a,b
        or   c
        jr   nz,delay_loop
        ret                

message:  .db "(press any key)", 0

.end

