;Morons

;(c) Tim FitzRandolph, 1996


#include "TI-85.H"


.org 0
.db "Morons BETA",0


;-------------------------------------------------------------
piclocation             = $80DF         ;for ZCP algorithm

camx                    = $80E1         ;camera's x tile
camy                    = $80E2         ;camera's y tile
laddr                   = $80E3         ;address of level.

forx                    = $80E5         ;for drawing screen
fory                    = $80E6         ;for frawing screen.
dx                      = $80E7
dy                      = $80E8

square                  = $80E9
temp                    = $80EB

TempLine                = $80ED
PicCoor                 = $8100
offset                  = $8102

temp2                   = $8104

scroll                  = $8106

NASR_Status             = $8108 ;for NASR

chx                     = $810A         ;choice X position (on screen)
chy                     = $810B         ;choice Y position (on screen)

chlx                    = $810C         ;choice X (in level)
chly                    = $810D         ;choice Y (in level)

move                    = $8110

choosing                = $8112
chaddr                  = $8113

choice                  = $8115


maddr                   = $8116         ;address of the MORON table
mcount                  = $8118         ;offset into MORON table!!!
mtx                     = $8119         ;tile X of moron
mty                     = $811A         ;tile Y of moron.
mox                     = $811B         ;x offset
moy                     = $811C
mdir                    = $811D         ;moron's direction 1=up,2=right,etc.

morx                    = $811E         ;moron's screen pos (X)
mory                    = $811F         ;moron's screen pos (Y)

Width                   = $8120         ;for collision routine
Height                  = $8121         ;for    "        "

tempx                   = $8122
tempy                   = $8123
;-------------------------------------------------------------
Init:
        ld a,4
        out (5),a

        ROM_CALL(CLEARLCD)

        ld a,0
        ld (camx),a
        ld (camy),a

        ld a,1
        ld (NASR_Status),a

        ld a,0
        ld (chlx),a
        ld (chly),a

        ld a,1
        ld (chx),a
        ld a,62
        ld (chy),a

        ld a,0
        ld (choosing),a

        ld hl,(PROGRAM_ADDR)
        ld de,MoronTable
        add hl,de
        ld (maddr),hl

        ld a,0
        ld (mcount),a

TitleScreen:
        ld hl,TitlePic
        ld (piclocation),hl
        CALL_(Start)

TitleWait:
        call GET_KEY
        cp $37
        ret z
        cp $09
        jr z,StartGame

        jr TitleWait



StartGame:
        ROM_CALL(CLEARLCD)
        CALL_(DrawLevel)


        jr GameLoop

        





GameLoop:
        JUMP_(KeyTest)
akeytest:
        CALL_(DoMorons)
        jr GameLoop




KeyTest:
        ld a,0
        ld (move),a
        ld a,0
        ld (scroll),a           ;by default, do not scroll.

        ld a,0
        out (1),a      
        in a,(1)       
        cp 0           
        jr z,akeytest  
        bit 6,a     
        jr z,QuitGame
        bit 5,a
        push af
        CALL_Z(SetScroll)       ;holding down 2nd means you want to scroll.
        pop af
        bit 7,a
        push af
        CALL_Z(AlphaPressed)
        pop af
        bit 1,a                 ;LEFT (among others) pressed?
        push af
        JUMP_Z(LeftPressed)      ;yep.
        pop af
        bit 2,a
        push af
        JUMP_Z(RightPressed)
        pop af
        bit 3,a
        push af
        JUMP_Z(UpPressed)
        pop af
        bit 0,a
        push af
        JUMP_Z(DownPressed)
        pop af


        JUMP_(akeytest)

QuitGame:
        ld a,(choosing)
        cp 1
        JUMP_Z(nochoose)

        ROM_CALL(CLEARLCD)
        CALL_(ResetLevel)

	ld hl, $8C40
	set 0, (hl)                     ; tell zshell to recalc checksum

        ret

nochoose:
        ld a,0
        ld (choosing),a
        CALL_(DrawLevel)

        JUMP_(akeytest)

ResetLevel:
        ld hl,(PROGRAM_ADDR)
        ld de,TheLevel
        add hl,de
        ld (laddr),hl

        ld b,187                ;375/2...
RLloop:
        ld hl,(laddr)

        ld a,(hl)
        cp 5
        CALL_Z(doa1)
        cp 6
        CALL_Z(doa1)
        cp 7
        CALL_Z(doa1)
        cp 8
        CALL_Z(doa1)
        cp 9
        CALL_Z(doa3)

        inc hl

        ld a,(hl)
        cp 5
        CALL_Z(doa1)
        cp 6
        CALL_Z(doa1)
        cp 7
        CALL_Z(doa1)
        cp 8
        CALL_Z(doa1)
        cp 9
        CALL_Z(doa3)

        inc hl
        ld (laddr),hl

        djnz RLloop

        ret
        
doa1:
        ld a,1
        ld (hl),a
        ret

doa3:
        ld a,3
        ld (hl),a
        ret



SetScroll:
        ld a,(choosing)
        cp 1
        JUMP_Z(StopChoosing)

        ld a,1
        ld (scroll),a
        ret

AlphaPressed:
        ld a,(scroll)
        cp 1
        ret z

        ld a,(choosing)
        cp 1
        ret z


        ld hl,(PROGRAM_ADDR)
        ld de,TheLevel
        add hl,de
        ld (chaddr),hl           ;save it.

        ld a,(chlx)
        ld d,0
        ld e,a
        ld hl,(chaddr)
        add hl,de
        ld (chaddr),hl           ;save new value.

        ld a,(chly)
        cp 0
        jr z,SAmultdone

        ld a,25
        ld (temp2),a
SAMultloop:
        ld hl,(chaddr)
        ld a,(chly)
        ld d,0
        ld e,a
        add hl,de
        ld (chaddr),hl

        ld a,(temp2)
        dec a
        cp 0
        jr z,SAmultdone
        ld (temp2),a
        jr SAMultloop

SAmultdone:
        ld hl,(chaddr)
        ld a,(hl)
        cp 2            ;on metal?
        ret z
        cp 4            ;on a pit?
        ret z
        cp 0            ;on nothing?
        ret z
        cp 's'          ;on level Start?
        ret z
        cp 'f'          ;on level Finish
        ret z

        ld a,1
        ld (choosing),a

        ld a,1
        ld (choice),a

        ld hl,(PROGRAM_ADDR)
        ld de,User1
        add hl,de
        ld (square),hl

        ret

StopChoosing:
        ld a,0
        ld (choosing),a

        ld hl,(chaddr)
        ld a,(choice)
        add a,4
        ld (hl),a
        ret


LeftPressed:
        pop af
        ld a,(choosing)
        cp 1
        JUMP_Z(chooseleft)

        ld a,(scroll)
        cp 1
        JUMP_Z(ScrollLeft)

        CALL_(EraseBox)
        ld a,(chx)
        cp 1
        jr z,jd1
        sub 12
        ld (chx),a

        ld a,(chlx)
        cp 0
        ret z
        dec a
        ld (chlx),a
jd1:
        CALL_(DrawBox)
        JUMP_(akeytest)

RightPressed:
        pop af
        ld a,(choosing)
        cp 1
        JUMP_Z(chooseright)

        ld a,(scroll)
        cp 1
        JUMP_Z(ScrollRight)

        CALL_(EraseBox)
        ld a,(chx)
        cp 109
        jr z,jd2
        add a,12
        ld (chx),a
        ld a,(chlx)
        cp 25
        ret z
        inc a
        ld (chlx),a
jd2:
        CALL_(DrawBox)
        JUMP_(akeytest)

UpPressed:
        pop af
        ld a,(choosing)
        cp 1
        ret z

        ld a,(scroll)
        cp 1
        JUMP_Z(ScrollUp)

        CALL_(EraseBox)
        ld a,(chy)
        cp 62
        jr z,jd3
        add a,12
        ld (chy),a

        ld a,(chly)
        cp 0
        ret z
        dec a
        ld (chly),a
jd3:
        CALL_(DrawBox)
        JUMP_(akeytest)

DownPressed:
        pop af
        ld a,(choosing)
        cp 1
        ret z

        ld a,(scroll)
        cp 1
        JUMP_Z(ScrollDown)


        CALL_(EraseBox)
        ld a,(chy)
        cp 14
        jr z,jd4
        sub 12
        ld (chy),a

        ld a,(chly)
        cp 15
        ret z
        inc a
        ld (chly),a
jd4:
        CALL_(DrawBox)

        JUMP_(akeytest)

EraseBox:

        CALL_(DrawLevel)
        ret


DrawBox:

        ld a,(chx)
        ld b,a
        ld a,(chy)
        ld c,a
        ld hl,(PROGRAM_ADDR)
        ld de,BoxSprite
        add hl,de
        CALL_(NASRTRANS)
        ret


chooseleft:
        CALL_(EraseChoice)

        ld a,(choice)
        cp 1
        JUMP_Z(cljd)
        dec a
        ld (choice),a
        cp 1
        CALL_Z(squareis1)
        cp 2
        CALL_Z(squareis2)
        cp 3
        CALL_Z(squareis3)
        cp 4
        CALL_Z(squareis4)
        JUMP_(cjld2)
cljd:
        CALL_Z(squareis1)
cjld2:
        CALL_(DrawChoice)
        JUMP_(akeytest)

chooseright:
        CALL_(EraseChoice)

        ld a,(choice)
        cp 5
        JUMP_Z(crjd)
        inc a
        ld (choice),a
        cp 2
        CALL_Z(squareis2)
        cp 3
        CALL_Z(squareis3)
        cp 4
        CALL_Z(squareis4)
        cp 5
        CALL_Z(squareis5)
        JUMP_(crjd2)
crjd:
        CALL_(squareis5)
crjd2:
        CALL_(DrawChoice)
        JUMP_(akeytest)

squareis1:
        ld hl,(PROGRAM_ADDR)
        ld de,User1
        add hl,de
        ld (square),hl
        ret

squareis2:
        ld hl,(PROGRAM_ADDR)
        ld de,User2
        add hl,de
        ld (square),hl
        ret

squareis3:
        ld hl,(PROGRAM_ADDR)
        ld de,User3
        add hl,de
        ld (square),hl
        ret

squareis4:
        ld hl,(PROGRAM_ADDR)
        ld de,User4
        add hl,de
        ld (square),hl
        ret

squareis5:
        ld hl,(PROGRAM_ADDR)
        ld de,User5
        add hl,de
        ld (square),hl
        ret

EraseChoice:
        CALL_(DrawLevel)
        ret

DrawChoice:
        ld a,(chx)
        ld b,a
        ld a,(chy)
        ld c,a
        ld hl,(square)
        CALL_(NASRTRANS)
        ret
        
ScrollLeft:
        ld a,(camx)
        dec a
        cp -1           ;too far to the left?
        CALL_Z(setato0)
        ld (camx),a

        ld a,(move)
        cp 1
        jr z,noshift1

        ld a,(chlx)
        dec a
        cp -1
        CALL_Z(setato0)
        ld (chlx),a
noshift1:
        CALL_(DrawLevel)
        JUMP_(akeytest)

ScrollRight:
        ld a,(camx)
        inc a
        cp 16
        CALL_Z(setato15)
        ld (camx),a

        ld a,(move)
        cp 1
        jr z,noshift2

        ld a,(chlx)
        inc a
        cp 26
        CALL_Z(setato25)
        ld (chlx),a
noshift2:
        CALL_(DrawLevel)
        JUMP_(akeytest)

ScrollUp:
        ld a,(camy)
        dec a
        cp -1
        CALL_Z(setato0)
        ld (camy),a

        ld a,(move)
        cp 1
        jr z,noshift3

        ld a,(chly)
        dec a
        cp -1
        CALL_Z(setato0)
        ld (chly),a
noshift3:
        CALL_(DrawLevel)
        JUMP_(akeytest)

ScrollDown:
        ld a,(camy)
        inc a
        cp 11
        CALL_Z(setato10)
        ld (camy),a

        ld a,(move)
        cp 1
        jr z,noshift4

        ld a,(chly)
        inc a
        cp 16
        CALL_Z(setato15)
        ld (chly),a
noshift4:
        CALL_(DrawLevel)
        JUMP_(akeytest)

setato0:
        ld a,1
        ld (move),a

        ld a,0
        ret

setato10:
        ld a,1
        ld (move),a

        ld a,10
        ret

setato15:
        ld a,1
        ld (move),a

        ld a,15
        ret

setato25:
        ld a,25
        ret













DrawLevel:              ;draw the level on screen based on camx,camy....
        ld hl,(PROGRAM_ADDR)
        ld de,TheLevel
        add hl,de
        ld (laddr),hl           ;save it.

        ld a,(camx)
        ld d,0
        ld e,a
        ld hl,(laddr)
        add hl,de
        ld (laddr),hl           ;save new value.

        ld a,(camy)
        cp 0
        jr z,multdone

        ld a,25
        ld (temp2),a
Multloop:
        ld hl,(laddr)
        ld a,(camy)
        ld d,0
        ld e,a
        add hl,de
        ld (laddr),hl

        ld a,(temp2)
        dec a
        cp 0
        jr z,multdone
        ld (temp2),a
        jr Multloop

multdone:



        ld a,0
        ld (fory),a
        ld a,62
        ld (dy),a
Fory:

        ld a,0
        ld (forx),a
        ld a,1
        ld (dx),a
        CALL_(Forx)

        ld hl,(laddr)
        ld de,15  
        add hl,de
        ld (laddr),hl           ;laddr has begginning of next line.

        ld a,(dy)
        sub 12
        ld (dy),a               ;add 12 to y position.


        ld a,(fory)
        inc a
        cp 5
        ret z
        ld (fory),a
        jr Fory

       
Forx:
        CALL_(DrawSquare)


        ld a,(dx)
        add a,12
        ld (dx),a       ;add 12 to drawing position.

        ld hl,(laddr)
        inc hl
        ld (laddr),hl

        ld a,(forx)
        inc a
        cp 10
        ret z
        ld (forx),a



        jr Forx

DrawSquare:
        ld hl,(laddr)
        ld a,(hl)
        cp 0
        CALL_Z(square0)
        cp 1
        CALL_Z(square1)
        cp 2
        CALL_Z(square2)
        cp 3
        CALL_Z(square3)
        cp 4
        CALL_Z(square4)
        cp 5
        CALL_Z(square5)
        cp 6
        CALL_Z(square6)
        cp 7
        CALL_Z(square7)
        cp 8
        CALL_Z(square8)
        cp 9
        CALL_Z(square9)
        cp 's'
        CALL_Z(squareS)
        cp 'f'
        CALL_Z(squareF)

        ld a,(dx)
        ld b,a
        ld a,(dy)
        ld c,a
        ld hl,(square)
        CALL_(NASRWARP)
        ret


square0:
        ld hl,(PROGRAM_ADDR)
        ld de,Void
        add hl,de
        ld (square),hl
        ret

square1:
        ld hl,(PROGRAM_ADDR)
        ld de,Grass
        add hl,de
        ld (square),hl
        ret

square2:
        ld hl,(PROGRAM_ADDR)
        ld de,Metal
        add hl,de
        ld (square),hl
        ret

square3:
        ld hl,(PROGRAM_ADDR)
        ld de,Water
        add hl,de
        ld (square),hl
        ret

square4:
        ld hl,(PROGRAM_ADDR)
        ld de,Pit
        add hl,de
        ld (square),hl
        ret

square5:
        ld hl,(PROGRAM_ADDR)
        ld de,User1
        add hl,de
        ld (square),hl
        ret

square6:
        ld hl,(PROGRAM_ADDR)
        ld de,User2
        add hl,de
        ld (square),hl
        ret

square7:
        ld hl,(PROGRAM_ADDR)
        ld de,User3
        add hl,de
        ld (square),hl
        ret

square8:
        ld hl,(PROGRAM_ADDR)
        ld de,User4
        add hl,de
        ld (square),hl
        ret

square9:
        ld hl,(PROGRAM_ADDR)
        ld de,User5
        add hl,de
        ld (square),hl
        ret

squareS:
        ld hl,(PROGRAM_ADDR)
        ld de,StartSprite
        add hl,de
        ld (square),hl
        ret
 
squareF:
        ld hl,(PROGRAM_ADDR)
        ld de,FinSprite
        add hl,de
        ld (square),hl
        ret



;----------------------------------------------------------------->
DoMorons:
        ld a,0
        ld (mcount),a

DMLoop:
        ld hl,(maddr)
        ld a,(mcount)
        ld d,0
        ld e,a
        add hl,de
        ld a,(hl)       ;a has moron's alive var.
        cp 1
        jr nz,nextmoron

        CALL_(PlotMoron)

nextmoron:
        ld a,(mcount)
        add a,6
        cp 210
        ret z
        ld (mcount),a
        jr DMLoop




PlotMoron:
        inc hl
        ld a,(hl)       ;a has moron'x X tile.
        ld (mtx),a

        inc hl
        ld a,(hl)       ;a has moron's Y tile.
        ld (mty),a

        inc hl
        ld a,(hl)       ;a has moron's x offset
        ld (mox),a

        inc hl
        ld a,(hl)
        ld (moy),a      ;s has moron's y offset

        CALL_(OnScreen)
        cp 1
        ret nz

        ld a,(camx)
        ld b,a
        ld a,(mtx)
        sub b
        ld (mtx),a

        ld a,(camy)
        ld b,a
        ld a,(mty)
        sub b
        ld (mty),a

        CALL_(XMultBy12)
        CALL_(YMultBy12)


        ld a,(tempx)
        ld b,a
        ld a,(tempy)
        ld c,a
        CALL_(PtChg)
        inc b
        CALL_(PtChg)
        inc C
        CALL_(PtChg)
        dec b
        CALL_(PtChg)
        ret

XMultBy12:
        ld a,(mtx)
        ld b,a
        ld a,0
        ld (temp2),a
XMB12Loop:
        ld a,(temp2)
        add a,12
        ld (temp2),a

        djnz XMB12Loop
        ld a,(mox)
        ld b,a
        ld a,(temp2)
        add a,b
        ld (tempx),a
        ret

YMultBy12:
        ld a,(mty)
        ld b,a
        ld a,62
        ld (temp2),a
YMB12Loop:
        ld a,(temp2)
        sub 12
        ld (temp2),a

        djnz YMB12Loop
        ld a,(moy)
        ld b,a
        ld a,(temp2)
        sub b
        ld (tempy),a
        ret


OnScreen:
        ld a,(camx)
        ld (tempx),a
        ld a,(camy)
        ld (tempy),a
        ld a,10
        ld (temp2),a
OSLoop1:
        ld a,(mtx)
        ld b,a
        ld a,(camx)
        cp b
        jr z,OSL2
        inc a
        ld (camx),a

        ld a,(temp2)
        dec a
        cp 0
        jr z,OSNoColl
        ld (temp2),a
        jr OSLoop1

OSL2:
        ld a,5
        ld (temp2),a
OSLoop2:
        ld a,(mty)
        ld b,a
        ld a,(camy)
        cp b
        jr z,OSColl
        inc a
        ld (camy),a

        ld a,(temp2)
        dec a
        cp 0
        jr z,OSNoColl
        ld (temp2),a
        jr OSLoop2

OSColl:
        ld a,(tempx)
        ld (camx),a
        ld a,(tempy)
        ld (camy),a
        ld a,1
        ret
        
OSNoColl:
        ld a,(tempx)
        ld (camx),a
        ld a,(tempy)
        ld (camy),a
        ld a,0
        ret
        
        
        



Start:
        DI
        ld      HL,$FFFF
        xor     A
        ld      (HL),A
        ld      DE,$FFFE
        ld      BC,$03FF
        lddr
        exx
        ld      HL,(PROGRAM_ADDR)
        ld      DE,(piclocation)
        add     HL,DE
        ld      C,$80
Loop:
        ld      A,(HL)
        inc     HL
        ld      D,A
        or      A
        jr      Z,EndDecode
        rlca
        jr      C,Copy
Stream:
        ld      A,D
        and     $3F
        ld      B,A
        ld      A,D
        and     $40
StreamLoop:
        or      A
        jr      Z,SLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
SLSuite:
        srl     C
        jr      NC,DjnzSL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzSL:
        djnz    StreamLoop
        jr      Loop
Copy:
        ld      B,$07
CopyLoop:
        rlca
        jr      NC,CLSuite
        ex      AF,AF'
        ld      A,C
        exx
        or      (HL)
        ld      (HL),A
        exx
        ex      AF,AF'
CLSuite:
        srl     C
        jr      NC,DjnzCL
        exx
        inc     HL
        exx
        ld      C,$80
DjnzCL:
        djnz    CopyLoop
        jr      Loop
EndDecode:
        exx
        EI
        ret


NASRWARP:    
        push    bc
        ex      de,hl
        ROM_CALL(FIND_PIXEL)
        ld      bc,$fc00
        add     hl,bc
        ld      (PicCoor),hl
        ex      de,hl
        ld      b,$ff
Patch:
        rla
        inc     b
        jr      nc,Patch
        ld      a,(hl)
        ld      c,a      
        inc     hl
        ld      a,(hl)
        ld      (offset),a
        ld      a,b   
        ld      e,c
        cp      (hl)
        jr      c,DS1
        inc     e
DS1:
        inc     hl
        ld      a,(hl)
        ld      d,a
        inc     hl
YLoop:            
        push    bc 
        push    de
        ld      b,8
        ex      de,hl
        ld      hl,TempLine
InitTempLineLoop:
        ld      (hl),$ff
        inc     hl
        djnz    InitTempLineLoop
        ex      de,hl
	ld	a,(NASR_Status)
	cp	0
	jr	z,NASRErase
NASRDraw:
        ld      b,0
        ld      de,TempLine
        ldir       
	jr	NASRDrawFin
NASRErase:
	ld	b,c
	ld	hl,TempLine
LoadEmpty:
	ld	(hl),0
	inc	hl
	djnz	LoadEmpty
NASRDrawFin:
        pop     de
        pop     bc
        push    hl
        push    bc         
        push    de
        ld      d,b
        ld      a,b
        cp      0
        jr      z,skipshift
SpriLoop1:
        ld      a,b    
        ld      HL,TempLine
        ld      b,e
        scf
SpriLoop2:        
        rr      (HL)
        inc     HL
        djnz    SpriLoop2
        ld      b,a
        djnz    SpriLoop1        
        ld      b,d
skipshift:
        ld      a,$ff           ;fill accumulator
        inc     b
mask1:
        srl     a               ;make the mask
        djnz    mask1           ;something like
        scf                     ;00001111 ->
        rl      a                        
        ld      hl,(PicCoor)    ;implement the mask
        or      (hl)            ;this preserve the 0 bits
        ld      hl,TempLine   ;become xxxx1111
        and     (hl)            ;when anded, become
        ld      (hl),a          ;xxxxyyyy
        ld      b,d             ;retrieve b
        ld      a,(offset)
        dec     a
        sub     b
        jr      nc,skip
        sub     248
skip:
        ld      b,a
        inc     b
        ld      a,$ff
mask2:               
        sla     a
        djnz    mask2
        scf
        rr      a
        dec     e
        ld      hl,(PicCoor)
        ld      d,0
        add     hl,de
        or      (hl)
        ld      hl,TempLine
        add     hl,de
        and     (hl)
        ld      (hl),a
        inc     e
        ld      c,e
        ld      hl,(PicCoor)
        ld      de,16
        push    hl
        add     hl,de
        ld      (PicCoor),hl
        pop     hl
        ld      de,TempLine
        ex      de,hl
        ld      b,0
        ldir      
        pop     de
        pop     bc
        pop     hl
        dec     d
        JUMP_NZ(YLoop)
        pop     bc
        ret



NASRTRANS:    
        push    bc
        ex      de,hl
        ROM_CALL(FIND_PIXEL)
        ld      bc,$fc00
        add     hl,bc
        ld      (PicCoor),hl
        ex      de,hl
        ld      b,$ff
Patch1:
        rla
        inc     b
        jr      nc,Patch1
        ld      c,(hl)
        inc     hl
        ld      a,b   
        ld      e,c
        cp      (hl)
        jr      c,DS11
        inc     e
DS11:
        inc     hl
        ld      a,(hl)
        ld      d,a
        inc     hl
YLoop1:            
        push    bc 
        push    de
        ld      b,8
        ex      de,hl
        ld      hl,TempLine
InitTempLineLoop1:
        ld      (hl),0
        inc     hl
        djnz    InitTempLineLoop1
        ex      de,hl
        ld      b,0
        ld      de,TempLine
        ldir       
        pop     de
        pop     bc
        ld      a,b
        cp      0 
        CALL_NZ(ShiftLine1)   
        push    bc
        push    hl
        push    de
        ld      b,e
        ld      hl,(PicCoor)
        ld      de,16
        push    hl
        add     hl,de
        ld      (PicCoor),hl
        pop     hl
        ld      de,TempLine
        ex      de,hl
LoadSpriteLoop1:
        ld      a,(hl)
        ex      de,hl
        or      (hl)
        ld      (hl),a
        ex      de,hl
        inc     de
        inc     hl
        djnz    LoadSpriteLoop1
        pop     de
        pop     hl
        pop     bc
        dec     d
        jr      nz,YLoop1
        pop     bc
        ret


ShiftLine1:
        push    hl
        push    bc 
SpriLoop11:
        ld      a,b    
        ld      HL,TempLine
        ld      b,e
        and     a
SpriLoop21:        
        rr      (HL)
        inc     HL
        djnz    SpriLoop21
        ld      b,a
        djnz    SpriLoop11        
        pop     bc
        pop     hl
        ret

PtChg:
        ROM_CALL(FIND_PIXEL)
        ld      DE,$FC00
        add     HL,DE
        or      (HL)
        ld      (HL),A
        ret


;------------------------------------------------------------------
;       A L L   . D B   D A T A   F O R   T H E   G A M E
;------------------------------------------------------------------


;Table of Morons (up to 35 morons in a level)...

MoronTable:
        .db 1,2,2,6,6,3
        .db 1,1,1,6,6,3
        .db 1,9,9,6,6,3
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0     
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0
        .db 0,0,0,0,0,0


;------------------------------------------------------------------
;all levels are to be 25x15 in size.  Otherwise it gets messed up!
;------------------------------------------------------------------
;LEVEL DATA EXPLAINED:

;0 - void (nothing)
;1 - Grass
;2 - Metal
;3 - Water
;4 - Pit of Doom

;7 - Start of Level
;8 - End of Level


TheLevel:
        .db 0,0,0,0,1,1,1,1,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0
        .db 0,1,1,'s',1,1,1,1,1,1,1,2,2,2,2,1,1,1,2,0,0,0,0,2,2
        .db 4,1,1,1,1,2,4,1,2,1,1,1,1,1,1,1,1,1,2,0,0,0,0,2,2
        .db 1,1,1,1,1,2,1,4,2,1,1,1,1,1,2,4,1,1,2,0,0,0,0,2,2
        .db 4,1,1,1,1,2,2,2,2,1,1,1,1,2,4,2,4,2,2,0,0,0,0,2,2
        .db 0,1,1,1,1,2,1,1,2,2,2,2,2,2,2,2,2,2,2,0,0,0,2,4,2
        .db 4,1,1,1,1,1,2,2,1,1,1,1,1,2,0,0,0,0,0,0,0,2,3,2
        .db 1,1,2,1,1,1,1,1,1,1,1,1,1,2,1,1,1,0,1,1,1,0,2,1,2
        .db 4,2,4,2,1,3,3,3,3,1,1,1,1,2,1,1,1,1,1,1,1,0,0,2,2
        .db 1,1,2,1,3,1,1,1,3,3,3,3,3,3,3,1,1,1,1,4,1,1,0,0,0
        .db 4,2,1,3,3,3,2,2,2,2,2,1,1,2,2,3,3,1,1,1,1,1,0,0,0
        .db 0,1,2,1,3,3,3,1,1,1,1,0,1,1,1,2,2,3,1,1,1,'f',0,0,0
        .db 0,0,1,2,1,3,3,2,1,0,0,0,0,0,0,1,1,1,3,0,0,0,0,0,0
        .db 0,0,0,1,2,1,2,1,1,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0
        .db 0,0,0,1,1,1,1,1,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0






Void:
        .db 2,5,12
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000
        .db %00000000,%00000000

Grass:
        .db 2,5,12
        .db %00100100,%01000000
        .db %00100000,%10000000
        .db %10000000,%00010000
        .db %00001000,%01000000
        .db %00100001,%00010000
        .db %10000010,%01000000
        .db %00010000,%00010000
        .db %11000010,%00100000
        .db %00010000,%00010000
        .db %10000010,%00100000
        .db %00010000,%10000000
        .db %00010010,%10000000

Metal:
        .db 2,5,12
        .db %11111111,%11110000
        .db %11000000,%00110000
        .db %10111111,%11110000
        .db %10110101,%01110000
        .db %10101010,%11110000
        .db %10110101,%01110000
        .db %10101010,%11110000
        .db %10110101,%01110000
        .db %10101010,%11110000
        .db %10111111,%11110000
        .db %11111111,%11110000
        .db %11111111,%11110000


Water:
        .db 2,5,12
        .db %10001000,%10000000
        .db %01000100,%01000000
        .db %00100010,%00100000
        .db %00010001,%00010000
        .db %10001000,%10000000
        .db %01000100,%01000000
        .db %00100010,%00100000
        .db %00010001,%00010000
        .db %10001000,%10000000
        .db %01000100,%01000000
        .db %00100010,%00100000
        .db %00010001,%00010000


Pit:
        .db 2,5,12
        .db %000011111,%10000000
        .db %00011111,%11100000
        .db %01000011,%11110000
        .db %00000001,%11100000
        .db %10011000,%11100000
        .db %00111110,%11100000
        .db %01111011,%11000000
        .db %01111001,%10010000
        .db %01111000,%01000000
        .db %11111100,%00000000
        .db %01111111,%10010000
        .db %00111111,%00000000



BoxSprite:
        .db 2,5,12
        .db %11111111,%11110000
        .db %11111111,%11110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11000000,%00110000
        .db %11111111,%11110000
        .db %11111111,%11110000


StartSprite:
        .db 2,5,12
        .db %10000110,%00000000
        .db %01001001,%00000100
        .db %00010000,%10010000
        .db %00100000,%01000000
        .db %01000000,%00100000
        .db %11111111,%11110000
        .db %00100111,%01000000
        .db %00101000,%01001000
        .db %10100110,%01000000
        .db %00100001,%01000010
        .db %00101110,%01000000
        .db %10111111,%11001000


FinSprite:
        .db 2,5,12
        .db %10000110,%00000000
        .db %01001001,%00000100
        .db %00010000,%10010000
        .db %00100000,%01000000
        .db %01000000,%00100000
        .db %11111111,%11110000
        .db %00101111,%01000000
        .db %00101000,%01001000
        .db %10101110,%01000000
        .db %00101000,%01000010
        .db %00101000,%01000000
        .db %10111111,%11001000

;----------------------------------------------------------\
;USER sprites.. stuff the player can put in the level.      |
;----------------------------------------------------------/

User1:
        .db 2,5,12
        .db %11111111,%11110000
        .db %10000011,%00010000
        .db %10000011,%00010000
        .db %10010011,%00010000
        .db %10110011,%00010000
        .db %11111111,%00010000
        .db %11111111,%00010000
        .db %10110000,%00010000
        .db %10010000,%00010000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %11111111,%11110000

User2:
        .db 2,5,12
        .db %11111111,%11110000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %11111110,%00010000
        .db %11111110,%00010000
        .db %10000110,%00010000
        .db %10000110,%00010000
        .db %10011111,%10010000
        .db %10001111,%00010000
        .db %10000110,%00010000
        .db %11111111,%11110000

User3:
        .db 2,5,12
        .db %11111111,%11110000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %10000000,%10010000
        .db %10000000,%11010000
        .db %10001111,%11110000
        .db %10001111,%11110000
        .db %10001100,%11010000
        .db %10001100,%10010000
        .db %10001100,%00010000
        .db %10001100,%00010000
        .db %11111111,%11110000

User4:
        .db 2,5,12
        .db %11111111,%11110000
        .db %10000110,%00010000
        .db %10001111,%00010000
        .db %10011111,%10010000
        .db %10000110,%00010000
        .db %10000110,%00010000
        .db %10000111,%11110000
        .db %10000111,%11110000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %10000000,%00010000
        .db %11111111,%11110000

User5:
        .db 2,5,12
        .db %11111111,%11110000
        .db %10100001,%00010000
        .db %11111101,%00010000
        .db %10001011,%11110000
        .db %10101000,%10010000
        .db %11111111,%11110000
        .db %10001000,%00010000
        .db %11111111,%11110000
        .db %10100000,%01010000
        .db %11111111,%01010000
        .db %10010000,%11110000
        .db %11111111,%11110000





TitlePic:

      .db    $3F,$3F,$3F,$3F,$3A,$4A,$BE,$3F,$30,$4A,$BF,$C0,$82,$1B,$4B,$08
      .db    $48,$0A,$48,$0A,$FC,$0A,$48,$9F,$E0,$82,$19,$4D,$08,$48,$0A,$48
      .db    $08,$E1,$0C,$48,$8F,$F0,$85,$19,$4C,$0D,$FC,$80,$FC,$08,$E0,$A0
      .db    $81,$FF,$8F,$F0,$84,$C0,$11,$FC,$13,$EC,$81,$EC,$80,$E0,$BF,$E0
      .db    $48,$8F,$F0,$88,$A0,$88,$BC,$8F,$16,$EC,$81,$EC,$81,$C1,$4A,$87
      .db    $FC,$BF,$C0,$E0,$C1,$E6,$B8,$FC,$14,$EC,$81,$EC,$83,$C3,$4C,$9F
      .db    $F1,$FE,$86,$82,$BF,$E1,$E3,$F0,$12,$E6,$81,$CC,$87,$87,$E0,$BC
      .db    $48,$8F,$F0,$B0,$98,$B8,$8E,$9F,$C0,$0F,$E6,$83,$CC,$87,$8E,$0A
      .db    $F7,$FC,$BF,$C3,$80,$E1,$E0,$B8,$48,$13,$E6,$83,$CC,$8E,$9C,$0B
      .db    $EF,$F8,$FE,$86,$81,$C3,$C0,$F1,$4A,$10,$E3,$83,$8C,$8E,$B8,$0C
      .db    $DF,$F7,$F0,$8C,$83,$87,$81,$E3,$4B,$0E,$E3,$87,$8C,$9E,$B0,$0C
      .db    $DF,$F7,$C0,$8C,$83,$87,$81,$E3,$4C,$0D,$E3,$86,$8C,$9E,$E0,$0C
      .db    $DF,$F3,$F8,$8C,$83,$87,$81,$E1,$4C,$0D,$E3,$C6,$8C,$9E,$C0,$0C
      .db    $DF,$F1,$FC,$8C,$83,$87,$81,$E0,$BF,$FC,$0B,$E1,$CE,$8C,$9E,$C0
      .db    $0B,$CF,$F8,$FF,$8C,$83,$83,$C0,$F0,$83,$FE,$0C,$E1,$CC,$8C,$9E
      .db    $12,$CF,$F8,$FF,$8C,$83,$83,$E0,$F0,$80,$FE,$0C,$E1,$CC,$8C,$9E
      .db    $11,$C7,$FC,$BF,$C7,$81,$CF,$FD,$48,$08,$FC,$0B,$E0,$EC,$8C,$9F
      .db    $11,$C7,$FC,$BF,$C3,$C7,$C0,$17,$FC,$0B,$E0,$F8,$8C,$8F,$C0,$09
      .db    $C3,$FE,$9F,$E0,$BF,$13,$C0,$83,$E0,$83,$48,$BC,$49,$9F,$C0,$81
      .db    $C1,$FF,$8F,$F6,$8F,$14,$C0,$87,$E0,$83,$C3,$CE,$B8,$F1,$FF,$80
      .db    $F0,$9F,$F1,$48,$81,$C0,$0F,$C0,$9F,$E0,$23,$4F,$81,$4A,$8F,$F8
      .db    $19,$50,$2A,$4D,$80,$4B,$87,$E0,$19,$4F,$2D,$48,$3C,$4E,$3F,$3F
      .db    $32,$C0,$C0,$82,$14,$C0,$85,$24,$D0,$19,$C2,$82,$C0,$88,$12,$C0
      .db    $85,$1E,$D1,$A0,$0A,$C0,$80,$C2,$82,$C8,$C8,$12,$C0,$85,$1E,$D0
      .db    $11,$C0,$0C,$C0,$C2,$92,$14,$C0,$85,$28,$F0,$B8,$D9,$96,$CE,$82
      .db    $CA,$D8,$E0,$BD,$E5,$C6,$A8,$8E,$9D,$B6,$98,$09,$D0,$E1,$E9,$9A
      .db    $CA,$82,$DD,$E9,$90,$87,$86,$C9,$A8,$8A,$95,$DA,$A4,$08,$C8,$A0
      .db    $A4,$C9,$A9,$81,$A4,$A5,$88,$85,$82,$A8,$D4,$89,$92,$C9,$A2,$09
      .db    $C8,$A6,$A4,$C9,$A9,$81,$A4,$A5,$98,$89,$9A,$A9,$D4,$89,$92,$C9
      .db    $A6,$09,$C8,$BA,$A4,$C9,$A9,$81,$A4,$A5,$E0,$89,$EA,$AE,$94,$89
      .db    $92,$C9,$B8,$09,$C8,$82,$A4,$C9,$A9,$81,$A4,$A5,$09,$C0,$A9,$A0
      .db    $D0,$A4,$CA,$A5,$0E,$D8,$86,$A5,$CA,$A9,$81,$A4,$A5,$88,$A0,$9A
      .db    $A8,$D4,$8B,$96,$C9,$A2,$09,$E8,$BC,$A6,$CC,$A7,$81,$A4,$A4,$F0
      .db    $BF,$F2,$A7,$94,$8D,$9A,$C9,$9C,$21,$C0,$3F,$88,$33,$C0,$3F,$98
      .db    $3F,$3A,$F0,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$30,$4D,$3F
      .db    $23,$E0,$81,$6B,$16,$F8,$11,$48,$0C,$FB,$83,$53,$9F,$48,$87,$4D
      .db    $08,$FE,$68,$9F,$FE,$8F,$FD,$49,$AF,$48,$BB,$BF,$7D,$87,$48,$BF
      .db    $ED,$49,$AD,$FF,$BE,$DF,$51,$BF,$67,$B7,$48,$BF,$DF,$48,$BD,$FF
      .db    $A2,$58,$BF,$7E,$A5,$93,$8D,$82,$CA,$CE,$FD,$9C,$F5,$CE,$B4,$CF
      .db    $F3,$CD,$93,$56,$8A,$A5,$94,$BD,$AD,$AA,$FE,$AD,$D1,$DE,$E9,$97
      .db    $F7,$DA,$A5,$58,$B5,$DB,$AD,$F6,$DA,$D5,$FD,$D7,$B6,$FD,$D6,$EF
      .db    $DF,$B5,$DB,$57,$B5,$DB,$AD,$EE,$D9,$DB,$FD,$D6,$B6,$FB,$D6,$EF
      .db    $DE,$F5,$DB,$57,$B5,$DB,$AD,$EE,$C1,$D9,$FD,$D1,$F6,$FB,$D6,$EF
      .db    $DE,$F5,$DB,$57,$B5,$DB,$AD,$DE,$48,$AB,$FB,$AF,$ED,$F7,$AD,$DF
      .db    $BD,$EB,$B7,$56,$B5,$DB,$AD,$BF,$BF,$D6,$DD,$D7,$B6,$EB,$B6,$EB
      .db    $DA,$ED,$DB,$57,$B5,$DB,$AD,$83,$C3,$CE,$DD,$D8,$F7,$9C,$F6,$EB
      .db    $E7,$9D,$DB,$7F,$7F,$4D,$00



.end




