;Plays a 1-Bit, 11kHz, Mono WAV-File over a connected earphone...
;After 256 bytes played, the stars are redrawn. Perhaps you can manage
;to play it over interrupt(each time 55 bits...)
; (C) 1996 by Andreas Ess
;-----------------------------------------------------------------------------

#INCLUDE "TI-85.H"
#INCLUDE "INTEL.H"

.org 0
.db "PLAYWAVE BK V0.1 BY AE",0

Stars = TEXT_MEM      ;90 bytes -> 30 star's x, y, z position
XPos = TEXT_MEM+90
YPos = TEXT_MEM+91
ZPos = TEXT_MEM+92
SQUOT = TEXT_MEM+93
SREM = TEXT_MEM+94

Start:
 cli
 mov  a, 4
 out  (5), a
 lea(Stars)
 mov  de, Stars
 mov  bc, 90
 ldir
 ROM_CALL(CLEARLCD)
 lea(TheSound)  ;get ready for sound
 mov  e, (hl)
 inc  hl
 mov  d, (hl)
 inc  hl
 mov  b, 128
; exx
KeyLoop:       ;let's start!
 ;**First, the sound
; exx
SoundLoop:
 mov   c, 20
DLoop:
 dec   c
 jnz   DLoop
 ror   b
 jnc   Play
 inc   hl		;next byte
 dec   e
 jz    HandleOther
Play:
 mov   a, (hl)          ;get bit
 and   b
 jz    Play1
 mov   a, 0FCh
 out   (7), a
 jmp   SoundLoop
Play1:
 mov   a, 0C0h
 out   (7), a
 jmp   SoundLoop
HandleOther:
 dec   e               ;set E to 255 and dec D
 dec   d
 jnz   Do_Stars
 lea(TheSound)
 mov   e, (hl)
 inc   hl
 mov   d, (hl)
 inc   hl
 mov   b, 128
 ;**Now, the stars
Do_Stars:
; exx
 pusha
 ROM_CALL(CLEARLCD)
 CALL_(DoStars)
 popa
 ;**Exit key pressed?
 xor  a
 out  (1), a
 in   a, (1)
 and  40h
 jnz  KeyLoop
 mov  a, 0C0h
 out  (7), a
 sti
 ret

DoStars:
 ld   b, 30
 ld   hl, Stars
DoStarLoop:
 push bc
 ;recalculate it's position
 ld   a, (hl)
 ld   (XPos), a
 inc  hl
 ld   a, (hl)
 ld   (YPos), a
 inc  hl
 ld   a, (hl)
 ld   (ZPos), a
 dec  a
 jr   nz, IncHL
 ld   a, 32
IncHL:
 ld   (hl), a
 inc  hl
 push hl
 ;Calculate 2D-XPos by saying XPos2D = 4*XPos3D/ZPos3D
 ld   de, 64
 ld   a, (XPos)
 ld   h, 0
 ld   l, a
 or   a      ;clear carry
 sbc  hl, de
 add  hl, hl
 ld   a, (ZPos)
 ld   d, 0
 ld   e, a
 CALL_(SDIV16)
 ld   de, 64
 add  hl, de
 ld   b, l          ;B now contains X-Pos
 ;Calculate 2D-YPos by saying YPos2D = 4*YPos3D/ZPos3D
 ld   de, 32
 ld   a, (YPos)
 ld   h, 0
 ld   l, a
 or   a
 sbc  hl, de
 add  hl, hl
 ld   a, (ZPos)
 ld   d, 0
 ld   e, a
 CALL_(SDIV16)
 ld   de, 32
 add  hl, de
 ld   c, l          ;C now contains X-Pos
 ;finally, show it:
 CALL_(PointOn)
 pop  hl
 pop  bc
 djnz DoStarLoop
 ret


;-----------------------------------------------------------------------------
;SDIV16: signed division, uses UDIV16
;-----------------------------------------------------------------------------
SDIV16:
 push  bc
 ld    a, h
 ld    (SREM), a
 xor   d
 ld    (SQUOT), a

 bit   7, d
 jr    z, CheckDE
 or    a
 sub   a
 sub   e
 ld    e, a
 sbc   a, a
 sub   d
 ld    d, a

CheckDE:
 bit   7, h
 jr    z, DoDiv
 or    a
 sub   a
 sub   l
 ld    l, a
 sbc   a, a
 sub   h
 ld    h, a

DoDiv:
 CALL_(UDIV16)

 ld    a, (SQUOT)
 bit   7, a
 jr    z, DoRem    ;!
 or    a
 sub   a
 sub   l
 ld    l, a
 sbc   a, a
 sub   h
 ld    h, a

DoRem:
 pop   bc
 ret

;-----------------------------------------------------------------------------
;UDIV16: divides HL trough DE
; quotient in HL
; remainder in DE
; carry = 0
;-----------------------------------------------------------------------------
UDIV16:

Divide:
 ld    c, l
 ld    a, h
 ld    hl, 0       ;hl = remainder
 ld    b, 16       ;16 bits in dividend
 or    a           ;clear carry

DivLoop:
 rl    c
 rla
 rl    l
 rl    h

 push  hl
 sbc   hl, de
 ccf

 jr    c, Drop
 ex    (sp), hl
Drop:
 inc   sp
 inc   sp
 djnz  DivLoop

 ex    de, hl
 rl    c
 ld    l, c
 rla
 ld    h, a
 or    a
 ret

;-----------------------------------------------------------------------------
;PointOn: draws point at b=x, c=y
;-----------------------------------------------------------------------------
PointOn:
 mov  a, b
 cmp  127
 ret  nc
 mov  a, c
 cmp  63
 ret  nc
 ROM_CALL(FIND_PIXEL)  ;HL=byte offset in video buffer, A=2^(bit to change)
 mov  de, VIDEO_MEM
 add  hl, de
 or   (hl)
 mov  (hl), a
 ret

;-----------------------------------------------------------------------------
;The WAV-File:
;-----------------------------------------------------------------------------
TheSound:
 .dw 2459
 .db $C0,$00,$3F,$FF,$FF,$C0,$00,$00,$7F,$FF,$FC,$00,$00,$00,$FF,$FF
 .db $FF,$FC,$00,$00,$00,$FF,$FF,$FF,$FC,$00,$00,$00,$01,$FF,$FF,$FF
 .db $FE,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$C0,$00,$00,$00,$00,$0F
 .db $FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF
 .db $F8,$00,$00,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00
 .db $00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00,$00
 .db $00,$00,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00
 .db $00,$00,$00,$00,$00,$00,$00,$05,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$D0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$F2,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $05,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$05
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$B4,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$04,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$F4,$90,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $0B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$D2,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$17,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$D2,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $40,$88,$28,$80,$04,$00,$00,$00,$00,$00,$00,$00,$00,$01,$5A,$90
 .db $89,$0F,$D0,$15,$32,$3B,$5E,$01,$C3,$E3,$64,$7E,$1B,$0D,$0C,$71
 .db $C3,$E1,$47,$CF,$80,$48,$09,$F1,$8C,$80,$2E,$17,$96,$8E,$41,$EE
 .db $78,$30,$E8,$E3,$E3,$C1,$81,$E3,$80,$F8,$F0,$6F,$4D,$45,$E0,$3F
 .db $11,$8F,$87,$CE,$07,$C1,$F3,$23,$80,$78,$F0,$79,$E0,$9E,$60,$CB
 .db $8E,$47,$94,$1D,$8C,$63,$38,$30,$E2,$16,$83,$9C,$8E,$03,$58,$E4
 .db $E1,$87,$89,$9E,$1E,$31,$70,$C0,$43,$03,$1C,$70,$38,$C0,$C3,$C1
 .db $0E,$0D,$08,$38,$00,$61,$95,$34,$04,$B2,$70,$50,$05,$87,$14,$1C
 .db $14,$30,$30,$C2,$43,$01,$04,$08,$14,$C0,$21,$45,$80,$90,$D2,$08
 .db $00,$40,$80,$09,$54,$00,$30,$10,$60,$01,$81,$04,$09,$02,$08,$00
 .db $04,$14,$12,$58,$40,$40,$03,$03,$0D,$0C,$20,$38,$00,$A0,$02,$4B
 .db $04,$10,$18,$21,$C9,$0A,$88,$16,$40,$42,$48,$05,$8B,$00,$05,$0C
 .db $34,$14,$60,$A0,$43,$03,$40,$1C,$02,$21,$28,$04,$01,$05,$64,$20
 .db $01,$05,$01,$26,$18,$34,$10,$20,$F0,$45,$82,$80,$54,$02,$81,$00
 .db $82,$03,$0A,$28,$30,$80,$A2,$10,$10,$02,$50,$11,$41,$25,$05,$21
 .db $02,$00,$80,$00,$4A,$20,$10,$40,$00,$20,$50,$90,$13,$08,$02,$08
 .db $10,$00,$20,$25,$00,$82,$94,$00,$00,$00,$10,$88,$20,$00,$90,$04
 .db $02,$00,$41,$40,$00,$00,$21,$00,$24,$A0,$04,$02,$00,$00,$28,$00
 .db $00,$10,$10,$00,$00,$10,$08,$41,$00,$80,$01,$00,$00,$10,$00,$02
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$40,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$04,$00,$00,$00,$00
 .db $48,$FE,$00,$01,$FF,$FF,$FE,$00,$00,$03,$FF,$FF,$E0,$00,$00,$07
 .db $FF,$FF,$FF,$E0,$00,$00,$0F,$FF,$FF,$FF,$E0,$00,$00,$00,$3F,$FF
 .db $FF,$FF,$F8,$00,$00,$00,$00,$7F,$FF,$FF,$FF,$F7,$06,$00,$00,$00
 .db $01,$7F,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$01,$F0,$FF,$FF,$FF
 .db $FF,$FF,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF,$F0
 .db $00,$00,$00,$00,$00,$00,$00,$1F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00
 .db $00,$00,$00,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FC,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$1F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$5F,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FD,$A0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$20,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
 .db $35,$20,$36,$1F,$A2,$6A,$E4,$76,$FE,$03,$87,$C6,$C8,$FC,$36,$18
 .db $08,$E3,$87,$C2,$0F,$9D,$04,$94,$1B,$E3,$19,$01,$DC,$27,$2D,$1C
 .db $83,$9C,$F0,$63,$D1,$C7,$C7,$A3,$03,$C7,$01,$B1,$E0,$CE,$19,$0B
 .db $C0,$CE,$23,$1F,$0D,$18,$0F,$83,$E6,$47,$00,$F0,$E0,$E3,$81,$3D
 .db $80,$9F,$18,$8E,$64,$33,$18,$CE,$78,$61,$C4,$2F,$07,$19,$9C,$06
 .db $B1,$CD,$C3,$8D,$19,$2C,$1C,$20,$F1,$98,$86,$06,$18,$F0,$71,$C1
 .db $83,$82,$1C,$0A,$10,$70,$40,$C1,$02,$29,$05,$64,$60,$A0,$06,$0A
 .db $30,$38,$18,$00,$21,$84,$86,$0A,$08,$00,$28,$80,$42,$4B,$28,$20
 .db $24,$10,$00,$A5,$00,$12,$88,$08,$20,$20,$E1,$03,$02,$40,$1C,$04
 .db $10,$00,$08,$14,$20,$90,$90,$82,$86,$16,$18,$18,$68,$20,$01,$C0
 .db $01,$06,$08,$2A,$30,$65,$84,$04,$00,$2C,$80,$80,$C0,$03,$0A,$08
 .db $08,$18,$68,$20,$C0,$90,$82,$06,$C0,$38,$04,$42,$12,$48,$12,$0A
 .db $48,$49,$00,$08,$02,$4D,$30,$20,$20,$40,$A2,$8A,$04,$00,$B0,$01
 .db $82,$A5,$04,$06,$10,$50,$21,$09,$44,$20,$00,$00,$20,$90,$C2,$4A
 .db $0A,$42,$0E,$01,$20,$00,$04,$40,$28,$80,$30,$41,$21,$04,$04,$94
 .db $04,$10,$30,$10,$40,$4A,$41,$40,$28,$04,$00,$0A,$29,$10,$08,$00
 .db $20,$00,$04,$00,$82,$82,$00,$00,$42,$01,$01,$00,$00,$04,$00,$00
 .db $00,$01,$00,$00,$11,$00,$00,$20,$10,$02,$40,$00,$00,$00,$00,$20
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$54,$1F,$80,$00,$FF,$FF,$FF,$00,$00,$00,$7F,$FF,$F8,$00
 .db $00,$01,$FF,$FF,$FF,$F8,$00,$00,$03,$FF,$FF,$FF,$F0,$00,$00,$00
 .db $03,$FF,$FF,$FF,$FE,$00,$00,$00,$00,$1F,$FF,$FF,$FF,$FF,$00,$00
 .db $00,$00,$00,$1F,$FF,$FF,$FF,$FF,$F0,$00,$00,$00,$00,$00,$1F,$FF
 .db $FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00,$00,$7F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$00,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$C0,$00,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $F0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$01,$A8,$24,$90,$F3,$01,$05,$8F,$16
 .db $28,$60,$F0,$A3,$C6,$D1,$16,$0C,$50,$72,$C2,$43,$0B,$09,$0B,$24
 .db $39,$2D,$04,$B3,$15,$08,$A8,$F0,$01,$C3,$2C,$16,$14,$88,$72,$31
 .db $23,$86,$02,$12,$4A,$29,$09,$C1,$81,$8D,$39,$BC,$B6,$A0,$49,$4E
 .db $2E,$18,$A0,$F1,$13,$86,$90,$18,$08,$30,$40,$40,$C7,$43,$08,$8C
 .db $34,$70,$F1,$46,$C3,$0F,$0C,$3C,$64,$21,$85,$8E,$3C,$1C,$70,$60
 .db $E0,$87,$06,$84,$1C,$12,$30,$48,$8A,$49,$59,$18,$28,$21,$82,$8C
 .db $0E,$04,$08,$38,$61,$21,$82,$82,$94,$06,$20,$10,$92,$CA,$08,$2D
 .db $04,$00,$29,$40,$04,$82,$02,$08,$0A,$38,$40,$C0,$92,$03,$01,$04
 .db $00,$02,$05,$08,$24,$24,$20,$A1,$80,$86,$16,$1A,$08,$00,$50,$00
 .db $41,$82,$08,$0C,$10,$61,$03,$00,$0B,$30,$2D,$30,$00,$C2,$82,$02
 .db $06,$1E,$08,$30,$04,$20,$81,$B0,$0E,$01,$10,$1E,$56,$A2,$A8,$7A
 .db $61,$ED,$90,$8F,$F0,$0F,$1F,$1B,$41,$F0,$D8,$68,$07,$8F,$5F,$40
 .db $2E,$F6,$02,$52,$3F,$8C,$32,$01,$F0,$CC,$74,$30,$0E,$73,$E1,$86
 .db $C7,$1F,$1E,$0C,$0F,$08,$8F,$C7,$C3,$BE,$78,$7F,$41,$F0,$8E,$7C
 .db $1E,$68,$3E,$07,$89,$1E,$03,$E6,$43,$8F,$00,$F3,$06,$1C,$70,$38
 .db $C0,$EE,$63,$98,$F1,$87,$38,$F4,$0E,$06,$60,$0C,$40,$11,$80,$00
 .db $60,$10,$00,$00,$00,$20,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$3F,$C0,$00,$7F,$FF,$FF,$C0,$00,$00,$7F,$FF,$FC,$00,$00
 .db $00,$FF,$FF,$FF,$F8,$00,$00,$01,$FF,$FF,$FF,$F8,$00,$00,$00,$03
 .db $FF,$FF,$FF,$9F,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$C0,$00,$00
 .db $00,$00,$4E,$7F,$FF,$FF,$FF,$EC,$00,$00,$00,$00,$00,$01,$FF,$FF
 .db $FF,$FF,$FF,$C0,$00,$00,$00,$00,$00,$02,$07,$FF,$FF,$FF,$FF,$FF
 .db $FF,$C0,$00,$00,$00,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $F0,$00,$00,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1F,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F0,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$E0
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$48,$80,$4D,$0F,$E8,$9C,$B2,$19,$9F,$20,$E5,$F1,$28
 .db $7F,$0E,$AE,$00,$74,$6D,$B0,$04,$CF,$41,$69,$64,$F9,$87,$80,$3E
 .db $19,$86,$D6,$81,$C6,$34,$18,$DC,$63,$F1,$E0,$C1,$F1,$08,$F9,$68
 .db $37,$46,$45,$E0,$3E,$10,$C7,$C3,$45,$03,$C1,$79,$83,$E0,$7C,$F8
 .db $70,$E0,$0E,$24,$61,$CC,$63,$99,$0D,$C4,$73,$1E,$38,$F5,$30,$81
 .db $C3,$E6,$05,$5C,$4C,$30,$E1,$C7,$8E,$46,$18,$58,$C3,$80,$C7,$06
 .db $1E,$18,$70,$60,$41,$C1,$43,$08,$89,$A5,$25,$B2,$86,$84,$08,$38
 .db $80,$E2,$C1,$87,$86,$12,$98,$08,$60,$00,$62,$41,$08,$2C,$00,$86
 .db $90,$C0,$06,$14,$00,$CA,$20,$01,$80,$87,$00,$08,$09,$00,$50,$50
 .db $40,$00,$20,$A0,$90,$C2,$02,$02,$1A,$58,$60,$61,$01,$C1,$05,$00
 .db $14,$18,$20,$80,$C1,$06,$10,$30,$C0,$B6,$82,$93,$00,$08,$58,$00
 .db $68,$61,$A0,$83,$04,$82,$1A,$1A,$00,$C0,$10,$08,$40,$00,$48,$2B
 .db $01,$20,$00,$29,$09,$34,$C0,$A0,$80,$06,$82,$2C,$14,$02,$80,$04
 .db $08,$00,$10,$58,$D1,$41,$44,$25,$10,$80,$80

RStars:
 ;    X   Y   Z
 .db $1,$0,$A
 .db $4,$16,$6
 .db $44,$C,$16
 .db $78,$11,$E
 .db $D,$2B,$12
 .db $5,$A,$1A
 .db $57,$30,$1A
 .db $79,$D,$D
 .db $78,$34,$1D
 .db $66,$1C,$13
 .db $54,$25,$11
 .db $5B,$7,$C
 .db $F,$2A,$F
 .db $3E,$23,$B
 .db $6E,$10,$5
 .db $35,$2B,$5
 .db $44,$28,$13
 .db $0,$31,$8
 .db $3A,$18,$C
 .db $49,$26,$8
 .db $15,$32,$9
 .db $2A,$19,$7
 .db $34,$3,$F
 .db $7C,$0,$D
 .db $8,$4,$8
 .db $7B,$16,$C
 .db $19,$C,$6
 .db $1F,$2F,$1C
 .db $72,$2E,$E
 .db $43,$2,$4

.end
