#include "ti-85.h"
;===========================================
;  DEFINES
;===========================================
#define   P_HI      %11000000        ;code to put port high
#define   P_LO      %11111100        ;code to put port low
#define   C_PORT    %00000111        ;addres of com port

current_tone	=TEXT_MEM+16      
current_length	=TEXT_MEM+8          
delay_times	=TEXT_MEM+24

.org 0
.db "Song Player v1.1 by E.L.",0


get_the_notes
	
	
	ld	hl,(PROGRAM_ADDR)	;get the strings address into hl
	ld	de,Song_string
	add	hl,de
	rst	20h
	rst	10h
	ex	de,hl
	jr	nc,songfound		;if it is found jump ahead

songnotfound
	ROM_CALL(CLEARLCD)		;if it is not 
	ld	hl, $0000		;print error string
	ld	(CURSOR_ROW),hl		;and exit the program
	ld	hl,(PROGRAM_ADDR)
	ld	de,error
	add 	hl,de
	ROM_CALL(D_ZT_STR)
exit				;kicks you out if there is no string
	call	GET_KEY
	cp	K_NOKEY
	jr	z,exit
	ret
songfound
	inc 	hl			;gets hl to proper position
	inc	hl
	
	ld	a, (hl)
	ld	(delay_times),a
	
	inc 	hl
	ld 	a, (hl)		        
	ld	b,a			;b has the number of notes
get_notes
	inc	hl			;get the tone into (current_tone)
	ld	a,(hl)			
	ld	(current_tone),a

	inc	hl
	ld	a,(hl)
	ld	(current_length),a	;get the length into (current_length)

	ld	a,(current_tone)
	cp	0
	jr	z,delayfor0
	cp	1
	jr	z,make2
	jr 	beep
gotit
	djnz 	get_notes
	ret
make2	
	inc	a
	ld	(current_tone),a
beep
	di
	push	bc
set_low
   	ld  	b,P_LO         
   	ld  	c,C_PORT      
   	out  	(c),b          
delay
	ld	a,(delay_times)
	ld	c,a
delay1
	ld	a,(current_tone)
	ld	b,a
delay2
   	dec  	b
   	
	xor	a
        out 	(1),a       
        in 	a,(1)       
        bit	6,a         
        jr	z,exit2   
	
	djnz 	delay2
	dec	c
	ld	a,c
	cp	0
	jr	nz,delay1

set_high
   	ld  	b,P_HI         
   	ld  	c,C_PORT       
   	out 	(c),b          

delayagain
	ld	a,(delay_times)
	ld	c,a
delay3
	ld	a,(current_tone)
	ld	b,a
Delay4
   	dec  	b
   	
	xor	a
        out 	(1),a       
        in 	a,(1)       
        bit	6,a         
        jr	z,exit2   
	
	djnz 	delay4
	dec	c
	ld	a,c
	cp	0
	jr	nz,delay3
	
	ld	a,(current_length)
   	dec	a
	ld	(current_length),a
   	cp	0
   	jr      nz,set_low
	
	ei
	pop	bc
	jr	gotit
	
exit2
	ei
	pop	bc
	ret


delayfor0
	push	bc
	ld	a,(current_length)
	ld	b,a
delayfor01
	ld	de,2000
delayfor02
   	dec  	de
   	
	xor	a
        out 	(1),a       
        in 	a,(1)       
        bit	6,a         
        jr	z,exit3  
	
	ld	a,d
	cp	0
	jr	nz,delayfor02
	djnz	delayfor01
	pop	bc
	jr	gotit
exit3
	pop	bc
	ret

error    .db "Can",$27,"t find SONG strng",0

Song_String	.db	$0C, 4, "SONG"

.end
