;       Globe Animation   for ZShell            (by Risto Jrvinen)
;       ---------------
;
;   Animates a rotating Earth.  Totally useless...  And ugly!  The aspect
; ratio is a bit wrong => It makes Earth look like a ball!  I found the
; pictures on a picture collection CD and didn't bother to fix them.
;   However in case your friends have CASIO's (ugh!) calculators (or
; something equally disgusting) you can use this program to make your
; friends jealous ;)  NOTE: Do NOT show it to your friend if he has HP's
; calculator!  I've seen over 20+ megs of HP-anims floating around in
; BBS's and the Net...
;   Speed of rotation can be controlled with Up/Down.
;   The code is handmade for these frames.  Frame resolution is 64*64 pixels.
; All optimizations are encouraged!  Especially some kind of compression
; would help a lot.  Taking 0.5kb per half-screen frame is unhealthy on a
; 28kb memory limit.  I've used Stephane Jantzen's ZCP but it only packs
; 128x63 pictures :(
;   Also these routines could be used as a grayscale picture viewer.
; Changing frames fast leaves an 'after-image' that can be used to create
; different shades.  A good example of this can be seen by making the globe
; rotate VERY fast.
;   And last but not least: It's RibaWare; no copyright, 100% public domain.
; All rights wronged, all wrongs reversed.  Learn'n'Copy!
;
;   I, Risto Jrvinen, don't have my own email address so if you wish to
; contact me please use my friends address:
;
;       Jarno_Uurainen@llauta.fipnet.fi
;
;         +------------------------------+
;   NOTE: | DO NOT SEND ANY BIG FILES!!! |
;         +------------------------------+
;   One idiot sent to my friend a 2meg .WAV!  He receives his email via
; a BBS so sending mega-email causes messagepolling to take forever and
; sysop to go nuts.  If mega-stuff pops up place it on FTP and I'll leech
; it someday...  I don't think that You're an idiot (after all you propably
; have TI's calculator).  This is just a precaution :)
;

;  Include Files
#INCLUDE "TI-85.H"      ; Include Extended ZShell Header

;  Constants
VidStart        = VIDEO_MEM+4   ; Set globe to center of screen
SizeOfPic       = 512           ; Size of each frame in bytes

;  Temporary Variables
; Location $80DF-$8187 is reserved by ZShell for temporary variables
Speed   = $80df         ; Used to save current speed
Count   = $80e0         ; Used as a delay counter
NoPic   = $80e1         ; Number of frame


.org    0
.db     "Globe Animation  1.0",0

   ROM_CALL(CLEARLCD)
   ld   a,$7f
   ld   (speed),a

KeyLoop:
   call GET_KEY                 ;Get pressed key
   cp   K_EXIT                  ;if EXIT pressed...
   ret  z                       ;...then return to ZShell
   cp   K_UP                    ;If + pressed...
   jr   z,Increase              ;...then slow down
   cp   K_DOWN                  ;If - pressed...
   jr   z,Decrease              ;...then speed up

   ld   a,(Count)
   cp   $0
   jr   z,Process
   dec  a
   ld   (Count),a
   CALL_(Wait)
   jr   KeyLoop

Increase:
   ld   a,(speed)
   cp   $ff
   jr   z,KeyLoop
   inc  a
   ld   (speed),a
   jr   KeyLoop
Decrease:
   ld   a,(speed)
   cp   $1
   jr   z,KeyLoop
   dec  a
   ld   (speed),a
   jr   KeyLoop

Process:
   ld   a,(speed)
   ld   (count),a

   ld   a,(NoPic)
   inc  a
   cp   15
   jr   nz,NReset
   ld   a,0
NReset:
   ld   (NoPic),a
   ld   hl,(PROGRAM_ADDR)
   ld   de,Pic00
   add  hl,de
   ld   de,SizeOfPic
PicAdd:
   cp   0
   jr   z,draw
   dec  a
   add  hl,de
   jr   PicAdd

Draw:
   ld   de,VidStart

   ld   a,64
Horz:
   ld   bc,8
   ldir
   inc  de
   inc  de
   inc  de
   inc  de
   inc  de
   inc  de
   inc  de
   inc  de
   dec  a
   jr   nz,Horz
   jr   KeyLoop

Wait:
   ld   a,(Speed)
WaitLoop:
   cp   $0
   ret  z
   dec  a
   jr   WaitLoop


Pic00:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$DF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$FF,$FF,$80,$00
.db $00,$07,$FF,$FF,$FF,$FF,$C0,$00
.db $00,$0F,$FF,$FF,$FF,$FF,$F0,$00
.db $00,$1F,$FF,$FF,$FF,$FF,$F8,$00
.db $00,$7F,$FF,$FF,$FF,$FF,$FC,$00
.db $00,$FF,$FF,$FF,$FF,$FF,$FE,$00
.db $01,$FF,$FF,$FF,$FF,$FF,$FF,$00
.db $01,$FF,$FF,$FF,$FF,$FF,$FB,$80
.db $03,$FF,$FF,$FF,$FF,$FF,$FF,$C0
.db $07,$EF,$FF,$FF,$FF,$FF,$FF,$40
.db $0F,$F1,$FF,$FF,$FF,$FF,$FB,$A0
.db $0F,$FF,$FF,$FF,$FF,$FF,$FB,$60
.db $1F,$FF,$FF,$FF,$FF,$FF,$FD,$10
.db $1F,$FF,$FF,$FF,$FF,$FF,$F9,$38
.db $3F,$FF,$FF,$FF,$FF,$FF,$FE,$28
.db $3F,$FF,$FF,$C7,$FF,$FF,$FC,$08
.db $7F,$FF,$FF,$C3,$FF,$FF,$E0,$04
.db $7F,$FE,$FF,$81,$FF,$3F,$E2,$0C
.db $7F,$FF,$FF,$00,$FC,$1F,$C3,$0E
.db $7F,$FF,$FC,$00,$F8,$1F,$E3,$06
.db $FF,$FF,$F2,$00,$F8,$27,$E3,$86
.db $FF,$FF,$BE,$00,$70,$27,$E3,$82
.db $FF,$FF,$F8,$00,$78,$26,$C3,$CB
.db $FF,$FF,$F8,$00,$38,$06,$83,$D3
.db $FF,$FF,$F0,$00,$18,$1B,$87,$D1
.db $FF,$FF,$F0,$00,$80,$0F,$AF,$11
.db $9F,$FF,$E0,$00,$00,$0F,$9E,$71
.db $BF,$FF,$C0,$00,$00,$07,$BF,$E1
.db $9F,$FF,$80,$00,$00,$07,$FF,$F9
.db $9F,$FF,$00,$00,$00,$01,$FF,$FF
.db $9F,$FE,$02,$00,$00,$01,$C5,$FF
.db $8F,$FE,$00,$01,$00,$01,$F9,$BF
.db $8F,$FE,$00,$00,$00,$00,$7F,$EF
.db $8F,$FF,$00,$00,$00,$00,$43,$C7
.db $87,$FF,$18,$00,$00,$00,$00,$3E
.db $87,$FF,$18,$00,$00,$00,$00,$FE
.db $47,$FF,$78,$00,$00,$00,$01,$FE
.db $47,$FF,$78,$00,$00,$00,$01,$FE
.db $47,$FE,$78,$00,$00,$00,$07,$FC
.db $63,$FE,$79,$80,$00,$00,$1F,$FC
.db $23,$FE,$70,$00,$00,$00,$1F,$FC
.db $21,$FE,$30,$00,$00,$00,$3F,$F8
.db $11,$FC,$00,$00,$00,$00,$3F,$F8
.db $18,$FE,$00,$00,$00,$00,$3F,$F0
.db $08,$7C,$00,$00,$00,$00,$3F,$F0
.db $0C,$3C,$00,$00,$00,$00,$7F,$E0
.db $06,$38,$00,$00,$00,$00,$73,$C0
.db $02,$00,$00,$00,$40,$00,$01,$C0
.db $01,$00,$00,$00,$40,$00,$03,$80
.db $01,$80,$00,$00,$00,$00,$07,$00
.db $00,$C0,$00,$00,$00,$00,$06,$00
.db $00,$60,$10,$80,$00,$00,$0C,$00
.db $00,$18,$00,$03,$00,$00,$18,$00
.db $00,$0C,$00,$00,$80,$00,$30,$00
.db $00,$06,$00,$00,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$18,$FF,$FF,$F8,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic01:
.db $00,$00,$00,$6F,$FE,$00,$00,$00
.db $00,$00,$07,$BD,$FF,$C0,$00,$00
.db $00,$00,$1D,$FF,$FF,$F8,$00,$00
.db $00,$00,$F7,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$FF,$FF,$80,$00
.db $00,$06,$EF,$FF,$FF,$FF,$C0,$00
.db $00,$0D,$FF,$FF,$FF,$FF,$F0,$00
.db $00,$19,$FF,$FF,$FF,$FF,$F8,$00
.db $00,$63,$FF,$FF,$FF,$FF,$FC,$00
.db $00,$CF,$FF,$FF,$FF,$FF,$FE,$00
.db $01,$9F,$FF,$FF,$FF,$FF,$FF,$00
.db $01,$3E,$BF,$FF,$FF,$FF,$FF,$80
.db $03,$3F,$EF,$FF,$FF,$FF,$FF,$C0
.db $06,$3F,$C7,$FF,$FF,$FF,$FF,$C0
.db $0D,$7F,$DC,$7F,$FF,$FF,$FF,$E0
.db $08,$FF,$FF,$FF,$FF,$FF,$FF,$E0
.db $1B,$FF,$FF,$FF,$FF,$FF,$FF,$F0
.db $13,$FF,$FF,$FF,$FF,$FF,$FF,$F8
.db $27,$FF,$FF,$FF,$FF,$FF,$FF,$F8
.db $27,$FF,$FF,$FF,$FC,$7F,$FF,$F8
.db $6F,$FF,$FF,$FF,$FC,$3F,$FF,$E4
.db $4F,$FF,$FF,$EF,$F8,$0F,$EF,$EC
.db $6F,$FF,$FF,$FF,$F8,$0F,$C7,$EE
.db $7F,$FF,$FF,$FF,$C0,$0F,$87,$EE
.db $9F,$FF,$FF,$FF,$20,$07,$85,$E6
.db $9F,$FF,$FF,$FF,$F0,$07,$85,$F6
.db $9F,$FF,$FF,$FF,$C0,$03,$85,$E7
.db $8F,$FF,$FF,$FF,$80,$03,$C1,$A7
.db $8F,$FF,$FF,$FF,$80,$00,$C3,$CF
.db $87,$3F,$FF,$FF,$00,$04,$01,$DD
.db $80,$1F,$FF,$FF,$00,$00,$01,$FF
.db $80,$3F,$FF,$FE,$00,$00,$01,$FF
.db $80,$1F,$FF,$FC,$00,$00,$00,$FF
.db $80,$1F,$FF,$F8,$00,$00,$00,$7F
.db $80,$0F,$FF,$F0,$10,$00,$00,$6F
.db $80,$07,$FF,$F0,$00,$08,$00,$7F
.db $90,$07,$FF,$F0,$00,$00,$00,$3F
.db $80,$07,$FF,$F0,$00,$00,$00,$27
.db $80,$03,$FF,$F1,$80,$00,$00,$02
.db $80,$07,$FF,$F1,$80,$00,$00,$06
.db $41,$07,$FF,$FB,$80,$00,$00,$06
.db $40,$07,$FF,$F7,$80,$00,$00,$0E
.db $40,$03,$FF,$C7,$80,$00,$00,$0C
.db $60,$03,$FF,$C7,$18,$00,$00,$3C
.db $20,$01,$FF,$C7,$00,$00,$00,$3C
.db $20,$01,$FF,$C7,$00,$00,$00,$78
.db $10,$00,$FF,$80,$00,$00,$00,$78
.db $18,$00,$FF,$80,$00,$00,$00,$70
.db $08,$00,$7F,$00,$00,$00,$00,$F0
.db $0C,$00,$3F,$00,$00,$00,$01,$E0
.db $06,$00,$3C,$00,$00,$00,$01,$C0
.db $02,$40,$00,$00,$00,$08,$00,$C0
.db $01,$10,$00,$00,$00,$10,$01,$80
.db $01,$80,$00,$00,$00,$00,$03,$00
.db $00,$C0,$00,$00,$00,$00,$06,$00
.db $00,$60,$00,$08,$80,$00,$0C,$00
.db $00,$18,$00,$00,$03,$00,$18,$00
.db $00,$0C,$00,$00,$01,$00,$30,$00
.db $00,$06,$20,$00,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$18,$07,$F7,$F8,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic02:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$E3,$DF,$C0,$00,$00
.db $00,$00,$1F,$07,$FF,$F8,$00,$00
.db $00,$00,$F7,$BF,$FF,$FE,$00,$00
.db $00,$01,$C1,$FF,$FF,$FF,$80,$00
.db $00,$06,$07,$9F,$FF,$FF,$C0,$00
.db $00,$0C,$0F,$FF,$FF,$FF,$F0,$00
.db $00,$18,$07,$FF,$FF,$FF,$F8,$00
.db $00,$70,$07,$FF,$FF,$FF,$FC,$00
.db $00,$C0,$1F,$FF,$FF,$FF,$FE,$00
.db $01,$80,$3F,$FF,$FF,$FF,$FF,$00
.db $01,$18,$3F,$5F,$FF,$FF,$FF,$80
.db $02,$08,$3F,$FB,$FF,$FF,$FF,$C0
.db $06,$00,$3F,$F1,$FF,$FF,$FF,$C0
.db $0C,$02,$7F,$F3,$0F,$FF,$FF,$E0
.db $08,$00,$FF,$FF,$FF,$FF,$FF,$E0
.db $18,$07,$FF,$FF,$FF,$FF,$FF,$F0
.db $10,$07,$FF,$FF,$FF,$FF,$FF,$F8
.db $20,$07,$FF,$FF,$FF,$FF,$FF,$F8
.db $20,$0F,$FF,$FF,$FF,$FF,$9F,$FC
.db $60,$0F,$FF,$FF,$FF,$FF,$8F,$FC
.db $40,$0F,$FF,$FF,$FE,$FF,$83,$FC
.db $40,$8F,$FF,$FF,$FF,$FF,$03,$CE
.db $40,$5F,$FF,$FF,$FF,$FE,$03,$CE
.db $C0,$1F,$FF,$FF,$FF,$F9,$01,$CE
.db $80,$1F,$FF,$FF,$FF,$FF,$01,$CE
.db $80,$0F,$FF,$FF,$FF,$FC,$00,$EF
.db $80,$0F,$FF,$FF,$FF,$FC,$00,$E7
.db $80,$07,$FF,$FF,$FF,$FC,$00,$67
.db $C0,$03,$E7,$FF,$FF,$F8,$01,$07
.db $C0,$00,$01,$FF,$FF,$F8,$00,$07
.db $C0,$00,$03,$FF,$FF,$E0,$00,$03
.db $E0,$00,$01,$FF,$FF,$C0,$00,$03
.db $F0,$00,$01,$FF,$FF,$80,$00,$03
.db $F8,$00,$00,$FF,$FF,$80,$80,$03
.db $F8,$00,$00,$7F,$FF,$80,$02,$03
.db $F8,$08,$00,$7F,$FF,$00,$00,$03
.db $F8,$00,$00,$7F,$FF,$80,$00,$03
.db $F8,$00,$00,$3F,$FF,$8C,$00,$02
.db $F8,$00,$00,$7F,$FF,$9C,$00,$02
.db $78,$00,$80,$7F,$FF,$BC,$00,$02
.db $78,$00,$00,$7F,$FF,$78,$00,$06
.db $78,$00,$00,$7F,$FE,$78,$00,$04
.db $79,$00,$00,$3F,$FC,$79,$80,$04
.db $3C,$00,$00,$3F,$FC,$70,$00,$0C
.db $38,$00,$00,$1F,$FC,$70,$00,$08
.db $18,$00,$00,$1F,$F0,$00,$00,$18
.db $1C,$00,$00,$1F,$F0,$00,$00,$10
.db $0C,$00,$00,$0F,$E0,$00,$00,$30
.db $0E,$00,$00,$07,$C0,$00,$00,$20
.db $06,$00,$00,$07,$00,$00,$00,$40
.db $03,$00,$80,$00,$00,$00,$10,$C0
.db $01,$00,$20,$00,$00,$00,$11,$80
.db $01,$80,$00,$00,$00,$00,$03,$00
.db $00,$C0,$00,$00,$00,$00,$06,$00
.db $00,$60,$00,$00,$08,$40,$0C,$00
.db $00,$18,$00,$00,$00,$02,$18,$00
.db $00,$0D,$00,$00,$00,$02,$30,$00
.db $00,$07,$A0,$40,$00,$00,$C0,$00
.db $00,$01,$F0,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$18,$00,$7F,$F8,$00,$00
.db $00,$00,$07,$7F,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic03:
.db $00,$00,$00,$7F,$F6,$00,$00,$00
.db $00,$00,$07,$FE,$3F,$C0,$00,$00
.db $00,$00,$1F,$F8,$3F,$F8,$00,$00
.db $00,$00,$FF,$3A,$FF,$FE,$00,$00
.db $00,$01,$CC,$07,$FF,$FF,$80,$00
.db $00,$07,$80,$0F,$7F,$FF,$C0,$00
.db $00,$0F,$80,$0F,$FF,$FF,$F0,$00
.db $00,$1F,$00,$07,$FF,$FF,$F8,$00
.db $00,$7E,$00,$03,$FF,$FF,$FC,$00
.db $00,$F8,$00,$0F,$FF,$FF,$FE,$00
.db $01,$C0,$00,$0F,$FF,$FF,$FF,$00
.db $01,$80,$18,$1F,$F7,$FF,$FF,$80
.db $03,$00,$0C,$0F,$FE,$FF,$FF,$C0
.db $06,$00,$00,$0F,$FA,$7F,$FF,$C0
.db $0D,$00,$00,$9F,$FE,$E3,$FF,$E0
.db $0C,$00,$00,$1F,$FF,$FF,$FF,$E0
.db $18,$00,$01,$FF,$FF,$FF,$FF,$F0
.db $18,$00,$00,$FF,$FF,$FF,$FF,$F8
.db $30,$00,$00,$FF,$FF,$FF,$FF,$F8
.db $30,$00,$01,$FF,$FF,$FF,$FF,$FC
.db $70,$00,$01,$FF,$FF,$FF,$FF,$DC
.db $78,$00,$01,$FF,$FF,$FF,$FF,$CC
.db $78,$00,$21,$FF,$FF,$FF,$FF,$8E
.db $48,$00,$13,$FF,$FF,$FF,$FF,$06
.db $CC,$00,$03,$FF,$FF,$FF,$FE,$86
.db $E8,$00,$03,$FF,$FF,$FF,$FF,$C6
.db $F8,$00,$01,$FF,$FF,$FF,$FF,$83
.db $F8,$00,$00,$FF,$FF,$FF,$FF,$03
.db $FE,$00,$00,$7F,$FF,$FF,$FF,$03
.db $FF,$00,$00,$3F,$3F,$FF,$FF,$03
.db $FF,$00,$00,$00,$0F,$FF,$FE,$01
.db $FF,$00,$00,$00,$1F,$FF,$FE,$01
.db $FF,$C0,$00,$00,$0F,$FF,$FC,$01
.db $FF,$F0,$00,$00,$0F,$FF,$F8,$01
.db $FF,$FC,$00,$00,$07,$FF,$F8,$41
.db $FF,$FC,$00,$00,$03,$FF,$F0,$05
.db $FF,$FC,$00,$80,$03,$FF,$F0,$01
.db $FF,$FC,$00,$00,$03,$FF,$F8,$03
.db $FF,$FC,$00,$00,$03,$FF,$F1,$02
.db $FF,$F8,$00,$00,$03,$FF,$F3,$02
.db $7F,$F8,$00,$08,$07,$FF,$F7,$02
.db $7F,$F8,$00,$00,$07,$FF,$FF,$06
.db $5F,$F8,$00,$00,$07,$FF,$CE,$84
.db $7F,$F8,$40,$00,$03,$FF,$9E,$84
.db $2F,$F8,$00,$00,$03,$FF,$9C,$0C
.db $2F,$E0,$00,$00,$03,$FF,$9C,$08
.db $1F,$E0,$00,$00,$03,$FF,$00,$18
.db $1F,$E0,$00,$00,$01,$FE,$00,$10
.db $0F,$E0,$00,$00,$01,$FC,$00,$30
.db $0F,$E0,$00,$00,$01,$F8,$00,$20
.db $07,$E0,$00,$00,$01,$E0,$00,$40
.db $03,$E0,$00,$20,$00,$00,$00,$C0
.db $01,$E0,$00,$10,$00,$00,$01,$80
.db $01,$E0,$00,$00,$00,$00,$03,$00
.db $00,$F0,$00,$00,$00,$00,$06,$00
.db $00,$78,$00,$00,$00,$08,$8C,$00
.db $00,$1C,$00,$00,$00,$00,$38,$00
.db $00,$0F,$08,$00,$00,$00,$70,$00
.db $00,$07,$0D,$00,$80,$00,$C0,$00
.db $00,$01,$8C,$80,$00,$01,$80,$00
.db $00,$00,$F8,$00,$00,$06,$00,$00
.db $00,$00,$1C,$00,$07,$F8,$00,$00
.db $00,$00,$07,$8F,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic04:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$FF,$A3,$C0,$00,$00
.db $00,$00,$1F,$FF,$C3,$F8,$00,$00
.db $00,$00,$FE,$79,$DB,$FE,$00,$00
.db $00,$01,$FC,$60,$0F,$FF,$80,$00
.db $00,$07,$FC,$00,$0E,$FF,$C0,$00
.db $00,$0F,$FC,$00,$0F,$FF,$F0,$00
.db $00,$1F,$FC,$00,$03,$FF,$F8,$00
.db $00,$7F,$FC,$00,$03,$FF,$FC,$00
.db $00,$FF,$E0,$00,$07,$FF,$FE,$00
.db $01,$FE,$00,$00,$07,$FF,$FF,$00
.db $01,$FC,$00,$0E,$07,$FF,$FF,$80
.db $03,$F8,$00,$03,$03,$FF,$7F,$C0
.db $07,$F0,$00,$00,$01,$FF,$3F,$C0
.db $0F,$E2,$00,$00,$23,$FF,$B3,$E0
.db $0F,$80,$00,$00,$03,$FF,$FF,$E0
.db $1F,$80,$00,$00,$3F,$FF,$FF,$F0
.db $19,$C0,$00,$00,$1F,$FF,$FF,$F8
.db $39,$C0,$00,$00,$1F,$FF,$FF,$F8
.db $33,$C0,$00,$00,$1F,$FF,$FF,$F8
.db $7F,$E0,$00,$00,$1F,$FF,$FF,$FC
.db $7D,$F8,$00,$00,$1F,$FF,$FF,$FC
.db $79,$FC,$00,$01,$1F,$FF,$FF,$FE
.db $7C,$04,$00,$01,$9F,$FF,$FF,$FE
.db $9C,$04,$00,$00,$1F,$FF,$FF,$FE
.db $89,$EC,$00,$00,$1F,$FF,$FF,$FE
.db $8F,$F8,$00,$00,$0F,$FF,$FF,$FF
.db $8F,$FC,$00,$00,$07,$FF,$FF,$FD
.db $93,$FF,$80,$00,$03,$FF,$FF,$FD
.db $8B,$FF,$C0,$00,$01,$F9,$FF,$FD
.db $87,$FF,$C0,$00,$00,$00,$FF,$FD
.db $A7,$FF,$C0,$00,$00,$01,$7F,$FD
.db $A7,$FF,$F8,$00,$00,$00,$FF,$FD
.db $87,$FF,$FF,$00,$00,$00,$7F,$F9
.db $87,$FF,$FF,$C0,$00,$00,$7F,$FB
.db $87,$FF,$FF,$C0,$00,$00,$3F,$F9
.db $87,$FF,$FF,$E0,$08,$00,$3F,$F1
.db $83,$FF,$FF,$C0,$00,$00,$3F,$F3
.db $83,$FF,$FF,$C0,$00,$00,$3F,$F6
.db $81,$FF,$FF,$80,$00,$00,$7F,$FE
.db $41,$FF,$FF,$80,$00,$40,$7F,$FE
.db $40,$FF,$FF,$00,$00,$00,$7F,$FE
.db $40,$7F,$FF,$00,$00,$00,$7F,$FC
.db $60,$3F,$FF,$04,$00,$00,$7F,$FC
.db $20,$3F,$FF,$00,$00,$00,$7F,$FC
.db $20,$3F,$FC,$00,$00,$00,$7F,$B8
.db $10,$BF,$F8,$00,$00,$00,$7F,$18
.db $18,$1F,$F8,$00,$00,$00,$7F,$10
.db $08,$1F,$F0,$00,$00,$00,$7E,$30
.db $0C,$7F,$F0,$00,$00,$00,$7C,$20
.db $06,$0F,$E0,$00,$00,$00,$70,$40
.db $02,$0F,$E0,$00,$08,$00,$00,$C0
.db $01,$0F,$C0,$00,$04,$00,$01,$80
.db $01,$87,$80,$00,$00,$00,$03,$00
.db $00,$C3,$80,$00,$00,$00,$06,$00
.db $00,$63,$C0,$00,$00,$00,$2C,$00
.db $00,$19,$C0,$00,$00,$00,$18,$00
.db $00,$0C,$F8,$10,$00,$00,$30,$00
.db $00,$06,$30,$1A,$00,$80,$C0,$00
.db $00,$01,$80,$21,$00,$01,$80,$00
.db $00,$00,$E1,$A0,$00,$06,$00,$00
.db $00,$00,$1D,$80,$00,$78,$00,$00
.db $00,$00,$07,$E1,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic05:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$FB,$FB,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$78,$00,$00
.db $00,$00,$FF,$F9,$C7,$5E,$00,$00
.db $00,$01,$F9,$F0,$80,$3F,$80,$00
.db $00,$07,$FF,$F8,$00,$3F,$C0,$00
.db $00,$0F,$FF,$FC,$00,$1F,$F0,$00
.db $00,$1F,$FF,$FE,$00,$07,$F8,$00
.db $00,$7F,$FF,$FE,$00,$03,$FC,$00
.db $00,$FF,$FF,$F0,$00,$03,$FE,$00
.db $01,$FF,$FF,$00,$00,$03,$FF,$00
.db $01,$FF,$FC,$00,$03,$83,$FF,$80
.db $03,$FF,$F8,$00,$00,$C1,$FF,$C0
.db $07,$FF,$F0,$00,$00,$00,$FE,$C0
.db $0F,$FF,$E0,$80,$00,$04,$FF,$E0
.db $0B,$FF,$80,$00,$00,$00,$FF,$E0
.db $1B,$FD,$80,$00,$00,$07,$FF,$F0
.db $17,$E1,$C0,$00,$00,$03,$FF,$F8
.db $27,$E1,$E0,$00,$00,$01,$FF,$F8
.db $27,$C3,$F0,$00,$00,$03,$FF,$FC
.db $63,$DF,$F8,$00,$00,$03,$FF,$FC
.db $43,$F8,$FF,$80,$00,$01,$FF,$FC
.db $41,$F8,$F7,$80,$00,$11,$FF,$FE
.db $40,$FE,$00,$C0,$00,$09,$FF,$FE
.db $80,$3E,$00,$C0,$00,$01,$FF,$FE
.db $80,$0C,$7C,$C0,$00,$01,$FF,$FE
.db $80,$0F,$FF,$80,$00,$00,$FF,$FF
.db $80,$07,$FF,$E0,$00,$00,$7F,$FF
.db $80,$10,$FF,$FC,$00,$00,$3F,$FF
.db $80,$02,$FF,$FE,$00,$00,$1F,$7F
.db $80,$01,$FF,$FE,$00,$00,$00,$3F
.db $80,$43,$FF,$FE,$00,$00,$00,$7F
.db $80,$63,$FF,$FF,$C0,$00,$00,$3F
.db $80,$03,$FF,$FF,$F8,$00,$00,$3F
.db $80,$03,$FF,$FF,$FE,$00,$00,$3F
.db $80,$03,$FF,$FF,$FE,$00,$00,$1F
.db $80,$01,$FF,$FF,$FE,$00,$40,$1F
.db $80,$01,$FF,$FF,$FE,$00,$00,$1F
.db $80,$00,$FF,$FF,$FC,$00,$00,$1E
.db $80,$00,$7F,$FF,$F8,$00,$00,$3E
.db $40,$00,$7F,$FF,$F8,$00,$08,$3E
.db $40,$00,$3F,$FF,$F8,$00,$00,$7E
.db $40,$00,$0F,$FF,$F0,$00,$00,$7C
.db $60,$00,$0F,$FF,$F0,$40,$00,$7C
.db $20,$00,$0F,$FF,$F0,$00,$00,$7C
.db $30,$00,$0F,$FF,$80,$00,$00,$78
.db $13,$00,$8F,$FF,$00,$00,$00,$F8
.db $18,$00,$0F,$FF,$00,$00,$00,$F0
.db $08,$00,$0F,$FE,$00,$00,$00,$F0
.db $0C,$00,$67,$FE,$00,$00,$01,$E0
.db $06,$00,$07,$FC,$00,$00,$01,$C0
.db $02,$00,$0F,$F8,$00,$02,$00,$C0
.db $01,$00,$07,$F0,$00,$02,$01,$80
.db $01,$80,$07,$C0,$00,$00,$03,$00
.db $00,$C0,$07,$C0,$00,$00,$06,$00
.db $00,$60,$07,$C0,$00,$00,$0C,$00
.db $00,$18,$03,$C0,$00,$00,$18,$00
.db $00,$0C,$03,$D8,$20,$00,$30,$00
.db $00,$06,$01,$E0,$34,$02,$C0,$00
.db $00,$01,$80,$01,$84,$01,$80,$00
.db $00,$00,$E0,$0E,$80,$06,$00,$00
.db $00,$00,$18,$9C,$00,$38,$00,$00
.db $00,$00,$07,$FE,$3F,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic06:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$DF,$78,$00,$00
.db $00,$00,$FF,$FF,$CF,$7E,$00,$00
.db $00,$01,$FF,$E3,$E3,$03,$80,$00
.db $00,$07,$FF,$FF,$F8,$01,$C0,$00
.db $00,$0D,$FF,$FF,$FC,$00,$F0,$00
.db $00,$19,$FF,$FF,$FE,$00,$38,$00
.db $00,$63,$FF,$FF,$FE,$00,$1C,$00
.db $00,$C7,$FF,$FF,$F8,$00,$0E,$00
.db $01,$8F,$FF,$FF,$80,$00,$0F,$00
.db $01,$0F,$FF,$FF,$00,$01,$C7,$80
.db $02,$0F,$FF,$FE,$00,$00,$E7,$C0
.db $06,$0F,$FF,$FE,$00,$00,$01,$C0
.db $0C,$0F,$FF,$FC,$20,$00,$05,$E0
.db $08,$0F,$FF,$F0,$00,$00,$01,$E0
.db $18,$0F,$FF,$70,$00,$00,$03,$F0
.db $10,$0F,$F0,$3C,$00,$00,$01,$F8
.db $20,$07,$F0,$1E,$00,$00,$01,$F8
.db $20,$07,$F0,$7F,$00,$00,$01,$F8
.db $60,$01,$F3,$FF,$00,$00,$01,$FC
.db $60,$01,$FF,$0F,$F8,$00,$00,$FC
.db $40,$00,$FF,$0D,$7C,$00,$04,$FE
.db $40,$00,$3F,$C0,$04,$00,$02,$FE
.db $80,$00,$07,$C0,$06,$00,$00,$7E
.db $80,$00,$01,$C3,$C4,$00,$00,$7E
.db $80,$00,$00,$FF,$FC,$00,$00,$3F
.db $80,$00,$00,$7F,$FE,$00,$00,$3F
.db $80,$00,$01,$0F,$FF,$C0,$00,$1F
.db $80,$00,$00,$2F,$FF,$F0,$00,$1F
.db $80,$00,$00,$0F,$FF,$F0,$00,$01
.db $80,$00,$04,$1F,$FF,$F0,$00,$03
.db $80,$00,$06,$1F,$FF,$FE,$00,$01
.db $80,$00,$00,$1F,$FF,$FF,$80,$01
.db $80,$00,$00,$3F,$FF,$FF,$E0,$01
.db $80,$00,$00,$3F,$FF,$FF,$E0,$01
.db $A0,$00,$00,$1F,$FF,$FF,$E0,$21
.db $E0,$00,$00,$0F,$FF,$FF,$E0,$03
.db $C0,$00,$00,$0F,$FF,$FF,$C0,$02
.db $80,$00,$00,$07,$FF,$FF,$C0,$02
.db $60,$00,$00,$07,$FF,$FF,$80,$12
.db $60,$00,$00,$01,$FF,$FF,$80,$06
.db $40,$00,$00,$00,$FF,$FF,$00,$04
.db $60,$00,$00,$00,$FF,$FF,$10,$04
.db $34,$00,$00,$00,$FF,$FE,$00,$0C
.db $21,$00,$00,$00,$FF,$F8,$00,$08
.db $18,$02,$80,$08,$FF,$F0,$00,$18
.db $18,$00,$00,$01,$FF,$E0,$00,$10
.db $08,$00,$00,$01,$FF,$C0,$00,$30
.db $0C,$00,$00,$19,$FF,$80,$00,$20
.db $06,$00,$00,$01,$FF,$00,$00,$40
.db $02,$00,$00,$01,$FE,$00,$04,$C0
.db $01,$00,$00,$01,$FC,$00,$05,$80
.db $01,$80,$00,$01,$F0,$00,$03,$00
.db $00,$C0,$00,$03,$E0,$00,$06,$00
.db $00,$60,$00,$03,$C0,$00,$0C,$00
.db $00,$18,$00,$03,$C0,$00,$18,$00
.db $00,$0C,$00,$03,$D8,$20,$30,$00
.db $00,$06,$00,$01,$C0,$30,$C0,$00
.db $00,$01,$80,$00,$02,$31,$80,$00
.db $00,$00,$E0,$00,$78,$06,$00,$00
.db $00,$00,$18,$09,$E0,$38,$00,$00
.db $00,$00,$07,$FF,$C7,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic07:
.db $00,$00,$00,$6F,$FE,$00,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$7E,$00,$00
.db $00,$01,$FF,$FF,$CF,$D9,$80,$00
.db $00,$07,$CF,$FF,$FF,$F0,$C0,$00
.db $00,$0E,$0F,$FF,$FF,$F8,$30,$00
.db $00,$18,$07,$FF,$FF,$FC,$18,$00
.db $00,$60,$07,$FF,$FF,$FE,$0C,$00
.db $00,$C0,$0F,$FF,$FF,$F8,$06,$00
.db $01,$80,$0F,$FF,$FF,$E0,$03,$00
.db $01,$00,$0F,$FF,$FF,$C0,$07,$80
.db $02,$00,$0F,$FF,$FF,$80,$03,$C0
.db $06,$00,$0F,$FF,$FF,$80,$00,$40
.db $0C,$00,$07,$FF,$FF,$04,$00,$60
.db $08,$00,$03,$FF,$FE,$00,$00,$30
.db $18,$00,$03,$FF,$EF,$00,$00,$10
.db $10,$00,$03,$FF,$03,$80,$00,$18
.db $28,$00,$01,$FF,$03,$E0,$00,$08
.db $2C,$00,$00,$FF,$07,$F0,$00,$08
.db $66,$00,$00,$3F,$3F,$F8,$00,$0C
.db $46,$00,$00,$1F,$F0,$FF,$80,$04
.db $60,$00,$00,$0F,$F0,$5F,$80,$0E
.db $40,$00,$00,$03,$FE,$00,$C0,$0E
.db $80,$00,$00,$00,$7E,$00,$60,$06
.db $80,$00,$00,$00,$0E,$3E,$40,$02
.db $80,$00,$00,$00,$07,$FF,$C0,$03
.db $80,$00,$00,$00,$03,$FF,$E0,$03
.db $A0,$00,$00,$00,$08,$7F,$FC,$01
.db $90,$00,$00,$00,$01,$7F,$FE,$01
.db $90,$00,$00,$00,$00,$7F,$FE,$01
.db $80,$00,$00,$00,$20,$FF,$FE,$01
.db $90,$00,$00,$00,$31,$FF,$FF,$81
.db $C0,$00,$00,$00,$01,$FF,$FF,$E1
.db $C8,$00,$00,$00,$01,$FF,$FF,$F1
.db $88,$00,$00,$00,$01,$FF,$FF,$F1
.db $C0,$40,$00,$00,$00,$FF,$FF,$F3
.db $D6,$20,$00,$00,$00,$7F,$FF,$F3
.db $84,$00,$00,$00,$00,$7F,$FF,$E2
.db $E0,$00,$00,$00,$00,$7F,$FF,$C2
.db $41,$80,$00,$00,$00,$3F,$FF,$C2
.db $43,$40,$00,$00,$00,$1F,$FF,$C6
.db $68,$00,$00,$00,$00,$0F,$FF,$84
.db $64,$00,$00,$00,$00,$0F,$FF,$94
.db $20,$84,$00,$00,$00,$0F,$FF,$0C
.db $20,$01,$80,$00,$00,$1F,$FC,$08
.db $10,$20,$00,$50,$01,$1F,$F8,$18
.db $18,$00,$00,$00,$00,$1F,$F8,$10
.db $08,$00,$00,$00,$00,$3F,$F0,$30
.db $0C,$00,$00,$00,$03,$3F,$E0,$20
.db $06,$00,$00,$00,$00,$7F,$C0,$40
.db $02,$00,$00,$00,$00,$7F,$00,$C0
.db $01,$00,$00,$00,$00,$FE,$01,$80
.db $01,$80,$00,$00,$00,$F8,$03,$00
.db $00,$C0,$00,$00,$01,$F0,$06,$00
.db $00,$60,$00,$00,$01,$E0,$0C,$00
.db $00,$18,$00,$00,$03,$C0,$18,$00
.db $00,$0C,$00,$00,$03,$B1,$30,$00
.db $00,$06,$00,$00,$03,$C1,$C0,$00
.db $00,$01,$80,$00,$00,$13,$80,$00
.db $00,$00,$E0,$00,$03,$C6,$00,$00
.db $00,$00,$18,$00,$8F,$38,$00,$00
.db $00,$00,$07,$3F,$FD,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic08:
.db $00,$00,$00,$6F,$FE,$00,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$CF,$FF,$FF,$7F,$80,$00
.db $00,$07,$3E,$1F,$FF,$FF,$C0,$00
.db $00,$0F,$E0,$1F,$FF,$FF,$F0,$00
.db $00,$18,$00,$07,$FF,$FF,$F8,$00
.db $00,$60,$00,$03,$FF,$FF,$FC,$00
.db $00,$C0,$00,$03,$FF,$FF,$E6,$00
.db $01,$80,$00,$03,$FF,$FF,$C3,$00
.db $01,$00,$00,$03,$FF,$FF,$C1,$80
.db $02,$00,$00,$03,$FF,$FF,$C0,$C0
.db $06,$00,$00,$01,$FF,$FF,$C0,$40
.db $0C,$00,$00,$00,$FF,$FF,$C4,$20
.db $08,$00,$00,$00,$7F,$FF,$80,$20
.db $18,$80,$00,$00,$7F,$FD,$C0,$10
.db $10,$80,$00,$00,$3F,$E0,$F0,$18
.db $20,$60,$00,$00,$1F,$E0,$78,$08
.db $20,$3C,$00,$00,$0B,$E0,$FC,$08
.db $60,$0E,$00,$00,$03,$F3,$FE,$04
.db $50,$02,$00,$00,$01,$FF,$1F,$C4
.db $40,$80,$00,$00,$00,$FF,$0F,$C6
.db $40,$00,$00,$00,$00,$1F,$E0,$62
.db $80,$00,$00,$00,$00,$03,$E0,$22
.db $C0,$00,$00,$00,$00,$00,$E7,$A2
.db $A0,$00,$00,$00,$00,$00,$7F,$E3
.db $C0,$00,$00,$00,$00,$00,$3F,$F1
.db $E0,$20,$00,$00,$00,$00,$8F,$F9
.db $80,$10,$00,$00,$00,$00,$17,$FD
.db $A0,$08,$00,$00,$00,$00,$0F,$FD
.db $A4,$00,$00,$00,$00,$02,$0F,$FD
.db $E0,$10,$00,$00,$00,$03,$1F,$FF
.db $83,$00,$00,$00,$00,$00,$1F,$FF
.db $87,$04,$00,$00,$00,$00,$1F,$FF
.db $90,$04,$00,$00,$00,$00,$1F,$FF
.db $8A,$00,$00,$00,$00,$00,$0F,$FF
.db $C1,$19,$84,$00,$00,$00,$0F,$FF
.db $80,$01,$00,$00,$00,$00,$0F,$FE
.db $81,$00,$00,$00,$00,$00,$07,$FE
.db $64,$00,$60,$00,$00,$00,$07,$FE
.db $7C,$01,$C8,$00,$00,$00,$03,$FE
.db $45,$88,$00,$00,$00,$00,$03,$FC
.db $71,$08,$00,$00,$00,$00,$03,$FC
.db $30,$04,$40,$80,$00,$00,$07,$FC
.db $30,$00,$00,$30,$00,$00,$07,$F8
.db $10,$00,$08,$00,$0A,$00,$27,$F8
.db $1C,$80,$00,$00,$00,$00,$0F,$F0
.db $0C,$00,$00,$00,$00,$00,$1F,$F0
.db $0C,$00,$00,$00,$00,$00,$DF,$A0
.db $07,$80,$00,$00,$00,$00,$3F,$40
.db $02,$C0,$00,$00,$00,$00,$7E,$C0
.db $01,$60,$00,$00,$00,$00,$7D,$80
.db $01,$E0,$00,$00,$00,$00,$F3,$00
.db $00,$F8,$00,$00,$00,$01,$E6,$00
.db $00,$70,$00,$00,$00,$03,$CC,$00
.db $00,$1C,$00,$00,$00,$07,$98,$00
.db $00,$0C,$00,$00,$00,$07,$F0,$00
.db $00,$06,$00,$00,$00,$06,$C0,$00
.db $00,$01,$80,$00,$00,$03,$80,$00
.db $00,$00,$E0,$00,$00,$3E,$00,$00
.db $00,$00,$18,$00,$04,$F8,$00,$00
.db $00,$00,$07,$87,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic09:
.db $00,$00,$00,$6F,$FE,$00,$00,$00
.db $00,$00,$07,$EF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$7F,$FF,$FE,$00,$00
.db $00,$01,$FC,$7F,$FF,$FF,$80,$00
.db $00,$07,$E0,$7C,$3F,$FF,$C0,$00
.db $00,$0F,$BF,$80,$1F,$FF,$F0,$00
.db $00,$1E,$00,$00,$0F,$FF,$F8,$00
.db $00,$78,$00,$00,$03,$FF,$FC,$00
.db $00,$F0,$00,$00,$01,$FF,$FE,$00
.db $01,$C0,$00,$00,$01,$FF,$FF,$00
.db $01,$80,$00,$00,$01,$FF,$FF,$80
.db $03,$00,$00,$00,$00,$FF,$FF,$C0
.db $06,$00,$00,$00,$00,$7F,$FF,$40
.db $0C,$00,$00,$00,$00,$1F,$FF,$20
.db $0C,$00,$00,$00,$00,$0F,$FF,$A0
.db $18,$00,$80,$00,$00,$0F,$FF,$90
.db $18,$00,$40,$00,$00,$07,$F8,$D8
.db $32,$00,$28,$00,$00,$03,$F8,$68
.db $20,$00,$0F,$80,$00,$01,$F8,$78
.db $60,$00,$01,$E0,$00,$00,$3D,$F4
.db $50,$80,$00,$60,$00,$00,$3F,$9C
.db $50,$00,$20,$00,$00,$00,$1F,$9E
.db $60,$00,$00,$00,$00,$00,$07,$E6
.db $A0,$00,$00,$00,$00,$00,$00,$E2
.db $83,$00,$00,$00,$00,$00,$00,$6E
.db $C0,$40,$00,$00,$00,$00,$00,$3F
.db $90,$80,$00,$00,$00,$00,$00,$1F
.db $84,$C0,$02,$00,$00,$00,$00,$2F
.db $82,$00,$03,$00,$00,$00,$00,$1F
.db $80,$20,$00,$80,$00,$00,$00,$0F
.db $80,$22,$00,$00,$00,$00,$00,$4F
.db $81,$A0,$01,$00,$00,$00,$00,$CF
.db $F0,$00,$40,$00,$00,$00,$00,$0F
.db $D0,$01,$C0,$40,$00,$00,$00,$1F
.db $F8,$10,$00,$40,$00,$00,$00,$1F
.db $EC,$08,$80,$00,$00,$00,$00,$0F
.db $F7,$00,$42,$98,$60,$00,$00,$0F
.db $E0,$00,$00,$10,$00,$00,$00,$0E
.db $E0,$00,$C0,$00,$00,$00,$00,$0E
.db $60,$84,$00,$05,$00,$00,$00,$0E
.db $70,$CC,$00,$14,$80,$00,$00,$0E
.db $70,$04,$A1,$00,$00,$00,$00,$0C
.db $78,$C0,$81,$00,$00,$00,$00,$0C
.db $3C,$40,$00,$84,$08,$00,$00,$1C
.db $3E,$00,$00,$00,$03,$00,$00,$18
.db $1E,$00,$00,$01,$00,$01,$40,$78
.db $1F,$10,$80,$00,$00,$00,$00,$30
.db $0F,$40,$00,$00,$00,$00,$00,$70
.db $0F,$00,$00,$00,$00,$00,$01,$E0
.db $07,$86,$00,$00,$00,$00,$00,$C0
.db $03,$83,$80,$00,$00,$00,$01,$C0
.db $01,$C1,$80,$00,$00,$00,$03,$80
.db $01,$E1,$80,$00,$00,$00,$07,$00
.db $00,$E3,$90,$00,$00,$00,$0E,$00
.db $00,$61,$80,$00,$00,$00,$1C,$00
.db $00,$18,$90,$00,$00,$00,$38,$00
.db $00,$0C,$40,$00,$00,$00,$70,$00
.db $00,$06,$80,$00,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$0E,$00,$00
.db $00,$00,$1E,$00,$00,$B8,$00,$00
.db $00,$00,$07,$C0,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic10:
.db $00,$00,$00,$6F,$FE,$00,$00,$00
.db $00,$00,$07,$FE,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FB,$FF,$FE,$00,$00
.db $00,$01,$FF,$E1,$FF,$FF,$80,$00
.db $00,$07,$EF,$80,$F0,$FF,$C0,$00
.db $00,$0F,$CC,$5F,$80,$3F,$F0,$00
.db $00,$1F,$98,$00,$00,$0F,$F8,$00
.db $00,$7F,$60,$00,$00,$03,$FC,$00
.db $00,$FF,$C0,$00,$00,$01,$FE,$00
.db $01,$FE,$00,$00,$00,$01,$FF,$00
.db $01,$EC,$00,$00,$00,$00,$FF,$80
.db $03,$F8,$00,$00,$00,$00,$7F,$C0
.db $07,$F0,$00,$00,$00,$00,$3F,$C0
.db $0E,$E0,$00,$00,$00,$00,$1F,$E0
.db $0F,$A0,$00,$00,$00,$00,$0F,$F0
.db $1F,$00,$00,$10,$00,$00,$07,$F0
.db $1E,$20,$00,$08,$00,$00,$03,$F8
.db $3C,$44,$00,$03,$00,$00,$01,$E8
.db $38,$00,$00,$00,$F8,$00,$00,$FC
.db $60,$00,$00,$00,$1E,$00,$00,$7C
.db $70,$60,$20,$00,$06,$00,$00,$3C
.db $70,$40,$00,$01,$00,$00,$00,$1E
.db $70,$40,$00,$00,$00,$00,$00,$0E
.db $F0,$40,$00,$00,$00,$00,$00,$06
.db $F0,$00,$C0,$00,$00,$00,$00,$02
.db $F2,$00,$08,$00,$00,$00,$00,$03
.db $F4,$10,$20,$00,$00,$00,$00,$03
.db $E4,$02,$18,$00,$20,$00,$00,$03
.db $C8,$00,$80,$00,$18,$00,$00,$01
.db $D8,$00,$04,$00,$04,$00,$00,$01
.db $F0,$00,$04,$10,$00,$00,$00,$03
.db $FE,$00,$32,$00,$10,$00,$00,$03
.db $FF,$70,$00,$06,$00,$00,$00,$01
.db $FF,$90,$00,$0E,$02,$00,$00,$01
.db $EF,$FC,$01,$00,$02,$00,$00,$01
.db $FB,$E7,$00,$84,$00,$00,$00,$01
.db $F1,$F3,$80,$06,$18,$C2,$00,$03
.db $8F,$80,$A0,$00,$00,$80,$00,$02
.db $9F,$C0,$00,$06,$00,$00,$00,$02
.db $5E,$C0,$30,$40,$00,$50,$00,$02
.db $5F,$E0,$10,$C0,$00,$C8,$00,$06
.db $5F,$E0,$00,$89,$10,$00,$00,$04
.db $7F,$F0,$70,$08,$10,$00,$00,$04
.db $3F,$F8,$30,$00,$08,$81,$00,$0C
.db $3F,$FC,$00,$00,$00,$00,$60,$08
.db $1F,$FE,$00,$00,$00,$20,$01,$58
.db $1F,$FE,$08,$10,$00,$00,$00,$10
.db $0F,$FE,$40,$00,$00,$00,$00,$30
.db $0F,$FE,$00,$00,$00,$00,$00,$20
.db $06,$7E,$01,$80,$00,$00,$00,$40
.db $02,$1E,$00,$E0,$00,$00,$00,$C0
.db $01,$06,$01,$E0,$00,$00,$01,$80
.db $01,$83,$01,$C0,$00,$00,$03,$00
.db $00,$C1,$03,$88,$00,$00,$06,$00
.db $00,$60,$03,$00,$00,$00,$0C,$00
.db $00,$18,$01,$10,$00,$00,$18,$00
.db $00,$0C,$00,$80,$00,$00,$30,$00
.db $00,$06,$04,$00,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$1F,$E0,$00,$38,$00,$00
.db $00,$00,$07,$F8,$1F,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic11:
.db $00,$00,$00,$6F,$F6,$00,$00,$00
.db $00,$00,$07,$FF,$EF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$83,$FF,$80,$00
.db $00,$07,$FF,$1F,$01,$E7,$C0,$00
.db $00,$0F,$FF,$1C,$6F,$01,$F0,$00
.db $00,$1F,$FF,$18,$00,$00,$78,$00
.db $00,$7F,$FE,$60,$00,$00,$1C,$00
.db $00,$FF,$FF,$80,$00,$00,$0E,$00
.db $01,$FF,$FE,$00,$00,$00,$07,$00
.db $01,$FF,$8C,$00,$00,$00,$03,$80
.db $03,$FF,$B8,$00,$00,$00,$03,$C0
.db $07,$FB,$F8,$00,$00,$00,$01,$C0
.db $0F,$F9,$D0,$00,$00,$00,$00,$E0
.db $0F,$F9,$10,$00,$00,$00,$00,$60
.db $1F,$F2,$00,$00,$02,$00,$00,$30
.db $1F,$F4,$10,$00,$00,$80,$00,$18
.db $3F,$F8,$20,$80,$00,$50,$00,$18
.db $3F,$E0,$00,$00,$00,$0F,$00,$0C
.db $7F,$00,$00,$00,$00,$01,$C0,$04
.db $7E,$60,$08,$01,$00,$00,$40,$04
.db $7C,$60,$08,$00,$00,$10,$00,$06
.db $7C,$C0,$08,$00,$00,$00,$00,$02
.db $FC,$E0,$10,$00,$00,$00,$00,$02
.db $FC,$E0,$00,$0A,$00,$00,$00,$02
.db $F9,$E0,$80,$00,$80,$00,$00,$03
.db $B1,$62,$01,$01,$00,$00,$00,$01
.db $F3,$E2,$00,$20,$C0,$01,$00,$01
.db $FF,$84,$00,$04,$00,$00,$80,$01
.db $FF,$18,$00,$00,$20,$00,$40,$01
.db $FF,$F0,$00,$00,$20,$80,$00,$01
.db $BF,$FF,$80,$01,$90,$00,$80,$01
.db $BF,$FF,$EB,$00,$00,$20,$00,$01
.db $B3,$FF,$F3,$00,$00,$70,$20,$01
.db $BE,$C6,$FF,$C0,$08,$00,$20,$01
.db $8F,$FD,$FC,$78,$04,$20,$00,$81
.db $89,$E0,$6E,$18,$00,$21,$58,$83
.db $80,$0F,$20,$0A,$00,$00,$10,$02
.db $80,$1F,$30,$00,$00,$60,$00,$02
.db $40,$3F,$B8,$01,$04,$00,$0E,$02
.db $40,$7F,$F8,$01,$0C,$00,$1A,$06
.db $40,$7F,$FC,$00,$08,$A1,$00,$04
.db $61,$FF,$FE,$03,$00,$81,$00,$04
.db $21,$FF,$FF,$01,$00,$00,$90,$8C
.db $20,$FF,$FF,$80,$00,$00,$00,$48
.db $10,$FF,$FF,$80,$00,$00,$08,$18
.db $18,$7F,$FF,$C1,$02,$00,$00,$10
.db $08,$7F,$FF,$90,$00,$00,$00,$30
.db $0C,$3E,$FF,$80,$00,$00,$00,$20
.db $06,$38,$7F,$80,$60,$00,$00,$40
.db $02,$00,$1F,$80,$38,$00,$00,$C0
.db $01,$00,$06,$00,$78,$00,$01,$80
.db $01,$80,$03,$00,$E0,$00,$03,$00
.db $00,$C0,$01,$01,$C4,$00,$06,$00
.db $00,$60,$00,$01,$80,$00,$0C,$00
.db $00,$18,$00,$01,$10,$00,$18,$00
.db $00,$0C,$00,$01,$00,$00,$30,$00
.db $00,$06,$00,$04,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$1F,$FF,$00,$38,$00,$00
.db $00,$00,$07,$FF,$83,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic12:
.db $00,$00,$00,$7F,$F6,$00,$00,$00
.db $00,$00,$07,$FF,$FD,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$FE,$1F,$80,$00
.db $00,$07,$FF,$FF,$1E,$07,$C0,$00
.db $00,$0F,$FF,$FF,$18,$BC,$30,$00
.db $00,$1F,$FF,$FF,$10,$00,$18,$00
.db $00,$7F,$FF,$FF,$60,$00,$0C,$00
.db $00,$FF,$FF,$FF,$C0,$00,$06,$00
.db $01,$FF,$FF,$FB,$80,$00,$03,$00
.db $01,$FF,$FF,$C3,$00,$00,$01,$80
.db $03,$FF,$FF,$CE,$00,$00,$00,$C0
.db $07,$FF,$FD,$FE,$00,$00,$00,$40
.db $0F,$FF,$FC,$7E,$00,$00,$00,$20
.db $0F,$FF,$FC,$42,$00,$00,$00,$20
.db $1F,$FF,$FC,$80,$00,$00,$40,$10
.db $1F,$FF,$F9,$81,$00,$00,$20,$18
.db $3F,$FF,$FE,$02,$08,$00,$14,$08
.db $3F,$FF,$E8,$00,$00,$00,$07,$88
.db $7F,$FF,$80,$00,$00,$00,$00,$C4
.db $5E,$FF,$18,$00,$80,$10,$00,$64
.db $7C,$FC,$18,$00,$80,$00,$04,$06
.db $78,$FE,$18,$00,$80,$00,$00,$02
.db $B9,$7E,$1C,$01,$80,$00,$00,$02
.db $B1,$7E,$3E,$00,$00,$50,$00,$02
.db $B1,$5C,$2E,$0C,$00,$04,$00,$03
.db $B0,$70,$6E,$20,$10,$08,$00,$01
.db $91,$F0,$FE,$20,$01,$06,$00,$41
.db $C1,$F5,$E0,$40,$00,$40,$00,$61
.db $80,$F7,$C3,$80,$00,$02,$00,$21
.db $80,$F7,$FF,$00,$00,$01,$10,$01
.db $80,$7F,$FF,$F8,$00,$0C,$80,$21
.db $80,$3F,$FB,$FF,$D8,$00,$06,$01
.db $80,$38,$BA,$FF,$98,$00,$0E,$11
.db $C0,$3F,$B8,$6F,$F6,$00,$80,$11
.db $80,$0F,$FE,$CF,$C3,$80,$44,$03
.db $80,$08,$7E,$03,$71,$C0,$04,$7B
.db $80,$00,$00,$FB,$00,$50,$00,$12
.db $80,$00,$03,$F3,$00,$00,$0C,$02
.db $40,$00,$07,$FB,$80,$10,$40,$0A
.db $40,$00,$0F,$FF,$80,$18,$C0,$1E
.db $40,$00,$1F,$FF,$C0,$00,$94,$84
.db $60,$00,$7F,$FF,$E0,$70,$10,$84
.db $20,$00,$7F,$FF,$F0,$30,$00,$2C
.db $20,$00,$7F,$FF,$F0,$00,$00,$08
.db $10,$00,$7F,$FF,$F8,$00,$00,$38
.db $18,$00,$7F,$FF,$F8,$20,$80,$10
.db $08,$00,$3F,$FF,$FA,$00,$00,$30
.db $0C,$00,$1F,$BF,$F0,$00,$00,$20
.db $06,$00,$18,$1F,$E0,$08,$00,$40
.db $02,$80,$00,$03,$E0,$0C,$00,$C0
.db $01,$40,$00,$01,$80,$1C,$01,$80
.db $01,$80,$00,$01,$C0,$78,$03,$00
.db $00,$C0,$00,$00,$80,$E2,$06,$00
.db $00,$60,$00,$00,$00,$C0,$0C,$00
.db $00,$18,$00,$00,$01,$10,$18,$00
.db $00,$0C,$00,$00,$01,$00,$30,$00
.db $00,$06,$00,$00,$08,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$1F,$FF,$F0,$38,$00,$00
.db $00,$00,$07,$FF,$F9,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic13:
.db $00,$00,$00,$6F,$F6,$00,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$FF,$F3,$80,$00
.db $00,$07,$FF,$FF,$FE,$78,$C0,$00
.db $00,$0F,$FF,$FF,$FF,$32,$F0,$00
.db $00,$1F,$FF,$FF,$FF,$90,$18,$00
.db $00,$7F,$FF,$FF,$FF,$B0,$0C,$00
.db $00,$FF,$FF,$FF,$FF,$E0,$06,$00
.db $01,$FF,$FF,$FF,$FD,$C0,$03,$00
.db $01,$FF,$FF,$FF,$F1,$80,$01,$80
.db $03,$FF,$FF,$FF,$F3,$80,$00,$C0
.db $07,$FF,$FF,$FF,$3F,$80,$00,$40
.db $0F,$FF,$FF,$FF,$9E,$80,$00,$20
.db $0F,$FF,$FF,$FF,$88,$40,$00,$20
.db $1F,$FF,$FF,$FF,$88,$00,$00,$90
.db $1F,$FF,$FF,$FF,$10,$20,$00,$58
.db $3F,$FF,$FF,$FF,$E0,$21,$00,$38
.db $3E,$FF,$FF,$FF,$80,$00,$00,$18
.db $7E,$FF,$FF,$F8,$00,$00,$00,$0C
.db $7C,$7F,$3F,$B1,$80,$08,$04,$04
.db $78,$7C,$3F,$C1,$80,$08,$00,$0E
.db $70,$78,$3F,$E1,$80,$08,$00,$02
.db $F0,$78,$4F,$E1,$C0,$08,$00,$02
.db $F0,$70,$4F,$E1,$E0,$00,$0C,$02
.db $E0,$30,$4D,$C3,$E0,$60,$01,$03
.db $E0,$38,$0D,$02,$F1,$00,$81,$01
.db $C0,$18,$6E,$07,$F1,$00,$11,$83
.db $C0,$80,$3E,$4F,$02,$00,$04,$03
.db $C0,$00,$3F,$3E,$14,$00,$00,$41
.db $C0,$00,$1F,$7F,$F8,$00,$00,$49
.db $80,$00,$0F,$FF,$FF,$C0,$03,$41
.db $80,$00,$07,$FF,$BF,$FF,$80,$05
.db $90,$00,$03,$85,$D7,$FC,$C0,$0D
.db $80,$80,$03,$F9,$C5,$7F,$E0,$21
.db $80,$00,$00,$FF,$F4,$7E,$38,$29
.db $C0,$00,$00,$83,$60,$3F,$1A,$0B
.db $E0,$00,$00,$00,$07,$90,$08,$02
.db $E0,$00,$00,$00,$3F,$B8,$00,$0A
.db $70,$00,$00,$00,$7F,$B8,$02,$22
.db $70,$00,$00,$00,$FF,$FC,$02,$66
.db $74,$00,$00,$01,$FF,$FC,$00,$5C
.db $7C,$00,$00,$0F,$FF,$FE,$0C,$2C
.db $38,$00,$00,$0F,$FF,$FE,$0C,$0C
.db $38,$00,$00,$0F,$FF,$FF,$00,$08
.db $10,$00,$00,$0F,$FF,$FF,$00,$18
.db $18,$00,$00,$07,$FF,$FF,$08,$90
.db $08,$00,$00,$07,$FF,$FE,$80,$30
.db $0C,$00,$00,$07,$F7,$FE,$00,$20
.db $06,$00,$00,$07,$03,$FC,$08,$40
.db $02,$02,$00,$00,$00,$F8,$0C,$C0
.db $01,$01,$00,$00,$00,$60,$39,$80
.db $01,$80,$00,$00,$00,$70,$73,$00
.db $00,$C0,$00,$00,$00,$61,$EE,$00
.db $00,$70,$00,$00,$00,$01,$8C,$00
.db $00,$19,$80,$00,$00,$02,$58,$00
.db $00,$0C,$20,$00,$00,$02,$30,$00
.db $00,$06,$00,$00,$00,$10,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$1F,$FF,$FE,$B8,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00
Pic14:
.db $00,$00,$00,$7F,$FE,$00,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$FF,$FF,$FF,$FE,$00,$00
.db $00,$01,$FF,$FF,$FF,$FF,$80,$00
.db $00,$07,$FF,$FF,$FF,$FF,$C0,$00
.db $00,$0F,$FF,$FF,$FF,$FF,$F0,$00
.db $00,$1F,$FF,$FF,$FF,$FF,$58,$00
.db $00,$7F,$FF,$FF,$FF,$FF,$4C,$00
.db $00,$FF,$FF,$FF,$FF,$FF,$C6,$00
.db $01,$FF,$FF,$FF,$FF,$FF,$C3,$00
.db $01,$FF,$FF,$FF,$FF,$F8,$C1,$80
.db $03,$FF,$FF,$FF,$FF,$FC,$C0,$C0
.db $07,$FF,$FF,$FF,$FF,$EF,$C0,$40
.db $0E,$FF,$FF,$FF,$FF,$F3,$A0,$20
.db $0F,$FF,$FF,$FF,$FF,$F3,$20,$20
.db $1F,$FF,$FF,$FF,$FF,$F1,$00,$10
.db $1F,$FF,$FF,$FF,$FF,$F2,$08,$18
.db $3F,$FF,$FF,$FF,$FF,$FC,$08,$88
.db $3F,$FE,$3F,$FF,$FF,$F8,$00,$08
.db $7F,$FE,$3F,$FF,$FF,$00,$00,$04
.db $7F,$FC,$1F,$E3,$FB,$0C,$02,$0C
.db $7F,$F8,$0F,$C1,$FC,$1C,$02,$06
.db $7F,$E0,$0F,$81,$FE,$1C,$01,$02
.db $FF,$F0,$0F,$02,$FE,$0E,$01,$02
.db $FF,$F0,$0F,$02,$FE,$1F,$00,$0A
.db $FF,$C0,$07,$02,$DC,$1F,$0C,$07
.db $FF,$C0,$07,$80,$E8,$17,$10,$45
.db $FF,$80,$01,$83,$70,$37,$10,$13
.db $FF,$80,$10,$01,$F2,$78,$20,$09
.db $FF,$00,$00,$01,$F9,$F0,$A0,$03
.db $FE,$00,$00,$00,$FB,$FF,$80,$03
.db $FE,$00,$00,$00,$7F,$FF,$FC,$07
.db $FC,$00,$00,$00,$3F,$FD,$FF,$E1
.db $FC,$10,$00,$00,$1C,$6F,$FF,$61
.db $FC,$00,$20,$00,$1F,$CC,$3F,$F3
.db $FC,$00,$00,$00,$07,$FF,$EF,$9B
.db $FC,$00,$00,$00,$08,$3B,$06,$DF
.db $FE,$C0,$00,$00,$00,$00,$7A,$02
.db $FE,$C0,$00,$00,$00,$01,$F6,$02
.db $7F,$C0,$00,$00,$00,$07,$F7,$0A
.db $7F,$C0,$00,$00,$00,$07,$FF,$0E
.db $7C,$C0,$00,$00,$00,$1F,$FF,$04
.db $7C,$CC,$00,$00,$00,$FF,$FF,$14
.db $3E,$C0,$00,$00,$00,$FF,$FF,$1C
.db $3E,$E0,$00,$00,$00,$FF,$FF,$08
.db $1E,$00,$00,$00,$00,$FF,$FF,$18
.db $1E,$00,$00,$00,$00,$FF,$FF,$30
.db $0F,$00,$00,$00,$00,$FF,$FF,$30
.db $0F,$00,$00,$00,$00,$FD,$FE,$20
.db $06,$00,$00,$00,$00,$E0,$FC,$C0
.db $02,$00,$01,$00,$00,$00,$78,$C0
.db $01,$00,$00,$80,$00,$00,$61,$80
.db $01,$80,$00,$00,$00,$00,$67,$00
.db $00,$C0,$00,$00,$00,$00,$4E,$00
.db $00,$64,$80,$00,$00,$00,$0C,$00
.db $00,$18,$02,$00,$00,$00,$38,$00
.db $00,$0C,$00,$80,$00,$00,$30,$00
.db $00,$06,$00,$00,$00,$00,$C0,$00
.db $00,$01,$80,$00,$00,$01,$80,$00
.db $00,$00,$E0,$00,$00,$06,$00,$00
.db $00,$00,$1F,$FF,$FF,$F8,$00,$00
.db $00,$00,$07,$FF,$FF,$C0,$00,$00
.db $00,$00,$00,$7F,$FE,$00,$00,$00




.end
