;Plays a 1-Bit, 11kHz, Mono WAV-File over a connected earphone...
; (C) 1996 by Andreas Ess
;-----------------------------------------------------------------------------

#INCLUDE "TI-85.H"
#INCLUDE "INTEL.H"

.org 0
.db "PLAYWAVE V0.1 BY AE",0

Start:
 mov  a, (KEY_1)
 and  a
 jnz  Start
 lea(Sound)
 CALL_(PlayWAV)
 lea(Sound)
 CALL_(PlayWAV)
 ret

PlayWAV:
 cli		 	;greylib by robert taylor can't be used :(
 mov   a, 0C0h
 out   (7), a
 mov   e, (hl)
 inc   hl
 mov   d, (hl)
 inc   hl
 mov   b, 128		;b is used as a mask
SoundLoop:
 mov   c, 20
DLoop:
 dec   c
 jnz   DLoop
 ror   b
 jnc   Play
 inc   hl		;next byte
 dec   de
 mov   a, d
 or    e
 jz    DonePlay
 xor   a
 out   (1), a
 in    a, (1)
 bit   6, a
 jnz   DonePlay
Play:
 mov   a, (hl)          ;get bit
 and   b
 jz    Play1
 mov   a, 0FCh
 out   (7), a
 jmp   SoundLoop
Play1:
 mov   a, 0C0h
 out   (7), a
 jmp   SoundLoop
DonePlay:
 mov  a, 0C0h
 out  (7), a
 sti
 ret

;-----------------------------------------------------------------------------
;The WAV-File:
;-----------------------------------------------------------------------------
Sound:
 .dw 25437

 .db $00,$0F,$FF,$FF,$FF,$80,$00,$00,$00,$00,$0B,$FF,$C0,$6C,$FF,$7F
 .db $FF,$FF,$FF,$E9,$0E,$00,$00,$F4,$FF,$FE,$03,$F7,$FF,$FF,$F8,$00
 .db $00,$00,$00,$00,$07,$FF,$FA,$BF,$FF,$FF,$FF,$FF,$7C,$F4,$00,$00
 .db $7E,$FF,$FF,$88,$9F,$FF,$FF,$FF,$00,$00,$00,$00,$01,$86,$FF,$F0
 .db $2C,$1F,$FF,$FF,$FF,$DF,$F6,$00,$00,$07,$FF,$F3,$03,$FF,$FF,$FF
 .db $FF,$80,$00,$00,$00,$00,$4F,$C0,$00,$7F,$FF,$FF,$FF,$FF,$FE,$A4
 .db $00,$00,$03,$3F,$FF,$E0,$3F,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$08
 .db $FC,$C6,$00,$3F,$FF,$FF,$FF,$FE,$CB,$A2,$00,$00,$FF,$FF,$80,$08
 .db $7F,$FF,$FF,$F8,$00,$00,$00,$00,$04,$3F,$00,$00,$01,$FF,$FF,$FF
 .db $FF,$FE,$F8,$00,$00,$02,$FF,$F8,$BF,$FF,$FF,$FF,$FC,$00,$00,$00
 .db $00,$00,$00,$00,$00,$31,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$01,$FF
 .db $FC,$07,$1F,$FF,$FF,$FF,$80,$00,$00,$00,$00,$3F,$FB,$F9,$00,$01
 .db $FF,$FF,$FF,$FF,$FF,$E0,$00,$00,$1E,$FE,$80,$6F,$FF,$FF,$FF,$80
 .db $00,$00,$00,$07,$FC,$00,$01,$8F,$FF,$FF,$FF,$FF,$E0,$80,$1F,$FF
 .db $FF,$CF,$18,$00,$03,$FF,$FF,$FF,$F0,$00,$00,$00,$00,$7F,$EF,$E6
 .db $86,$3F,$F9,$FF,$7F,$FF,$FF,$FF,$FF,$FF,$E2,$7E,$40,$03,$FF,$FF
 .db $FF,$FC,$00,$00,$00,$00,$02,$00,$7F,$AF,$CF,$FE,$FD,$FF,$FF,$FF
 .db $FF,$FF,$FF,$9E,$19,$E0,$04,$FF,$FF,$FF,$FE,$00,$00,$00,$00,$00
 .db $00,$0F,$1F,$FF,$FF,$1C,$33,$FF,$FF,$FF,$FF,$FF,$84,$00,$E0,$00
 .db $3F,$FF,$FF,$FF,$10,$00,$00,$00,$00,$00,$03,$00,$61,$FF,$FC,$0F
 .db $B7,$FF,$FE,$FF,$F1,$1F,$F0,$7F,$80,$3F,$FF,$C0,$FF,$80,$00,$00
 .db $00,$00,$00,$07,$FF,$FF,$C0,$7E,$00,$1F,$FF,$FC,$DF,$FE,$0F,$E0
 .db $FF,$88,$3F,$C3,$FF,$FF,$F8,$00,$00,$00,$00,$04,$00,$FF,$03,$FE
 .db $3E,$00,$FF,$87,$FE,$3F,$E6,$1F,$E0,$1F,$C0,$10,$0F,$98,$CF,$FF
 .db $80,$09,$C0,$2F,$FD,$80,$0F,$E0,$01,$FE,$00,$80,$7C,$00,$1F,$FF
 .db $FF,$FF,$9F,$80,$01,$F9,$FE,$41,$F0,$1E,$7F,$83,$83,$30,$03,$F8
 .db $3F,$CF,$FC,$67,$C4,$03,$C0,$7E,$00,$C2,$07,$FF,$FE,$3B,$E0,$0F
 .db $F0,$1F,$3F,$FF,$00,$00,$07,$1D,$FF,$87,$F0,$07,$3E,$63,$FF,$F9
 .db $9F,$80,$00,$04,$F0,$1F,$3F,$FF,$0F,$FC,$0F,$1B,$FF,$07,$FC,$03
 .db $00,$1E,$03,$FF,$FF,$3E,$42,$00,$7F,$FE,$3F,$FF,$8F,$30,$04,$00
 .db $FF,$80,$7E,$0F,$3F,$FF,$0E,$01,$FF,$19,$FF,$80,$70,$0E,$01,$F9
 .db $00,$7F,$03,$CC,$3F,$E3,$9F,$FF,$EF,$FF,$C0,$00,$00,$63,$FF,$F8
 .db $41,$C0,$7F,$FF,$F0,$7F,$FF,$B8,$80,$00,$03,$E0,$7E,$67,$FC,$3B
 .db $FF,$1F,$3F,$FE,$07,$F8,$07,$00,$00,$00,$30,$CF,$FE,$3F,$C1,$BC
 .db $FF,$EF,$FC,$C0,$00,$00,$E0,$0C,$61,$FF,$FF,$F3,$08,$30,$CF,$FF
 .db $FB,$FF,$30,$00,$00,$FB,$CF,$FC,$60,$1F,$F8,$83,$18,$07,$FF,$F8
 .db $C0,$00,$01,$C4,$7C,$C1,$98,$11,$8F,$FC,$E7,$FE,$07,$FF,$FC,$C0
 .db $08,$00,$07,$FE,$E1,$9C,$00,$1F,$FE,$E3,$FE,$1F,$FF,$B8,$00,$00
 .db $01,$DF,$FC,$81,$90,$03,$FF,$F8,$CF,$FC,$07,$E0,$30,$00,$00,$00
 .db $07,$F3,$07,$F0,$0F,$FF,$E3,$7E,$00,$0F,$80,$C0,$00,$00,$DF,$FF
 .db $C0,$7F,$E0,$3F,$FF,$FF,$F9,$00,$00,$03,$00,$07,$80,$3F,$FF,$81
 .db $F8,$07,$FF,$FF,$98,$31,$00,$01,$EF,$00,$FF,$03,$FF,$CF,$3F,$E1
 .db $3F,$FF,$FF,$00,$00,$00,$1F,$FF,$00,$60,$06,$7F,$FF,$F8,$3F,$FF
 .db $8F,$FF,$00,$00,$30,$06,$0F,$9B,$98,$7F,$8F,$FF,$FF,$FC,$7F,$00
 .db $03,$FE,$00,$00,$01,$0F,$FE,$E6,$1F,$9F,$93,$FA,$00,$0F,$80,$01
 .db $FF,$FF,$FF,$00,$01,$FF,$FF,$1E,$00,$00,$FF,$F2,$18,$00,$01,$FF
 .db $FF,$FE,$00,$00,$E1,$36,$3E,$00,$00,$FF,$FF,$FF,$FC,$03,$FC,$FF
 .db $FF,$FC,$00,$00,$00,$00,$00,$01,$FF,$CF,$FB,$00,$03,$FF,$FF,$FF
 .db $E0,$00,$00,$7F,$FF,$FF,$E0,$00,$05,$83,$FF,$FF,$C0,$00,$00,$00
 .db $FF,$FF,$5D,$FF,$FF,$FF,$FC,$80,$00,$00,$00,$7F,$FF,$F0,$00,$20
 .db $3F,$FF,$E0,$06,$3F,$FF,$FF,$80,$00,$00,$00,$06,$07,$FF,$FF,$80
 .db $3F,$07,$FF,$00,$00,$00,$00,$9F,$FF,$FF,$FF,$B3,$FF,$FF,$FC,$00
 .db $00,$00,$0F,$F8,$00,$18,$0E,$FF,$FF,$EF,$FC,$00,$00,$01,$98,$20
 .db $80,$1E,$FF,$01,$FF,$FF,$FF,$FF,$00,$00,$00,$01,$FF,$3F,$FF,$FE
 .db $07,$FF,$BF,$FF,$FE,$00,$00,$00,$03,$FF,$FF,$FF,$E4,$00,$1F,$FF
 .db $FE,$72,$00,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00
 .db $00,$0C,$17,$FA,$2F,$FF,$3F,$FF,$FF,$FF,$E0,$00,$00,$00,$01,$3F
 .db $FF,$FF,$78,$7F,$FF,$FF,$FF,$C0,$00,$00,$00,$FF,$FF,$FF,$80,$00
 .db $23,$FF,$FF,$FF,$C0,$00,$00,$07,$FF,$FF,$F0,$00,$7F,$FF,$DF,$D0
 .db $00,$00,$BF,$FF,$FC,$00,$00,$00,$01,$BF,$FF,$FF,$FF,$F0,$00,$00
 .db $00,$03,$FF,$FF,$FF,$FF,$E0,$00,$00,$03,$FF,$FF,$FF,$00,$00,$00
 .db $00,$01,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$E0
 .db $00,$00,$01,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$0E,$FF,$FF,$FF,$FF
 .db $00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$F2,$00,$00,$00,$00,$03,$FF
 .db $FF,$FF,$F0,$00,$00,$00,$3F,$FF,$FF,$FF,$00,$00,$00,$00,$00,$FF
 .db $FF,$FF,$FF,$FF,$F0,$00,$00,$00,$00,$1F,$FF,$FF,$FF,$F8,$00,$00
 .db $0F,$FF,$FF,$FF,$06,$80,$00,$00,$00,$00,$3F,$FF,$FF,$FF,$FF,$80
 .db $00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00,$00,$00,$FF,$FF
 .db $FF,$FF,$C0,$00,$00,$9F,$FF,$FF,$FF,$00,$00,$00,$00,$00,$1F,$FF
 .db $FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$07,$FF,$3F,$7E,$00,$00,$00
 .db $A0,$03,$EF,$FF,$FF,$FF,$FF,$7C,$00,$00,$00,$07,$3F,$FF,$FF,$FF
 .db $87,$80,$00,$00,$03,$87,$17,$B3,$7F,$FF,$BF,$04,$00,$00,$06,$1F
 .db $7F,$FF,$FF,$FC,$FC,$80,$00,$03,$10,$72,$72,$7F,$FF,$FF,$C8,$00
 .db $00,$00,$03,$27,$FF,$FF,$F9,$FD,$FF,$7F,$9F,$E1,$E5,$E0,$0E,$7F
 .db $1F,$8C,$1C,$80,$FC,$3D,$FF,$FF,$0C,$20,$00,$00,$10,$CF,$CF,$FF
 .db $FF,$FF,$FE,$0E,$04,$0E,$19,$FB,$FC,$79,$FF,$FF,$C0,$E0,$00,$10
 .db $67,$0F,$7E,$5B,$FF,$FC,$38,$20,$00,$00,$41,$EF,$8F,$FF,$FF,$DF
 .db $BF,$00,$00,$08,$08,$00,$3F,$FF,$FF,$FF,$E0,$C0,$00,$00,$00,$03
 .db $C7,$7F,$BF,$BF,$3F,$9D,$FC,$3F,$FC,$FF,$FF,$F0,$60,$C0,$00,$01
 .db $83,$9F,$FF,$FF,$FF,$1C,$00,$00,$00,$10,$02,$60,$FF,$FF,$FF,$FF
 .db $FF,$E8,$1E,$00,$00,$00,$03,$FD,$FF,$FF,$FF,$FF,$E0,$81,$80,$00
 .db $03,$03,$36,$1F,$FF,$FE,$FF,$F9,$FC,$3F,$F1,$FF,$F0,$70,$00,$C0
 .db $41,$C3,$CF,$FF,$FF,$FF,$07,$80,$00,$00,$00,$04,$1F,$F9,$FF,$FF
 .db $FF,$FF,$E0,$80,$00,$00,$FF,$C3,$DF,$0F,$FF,$DF,$1E,$3C,$3E,$0E
 .db $38,$00,$00,$0C,$1B,$F1,$FD,$F3,$FF,$FF,$E3,$FF,$87,$FF,$47,$04
 .db $00,$04,$87,$FE,$3F,$FF,$FF,$FF,$F8,$60,$00,$00,$00,$C0,$FF,$DF
 .db $FF,$FF,$FF,$FC,$08,$01,$8C,$0C,$F8,$0F,$3F,$F9,$FC,$7F,$FF,$7F
 .db $E0,$F4,$00,$38,$01,$80,$00,$07,$07,$FE,$3F,$FC,$FF,$FF,$F8,$F1
 .db $E0,$08,$1F,$C1,$FC,$00,$FF,$FF,$87,$FF,$F0,$60,$00,$00,$00,$00
 .db $0F,$FB,$7F,$E7,$FF,$FE,$C3,$C7,$1F,$E0,$7E,$00,$F8,$03,$9F,$F8
 .db $FF,$C0,$E7,$FF,$F3,$FF,$00,$00,$00,$00,$1F,$FF,$FF,$FC,$CF,$FC
 .db $03,$FB,$91,$B8,$01,$C0,$7F,$F0,$7F,$FF,$FF,$FC,$9A,$03,$80,$00
 .db $00,$00,$00,$01,$E0,$4F,$FF,$FF,$FF,$FF,$FF,$FF,$3F,$BF,$E1,$00
 .db $01,$C3,$FC,$EB,$E0,$63,$F7,$80,$00,$00,$40,$0F,$FF,$FD,$8E,$02
 .db $E8,$FF,$E0,$43,$1E,$21,$BB,$DF,$FE,$FF,$FF,$F8,$00,$00,$00,$00
 .db $00,$00,$2D,$DF,$FF,$FF,$EF,$FE,$FF,$F6,$C0,$00,$10,$00,$80,$01
 .db $EF,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$38,$80,$00,$00,$00,$00,$00,$00
 .db $04,$02,$B7,$CF,$BF,$FF,$BB,$FF,$CF,$FC,$FD,$FE,$FF,$FF,$FF,$FE
 .db $D1,$2F,$9F,$FC,$00,$14,$04,$70,$00,$00,$10,$0B,$FF,$C0,$DC,$41
 .db $0E,$BB,$F8,$00,$60,$05,$B8,$03,$7D,$BF,$FF,$FF,$F9,$ED,$FB,$D4
 .db $09,$00,$07,$FF,$FF,$F0,$00,$90,$7F,$E0,$02,$43,$08,$84,$9E,$7F
 .db $E7,$BD,$FE,$FF,$C6,$3F,$F3,$FF,$C0,$00,$00,$00,$00,$00,$00,$AF
 .db $FF,$FF,$FE,$BF,$F7,$F4,$03,$00,$0D,$2F,$FF,$8A,$09,$F9,$9F,$80
 .db $FF,$CD,$DE,$70,$F2,$B8,$3E,$CF,$EF,$FF,$7C,$FD,$BF,$FF,$00,$00
 .db $00,$00,$00,$00,$01,$3F,$FF,$FF,$FF,$FE,$7F,$AF,$39,$00,$BA,$3F
 .db $BC,$05,$01,$0B,$FB,$37,$F7,$FF,$DF,$F7,$F2,$C0,$E0,$1E,$EE,$FF
 .db $D7,$BD,$FF,$FE,$40,$00,$00,$00,$00,$01,$32,$1F,$FF,$FF,$FB,$DF
 .db $FD,$FF,$E8,$08,$63,$FE,$F0,$00,$00,$0E,$1B,$DC,$1C,$E7,$FF,$FF
 .db $DB,$FC,$00,$D4,$37,$FE,$D1,$BF,$FF,$F9,$C0,$00,$00,$22,$00,$00
 .db $04,$BB,$FF,$FF,$E1,$FF,$EF,$FF,$E0,$06,$7F,$FF,$E2,$00,$00,$11
 .db $88,$00,$4C,$47,$FF,$FF,$FF,$E4,$AE,$09,$F9,$C9,$1D,$F6,$FF,$F9
 .db $84,$00,$00,$CC,$00,$10,$00,$CD,$F9,$FF,$0A,$FF,$FF,$FF,$3C,$23
 .db $DB,$FF,$C0,$00,$00,$03,$20,$0C,$E0,$3F,$79,$FD,$FE,$47,$FE,$FF
 .db $FF,$30,$07,$3B,$FF,$8C,$20,$00,$07,$40,$23,$80,$3C,$A3,$DB,$B0
 .db $07,$D5,$FF,$EE,$3E,$FF,$FF,$FE,$38,$00,$00,$00,$00,$86,$01,$73
 .db $87,$FF,$FB,$DF,$FF,$FF,$F8,$D0,$60,$8E,$7C,$E6,$80,$00,$14,$00
 .db $00,$03,$DF,$FF,$FC,$00,$44,$06,$FF,$F3,$BD,$80,$0F,$FF,$00,$3B
 .db $C1,$01,$00,$00,$00,$03,$FF,$C0,$7F,$E0,$7F,$FF,$FF,$30,$01,$FF
 .db $C0,$7F,$E0,$00,$02,$30,$01,$3F,$BF,$FE,$67,$FF,$00,$6F,$FE,$40
 .db $80,$03,$FF,$FD,$FF,$F8,$00,$00,$00,$00,$1C,$0C,$C4,$1F,$FF,$23
 .db $FF,$FF,$FC,$03,$CF,$0F,$E7,$FA,$20,$00,$01,$80,$04,$D8,$5F,$FF
 .db $1F,$FF,$E2,$1F,$FE,$CC,$00,$19,$BF,$DF,$F8,$8F,$F8,$03,$BE,$00
 .db $63,$23,$FE,$00,$FF,$9D,$EF,$FF,$DF,$F3,$01,$FF,$FC,$C6,$00,$00
 .db $00,$01,$00,$01,$FF,$FF,$FF,$9F,$FF,$FF,$FF,$E0,$04,$00,$7F,$F7
 .db $C8,$E3,$00,$79,$80,$1E,$20,$84,$7F,$7E,$30,$DF,$CE,$FF,$E6,$7B
 .db $FB,$E7,$FF,$C0,$00,$00,$04,$00,$00,$1D,$F7,$FF,$FF,$E2,$3F,$FF
 .db $EF,$18,$80,$3E,$E0,$9F,$F8,$00,$20,$18,$88,$00,$C6,$37,$FF,$3F
 .db $F3,$00,$FF,$E0,$27,$76,$3F,$FF,$FE,$64,$00,$01,$30,$10,$00,$00
 .db $0F,$FF,$FF,$DD,$FF,$FF,$E1,$80,$1D,$C4,$FF,$FF,$00,$00,$01,$C0
 .db $00,$20,$00,$3F,$FF,$F9,$8C,$FC,$CE,$7F,$F0,$3D,$C0,$7F,$FF,$00
 .db $00,$06,$31,$00,$00,$00,$FF,$EF,$F9,$C3,$FF,$FB,$3F,$F1,$88,$FF
 .db $CE,$FF,$F8,$10,$84,$00,$C0,$00,$02,$7F,$C3,$3F,$F9,$DF,$FF,$EF
 .db $F3,$00,$14,$00,$1F,$E3,$F9,$9F,$F8,$00,$1E,$90,$FF,$FF,$FF,$FF
 .db $FF,$F8,$00,$00,$00,$00,$03,$F0,$07,$FD,$FF,$FE,$00,$56,$01,$E0
 .db $1F,$F0,$01,$F7,$FF,$FF,$C7,$FF,$FF,$FF,$FF,$08,$21,$CC,$00,$00
 .db $00,$0F,$80,$1E,$00,$00,$10,$00,$B0,$00,$3F,$FF,$FF,$FE,$0F,$FF
 .db $E0,$FF,$00,$7F,$FB,$FF,$FF,$19,$FF,$9F,$FF,$FF,$38,$1F,$F0,$1F
 .db $C0,$00,$00,$00,$20,$00,$3F,$FF,$FF,$FC,$FF,$FE,$7B,$FF,$C0,$F3
 .db $0F,$3F,$FF,$80,$04,$07,$60,$00,$00,$00,$7F,$FF,$F7,$80,$73,$FF
 .db $FF,$F3,$FF,$DF,$FF,$F0,$00,$00,$0F,$00,$00,$00,$01,$FF,$FF,$FE
 .db $B7,$FF,$80,$FF,$FF,$F9,$00,$01,$FF,$FF,$E0,$3D,$80,$08,$10,$1F
 .db $FF,$FE,$40,$02,$00,$0B,$FF,$FF,$F0,$03,$9F,$FF,$FF,$9C,$10,$FF
 .db $C0,$00,$00,$FF,$FC,$FF,$FC,$06,$21,$10,$00,$3F,$FF,$00,$00,$00
 .db $FF,$FF,$F0,$00,$7F,$C3,$CE,$FF,$FF,$F0,$1C,$01,$E0,$06,$FF,$80
 .db $7F,$FF,$79,$C1,$EF,$80,$00,$3A,$1F,$FF,$F7,$FF,$F3,$FC,$00,$00
 .db $09,$E0,$3F,$FE,$FE,$E7,$06,$00,$02,$00,$40,$0E,$FF,$FF,$FF,$FF
 .db $F8,$E0,$00,$00,$00,$7F,$FF,$FC,$27,$3D,$FE,$80,$00,$80,$3F,$FF
 .db $FF,$FF,$FF,$C0,$00,$00,$06,$03,$FF,$FF,$FF,$FD,$E0,$10,$00,$02
 .db $00,$03,$FF,$FF,$FF,$FF,$F0,$00,$00,$7D,$FF,$DE,$F8,$00,$00,$00
 .db $70,$03,$07,$43,$FF,$FF,$FF,$FD,$CC,$80,$00,$00,$06,$20,$FF,$FF
 .db $BF,$FF,$C1,$C0,$00,$00,$01,$7F,$FF,$FB,$FF,$FD,$F0,$04,$67,$DF
 .db $30,$62,$66,$06,$7F,$01,$00,$00,$10,$07,$FF,$FF,$FF,$FF,$FE,$00
 .db $00,$00,$00,$E3,$DF,$FD,$FF,$FF,$0F,$20,$00,$00,$02,$3F,$FF,$FF
 .db $FF,$E6,$00,$01,$00,$7F,$FF,$FF,$B8,$03,$F0,$0C,$00,$00,$00,$1F
 .db $FF,$FF,$FF,$FF,$FC,$00,$00,$00,$01,$04,$7F,$F3,$FF,$F8,$38,$00
 .db $00,$00,$19,$FF,$FF,$FF,$FF,$88,$00,$00,$01,$8B,$7F,$FF,$FF,$FF
 .db $C0,$20,$00,$00,$00,$1F,$FF,$FD,$FF,$FF,$FF,$80,$00,$00,$01,$B7
 .db $FF,$8F,$FF,$CF,$C0,$00,$00,$40,$CF,$FF,$F3,$FF,$FF,$F0,$00,$00
 .db $00,$00,$1F,$EF,$3F,$FF,$7F,$B0,$10,$01,$80,$3F,$FB,$C7,$FB,$FF
 .db $F0,$02,$20,$06,$00,$A1,$9C,$7D,$FF,$FE,$00,$00,$07,$00,$33,$83
 .db $3F,$FF,$FF,$C0,$04,$00,$03,$F0,$07,$F0,$E1,$BF,$F0,$3F,$E0,$07
 .db $B0,$E0,$0E,$07,$FC,$7F,$80,$0F,$F8,$07,$F2,$03,$FF,$03,$FF,$00
 .db $1F,$91,$00,$01,$F8,$07,$FC,$0F,$FF,$00,$83,$C0,$00,$7F,$83,$FF
 .db $00,$7F,$C0,$1F,$E0,$10,$FF,$83,$FF,$E1,$FF,$F8,$00,$18,$00,$FF
 .db $C1,$FF,$F0,$3F,$F8,$00,$1C,$03,$F9,$C1,$F8,$40,$3F,$FF,$FF,$E0
 .db $03,$80,$00,$04,$10,$7F,$7F,$CF,$FF,$81,$E0,$0A,$7F,$F0,$19,$01
 .db $F3,$7C,$00,$C0,$07,$F8,$E1,$FF,$FF,$FF,$FF,$BE,$00,$00,$00,$00
 .db $00,$20,$7F,$FF,$FF,$E7,$E1,$FF,$C0,$FF,$40,$30,$70,$0F,$00,$CF
 .db $FF,$FB,$FF,$FF,$FF,$FF,$FF,$F0,$0F,$80,$00,$00,$00,$00,$0F,$03
 .db $80,$00,$01,$E0,$11,$F8,$3F,$FF,$FF,$FF,$C1,$FF,$3D,$3F,$FF,$FF
 .db $FF,$FF,$FF,$F8,$30,$02,$01,$0F,$C0,$80,$00,$3F,$7C,$00,$00,$00
 .db $00,$11,$BF,$FF,$FF,$FF,$43,$80,$00,$90,$7A,$0E,$7F,$C7,$FF,$E0
 .db $3C,$06,$02,$0F,$C8,$FF,$FF,$FF,$FF,$C3,$80,$02,$03,$00,$7D,$F7
 .db $FF,$FF,$FB,$E1,$80,$00,$38,$07,$9E,$EF,$C7,$F0,$0C,$00,$0C,$07
 .db $83,$80,$7E,$3E,$FF,$83,$F0,$00,$00,$00,$0F,$FF,$F8,$FF,$EF,$FF
 .db $83,$D8,$0F,$0F,$0F,$F8,$7F,$FF,$FF,$E6,$00,$00,$70,$3D,$FF,$03
 .db $E6,$7E,$E0,$00,$00,$03,$80,$03,$FB,$3F,$FF,$FF,$0C,$00,$00,$00
 .db $1A,$77,$F3,$FB,$F9,$E0,$FE,$01,$E6,$04,$E7,$FC,$3F,$FF,$FF,$C0
 .db $60,$03,$01,$0F,$87,$E0,$FF,$E6,$38,$07,$83,$F0,$00,$48,$FF,$CF
 .db $FF,$3F,$20,$20,$08,$78,$1F,$FF,$F1,$FF,$F8,$36,$07,$80,$E6,$C0
 .db $7F,$0F,$9F,$FF,$7F,$38,$00,$00,$70,$18,$1F,$C1,$FF,$F8,$10,$32
 .db $07,$E0,$00,$1F,$FC,$3F,$FF,$E6,$07,$80,$FC,$04,$FE,$0F,$87,$FF
 .db $FF,$00,$3C,$03,$10,$13,$F8,$7C,$FF,$FF,$F8,$07,$00,$12,$00,$DC
 .db $38,$1F,$FE,$3C,$60,$E0,$7E,$80,$80,$FB,$87,$FF,$FF,$FC,$18,$00
 .db $E0,$07,$7F,$E5,$FF,$F5,$D9,$81,$01,$02,$06,$0E,$7E,$8C,$FF,$FF
 .db $FF,$F0,$01,$80,$07,$E0,$E1,$FB,$FF,$E0,$03,$80,$10,$30,$07,$E1
 .db $FF,$FD,$FF,$E0,$00,$06,$00,$10,$3F,$FF,$EF,$FF,$1F,$80,$00,$00
 .db $0C,$07,$F8,$FF,$FF,$FF,$F0,$00,$00,$80,$7F,$B8,$1F,$FF,$E3,$F6
 .db $10,$01,$E0,$80,$3F,$FC,$1F,$FF,$E7,$00,$90,$00,$1F,$00,$FF,$FF
 .db $9B,$FF,$80,$02,$02,$40,$1F,$E1,$C1,$FF,$FF,$9F,$F0,$00,$00,$0E
 .db $00,$3E,$7F,$FF,$FF,$C0,$00,$00,$0F,$00,$FE,$07,$FF,$E7,$FF,$CC
 .db $01,$C0,$00,$04,$3F,$F2,$7F,$F8,$0B,$9E,$00,$03,$C0,$0F,$E1,$FF
 .db $FF,$FF,$00,$00,$01,$00,$18,$E2,$1F,$FF,$FC,$66,$60,$00,$30,$00
 .db $00,$1F,$FF,$FF,$FF,$C0,$18,$90,$00,$73,$F3,$BF,$9F,$FF,$E0,$00
 .db $00,$1F,$83,$B0,$47,$FF,$FF,$FD,$80,$00,$00,$00,$07,$FF,$FF,$FF
 .db $FF,$01,$00,$00,$E0,$08,$C0,$3F,$FF,$FF,$CD,$F8,$02,$20,$00,$1F
 .db $9D,$FF,$FF,$FE,$C6,$00,$00,$30,$77,$F7,$FF,$FF,$FF,$C8,$30,$0C
 .db $00,$18,$00,$03,$BF,$FF,$FF,$F8,$00,$38,$00,$06,$7F,$CF,$F9,$FF
 .db $E0,$7F,$80,$01,$80,$FC,$3F,$FC,$3F,$F8,$1C,$00,$00,$07,$FB,$FF
 .db $D9,$FF,$FF,$C0,$60,$00,$FF,$01,$F8,$FF,$83,$FF,$07,$E0,$0F,$F0
 .db $00,$3F,$80,$7F,$FB,$FF,$80,$01,$F0,$01,$F8,$0F,$FC,$0E,$7F,$C0
 .db $7E,$00,$78,$00,$7E,$E0,$6F,$FD,$FF,$F8,$0F,$80,$0C,$0C,$0F,$FF
 .db $99,$FF,$03,$C0,$03,$C1,$C0,$1F,$01,$FF,$1F,$FF,$FC,$1B,$E0,$00
 .db $03,$F9,$FF,$87,$FE,$3F,$00,$30,$02,$01,$FF,$83,$83,$FF,$FF,$F0
 .db $FE,$40,$60,$03,$C3,$81,$FF,$FF,$FC,$08,$10,$08,$03,$F9,$EF,$CF
 .db $FF,$FF,$1F,$F8,$18,$00,$FE,$DF,$03,$FF,$3F,$C0,$3E,$07,$00,$7F
 .db $E3,$F8,$1F,$FF,$F0,$0F,$80,$E7,$01,$38,$3E,$07,$FE,$7F,$C0,$44
 .db $00,$00,$0F,$0F,$E6,$FB,$FF,$F8,$7F,$C0,$00,$03,$C3,$FC,$03,$FF
 .db $FF,$00,$3C,$00,$00,$3C,$3C,$C0,$3F,$FF,$FF,$F0,$00,$00,$00,$CD
 .db $E0,$7F,$CF,$FD,$0F,$01,$00,$00,$CC,$1F,$B0,$FF,$FF,$FF,$3F,$F0
 .db $20,$07,$F0,$39,$FE,$FF,$80,$C0,$06,$00,$01,$3F,$F8,$3D,$FF,$FF
 .db $9F,$CF,$C1,$C0,$07,$06,$0F,$FF,$FF,$84,$00,$18,$00,$00,$CF,$FE
 .db $E7,$FF,$FF,$FF,$F9,$F1,$C0,$0F,$8D,$E7,$FF,$FF,$00,$00,$00,$00
 .db $00,$FF,$FF,$FE,$FF,$F4,$FC,$03,$C0,$03,$00,$70,$0F,$FF,$FE,$00
 .db $60,$10,$00,$C0,$3F,$EF,$FF,$8F,$E0,$3F,$19,$F8,$0C,$60,$7F,$23
 .db $FF,$FF,$00,$04,$00,$00,$06,$6F,$EF,$7F,$FF,$FF,$1E,$78,$38,$01
 .db $E0,$C3,$E3,$FF,$FE,$00,$00,$00,$00,$00,$1F,$FF,$FF,$FF,$E0,$7D
 .db $E0,$70,$03,$07,$DF,$0F,$FF,$FE,$03,$80,$00,$00,$7C,$FF,$F8,$FB
 .db $FF,$E7,$C3,$C0,$43,$00,$1C,$FE,$7F,$FF,$F8,$1C,$00,$00,$00,$60
 .db $7F,$E7,$FF,$FF,$BF,$FF,$03,$FE,$00,$E0,$B8,$3F,$FF,$9E,$E0,$00
 .db $00,$01,$FF,$FE,$7C,$9F,$FF,$FF,$F8,$7F,$C0,$01,$82,$03,$FF,$FF
 .db $FF,$80,$04,$00,$00,$0F,$FD,$F8,$7F,$F8,$FF,$E1,$FF,$88,$00,$0C
 .db $03,$FE,$3F,$FC,$C0,$00,$00,$07,$FF,$E7,$F0,$7B,$FF,$FE,$1C,$C0
 .db $00,$07,$30,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00,$3F,$87,$FF
 .db $FF,$FF,$FF,$E0,$E0,$2F,$00,$FE,$00,$C0,$00,$01,$C0,$0F,$FF,$FF
 .db $FF,$FF,$FF,$FF,$BF,$00,$00,$00,$00,$00,$03,$E0,$00,$00,$00,$00
 .db $00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C3,$FF,$FF,$FF,$FF,$F3,$80
 .db $00,$02,$00,$00,$00,$00,$3F,$FF,$FF,$90,$00,$00,$00,$00,$F7,$FF
 .db $FF,$FF,$C0,$00,$00,$00,$00,$01,$FF,$9C,$7F,$9F,$FF,$FF,$CC,$00
 .db $01,$8F,$FF,$FF,$FF,$C0,$00,$00,$00,$7F,$EF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$88,$00,$00,$07,$FF,$FF,$FE,$00,$00,$00,$00,$03,$FF,$FF,$F7
 .db $F3,$1B,$F9,$DF,$B0,$00,$01,$DF,$FF,$FF,$FF,$00,$00,$00,$01,$9E
 .db $FF,$FF,$FF,$FF,$EF,$FC,$18,$00,$00,$0F,$FF,$FF,$FF,$C0,$00,$00
 .db $00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FC,$78,$80,$01,$83,$DF,$FF,$FF
 .db $F9,$00,$00,$FF,$FC,$80,$43,$C2,$7F,$FF,$FF,$FF,$00,$00,$00,$30
 .db $3F,$FF,$FF,$FC,$00,$00,$00,$40,$00,$3F,$FF,$9F,$FF,$C0,$FE,$00
 .db $09,$FF,$FF,$FF,$FF,$A3,$FF,$80,$00,$00,$00,$3F,$FF,$DC,$7F,$FF
 .db $FE,$20,$00,$01,$80,$04,$3F,$FF,$FF,$FC,$00,$00,$00,$00,$03,$FF
 .db $F9,$FF,$FF,$FF,$F8,$00,$00,$67,$FE,$7F,$FF,$FF,$F0,$00,$00,$1C
 .db $02,$00,$1F,$FF,$FF,$FF,$FF,$88,$00,$00,$03,$FF,$FF,$FF,$3F,$F8
 .db $1C,$00,$00,$00,$0F,$BF,$FF,$07,$FF,$FF,$F0,$00,$00,$05,$EF,$FF
 .db $FF,$FF,$F0,$00,$01,$80,$00,$30,$FF,$FF,$FF,$FE,$BF,$E0,$C0,$06
 .db $00,$9F,$BF,$FF,$FF,$FB,$B0,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF
 .db $80,$00,$00,$04,$7F,$FF,$FF,$FD,$CC,$00,$01,$00,$00,$33,$9F,$CF
 .db $FF,$FF,$FF,$10,$00,$00,$01,$FF,$FF,$FF,$EE,$7C,$C0,$00,$00,$21
 .db $80,$1F,$63,$FF,$FF,$FF,$00,$01,$00,$1D,$FF,$FF,$FE,$FF,$FC,$80
 .db $80,$00,$00,$00,$7E,$FF,$FF,$FF,$FF,$F8,$00,$00,$01,$FF,$FF,$FE
 .db $7F,$FF,$02,$00,$00,$00,$03,$FB,$F3,$FF,$FF,$FF,$40,$00,$08,$05
 .db $C3,$BB,$FC,$FF,$F6,$03,$00,$00,$00,$07,$EF,$FF,$FF,$FF,$FF,$C0
 .db $00,$20,$07,$7F,$FF,$F7,$FB,$F8,$08,$00,$00,$00,$3F,$87,$9D,$FF
 .db $FF,$FF,$00,$00,$00,$3B,$FF,$FF,$EF,$FF,$F0,$00,$00,$00,$00,$9F
 .db $FF,$FF,$FF,$FF,$FF,$80,$00,$C0,$0F,$FF,$FF,$BB,$FF,$FB,$80,$00
 .db $00,$01,$FF,$FF,$C7,$7F,$FF,$F3,$00,$01,$CB,$07,$FB,$FF,$FF,$7F
 .db $C6,$00,$00,$00,$00,$7F,$FF,$E0,$FF,$FF,$FC,$00,$00,$00,$3F,$FF
 .db $FC,$1C,$FF,$E4,$00,$00,$00,$03,$F9,$FF,$C9,$FF,$FF,$F8,$00,$00
 .db $08,$0F,$FF,$FB,$FF,$FB,$FD,$00,$00,$00,$01,$03,$BF,$FF,$FF,$FF
 .db $F9,$10,$00,$00,$3F,$FF,$F0,$63,$FF,$FF,$80,$00,$00,$00,$03,$FF
 .db $FB,$BF,$BB,$FF,$98,$39,$DF,$FF,$FF,$DF,$F2,$00,$00,$00,$3F,$C0
 .db $4C,$3F,$33,$18,$7F,$FF,$FE,$76,$0F,$88,$E7,$FF,$FF,$E7,$80,$00
 .db $00,$00,$00,$DF,$FF,$FF,$FF,$FF,$F0,$1C,$18,$E7,$1B,$06,$FF,$FF
 .db $BC,$67,$78,$00,$00,$00,$00,$03,$FF,$FC,$DF,$87,$FE,$70,$3F,$FE
 .db $7F,$FF,$FE,$00,$00,$00,$00,$08,$00,$42,$00,$FF,$FF,$FF,$FF,$C0
 .db $01,$FF,$FF,$83,$DF,$FC,$61,$80,$1C,$00,$00,$00,$00,$18,$0F,$E6
 .db $7F,$FF,$FF,$FF,$FF,$FC,$EF,$FF,$F8,$01,$00,$00,$00,$00,$0C,$76
 .db $00,$7F,$CC,$FF,$FE,$08,$01,$7F,$FF,$C7,$8D,$F8,$FC,$00,$80,$00
 .db $20,$00,$00,$3F,$FF,$4E,$FB,$97,$00,$7F,$FF,$FC,$37,$FF,$C0,$00
 .db $61,$80,$00,$00,$3C,$1D,$8C,$7F,$00,$FF,$FF,$FF,$FF,$FF,$FB,$FF
 .db $9F,$80,$7E,$00,$00,$00,$20,$40,$00,$31,$FF,$FF,$DC,$FF,$03,$FB
 .db $FF,$FE,$7F,$F6,$00,$20,$1F,$D8,$00,$00,$00,$09,$00,$FF,$03,$FF
 .db $F0,$06,$07,$FF,$FC,$EE,$7F,$03,$FE,$00,$00,$00,$00,$00,$00,$77
 .db $FF,$FD,$81,$FC,$07,$F7,$FF,$FF,$8F,$FC,$00,$00,$04,$00,$00,$00
 .db $E3,$01,$8F,$FF,$FF,$FF,$E4,$00,$07,$FF,$FF,$F8,$7F,$8E,$3C,$06
 .db $30,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FE,$63,$20,$FF,$F7,$FF,$FF
 .db $00,$00,$0E,$00,$00,$03,$B0,$00,$00,$7F,$FF,$FF,$FF,$60,$05,$FF
 .db $FE,$0F,$FF,$FF,$F8,$00,$00,$00,$00,$10,$00,$47,$FF,$FE,$7F,$F8
 .db $03,$F7,$FF,$FF,$FF,$FF,$E6,$00,$20,$00,$00,$00,$00,$0F,$3F,$FF
 .db $FF,$FF,$FC,$00,$07,$FF,$FF,$F9,$FF,$84,$60,$04,$00,$00,$00,$C0
 .db $00,$1F,$FF,$FF,$1F,$FC,$87,$FF,$FF,$FF,$FF,$FF,$F1,$00,$E0,$00
 .db $00,$00,$00,$20,$23,$FF,$FE,$07,$F2,$00,$1F,$DF,$EC,$04,$7F,$FF
 .db $FF,$E2,$70,$00,$7F,$39,$DF,$FF,$FF,$FE,$3C,$C0,$00,$07,$F9,$83
 .db $FF,$E3,$E0,$00,$00,$00,$03,$1C,$01,$FF,$3F,$FF,$FF,$FF,$C3,$18
 .db $33,$FF,$F8,$0F,$80,$00,$7E,$05,$CF,$87,$C2,$07,$F0,$00,$7E,$40
 .db $10,$F3,$8C,$3F,$FF,$FE,$FF,$FE,$00,$00,$00,$00,$00,$00,$1F,$FF
 .db $7F,$FC,$1F,$FE,$00,$EE,$00,$0E,$00,$01,$BC,$01,$FF,$FF,$FF,$FF
 .db $FC,$FF,$E1,$FF,$FC,$00,$E8,$00,$00,$00,$3F,$F0,$04,$00,$00,$00
 .db $00,$03,$1F,$FE,$FF,$FF,$FF,$FF,$FF,$FF,$C5,$FE,$FC,$67,$F9,$37
 .db $33,$79,$CF,$FF,$CC,$8B,$E0,$00,$00,$00,$40,$02,$7C,$FB,$FF,$FF
 .db $FF,$FF,$FF,$C7,$FF,$18,$70,$80,$0F,$C0,$37,$E1,$9F,$FF,$FC,$E1
 .db $80,$00,$00,$38,$01,$FE,$23,$FF,$FF,$FF,$F9,$CF,$18,$E3,$0F,$39
 .db $80,$0F,$E6,$1C,$E3,$1F,$7B,$CC,$F8,$00,$00,$00,$00,$43,$CC,$7F
 .db $FF,$33,$FF,$D0,$7F,$FE,$67,$FF,$33,$9F,$B9,$C7,$0C,$E6,$3E,$FB
 .db $8F,$F8,$00,$40,$00,$00,$60,$0F,$39,$9D,$FF,$FE,$FF,$FF,$67,$BF
 .db $81,$3F,$FC,$03,$70,$01,$FF,$F9,$0D,$FC,$40,$26,$E0,$00,$80,$00
 .db $7F,$FE,$7F,$FF,$FF,$FF,$FF,$DF,$FF,$00,$7F,$C8,$04,$63,$04,$7F
 .db $F8,$08,$FC,$FE,$0E,$20,$00,$00,$01,$08,$FF,$9F,$FF,$FF,$FD,$FF
 .db $FF,$FF,$F0,$F1,$C0,$1C,$F3,$9F,$FD,$F8,$1F,$FF,$FC,$E3,$00,$00
 .db $00,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$BF,$FF,$F6,$70,$C0,$00,$00
 .db $FF,$FF,$FE,$18,$FC,$F9,$C9,$F0,$00,$00,$00,$80,$33,$FF,$FF,$FF
 .db $FF,$EC,$1F,$FF,$F3,$F1,$E0,$00,$00,$3F,$FF,$FE,$1C,$38,$31,$E7
 .db $FC,$00,$00,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FB,$F8,$E0
 .db $02,$00,$1F,$FE,$7E,$03,$33,$83,$73,$FF,$00,$00,$00,$00,$00,$3F
 .db $E3,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$DC,$00,$00,$03,$FF,$BF,$80,$03
 .db $87,$3B,$FF,$C0,$00,$00,$00,$00,$1F,$F7,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FE,$1C,$00,$04,$03,$FF,$FF,$80,$00,$0F,$BB,$FF,$F0,$00,$00,$00
 .db $00,$03,$FE,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$00,$FF,$FD
 .db $E0,$00,$0F,$FF,$FF,$F8,$00,$00,$00,$00,$0F,$BE,$1F,$FD,$FF,$FF
 .db $FF,$FF,$FF,$9F,$CF,$E0,$00,$FF,$F0,$C7,$FC,$81,$FF,$C0,$31,$F0
 .db $00,$00,$00,$00,$FF,$F4,$20,$DE,$CF,$FF,$FF,$3F,$FE,$33,$7F,$00
 .db $00,$FF,$E4,$1E,$F8,$00,$FF,$60,$78,$00,$00,$08,$80,$FF,$F8,$E0
 .db $07,$CF,$FF,$FF,$FB,$27,$EA,$7E,$E0,$01,$FF,$C7,$FD,$60,$79,$24
 .db $FE,$F0,$00,$00,$03,$18,$3D,$E0,$71,$CF,$CF,$FF,$FF,$FF,$F8,$00
 .db $FC,$C0,$7F,$FF,$41,$FF,$60,$01,$B6,$00,$38,$C0,$00,$1F,$20,$3F
 .db $F8,$00,$FF,$80,$FF,$FF,$FF,$DE,$70,$78,$21,$B0,$9F,$FC,$00,$78
 .db $00,$FF,$E8,$06,$00,$00,$00,$32,$1F,$39,$F0,$06,$39,$FF,$FF,$F9
 .db $CF,$FC,$77,$30,$01,$FF,$FF,$FF,$10,$00,$8F,$FF,$F7,$00,$00,$00
 .db $44,$07,$BF,$00,$00,$C6,$FF,$FF,$FD,$FF,$C0,$7F,$F0,$08,$09,$FF
 .db $FF,$30,$00,$FF,$FF,$8E,$40,$00,$00,$87,$FC,$63,$E1,$03,$00,$FF
 .db $FF,$FF,$FF,$FD,$3F,$D0,$7F,$80,$3F,$FF,$FE,$00,$21,$F3,$0F,$C0
 .db $00,$00,$01,$B8,$0F,$DC,$F0,$80,$6F,$FF,$FF,$FF,$FF,$CF,$FA,$BF
 .db $C7,$7F,$F0,$00,$00,$13,$FB,$FF,$FF,$00,$00,$00,$00,$01,$DF,$71
 .db $E3,$EF,$FC,$30,$47,$C7,$37,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00
 .db $00,$00,$8F,$7F,$F9,$FF,$FF,$FF,$60,$00,$00,$97,$0C,$7F,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$E1,$FD,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$08,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC
 .db $E7,$FF,$FF,$FF,$1C,$00,$00,$00,$00,$1B,$00,$00,$00,$0F,$DF,$FF
 .db $FF,$FF,$FF,$FF,$CF,$FF,$FF,$FF,$80,$80,$00,$47,$E6,$22,$00,$00
 .db $00,$31,$FF,$9F,$F0,$01,$3F,$FF,$FF,$FF,$FF,$FF,$D3,$00,$7F,$FF
 .db $FF,$E3,$00,$00,$1F,$FC,$41,$80,$00,$00,$00,$7F,$36,$00,$02,$3F
 .db $FF,$FF,$FF,$FC,$20,$06,$00,$7F,$FF,$FF,$F0,$00,$02,$1F,$FC,$63
 .db $E0,$00,$0C,$60,$73,$04,$F7,$9F,$FF,$FF,$FF,$FF,$FF,$FE,$00,$00
 .db $0F,$FF,$FF,$D8,$00,$00,$00,$80,$FC,$C0,$00,$00,$01,$8F,$FF,$FF
 .db $FF,$E0,$04,$FE,$FF,$E4,$40,$6F,$7E,$7F,$60,$07,$FF,$FF,$10,$00
 .db $00,$00,$40,$00,$8E,$20,$01,$FC,$DF,$FF,$FF,$FF,$FF,$F8,$00,$10
 .db $07,$FC,$C4,$04,$67,$FF,$FD,$82,$00,$00,$01,$79,$80,$0C,$80,$27
 .db $FD,$FF,$FF,$F7,$FF,$FF,$FB,$80,$00,$00,$79,$04,$8D,$FF,$FF,$F9
 .db $80,$08,$40,$00,$00,$40,$00,$20,$07,$FF,$FF,$FF,$F7,$EF,$FF,$FF
 .db $C8,$00,$00,$1F,$E3,$0E,$F1,$9F,$FC,$80,$0C,$E0,$00,$10,$00,$00
 .db $00,$46,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$60,$20,$42,$19,$F8,$8E,$D8
 .db $FF,$FF,$FF,$00,$20,$00,$00,$00,$00,$03,$17,$FF,$DF,$FF,$FF,$FF
 .db $8C,$7F,$FF,$FF,$F0,$00,$00,$0F,$FF,$FF,$FF,$FF,$80,$00,$00,$00
 .db $00,$00,$00,$01,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$EC,$08,$00,$01
 .db $9F,$FF,$FF,$FF,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$0F,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$8E,$73,$38,$C0,$A7,$FF,$C4,$7F,$FF,$C3,$38
 .db $00,$00,$00,$00,$00,$0E,$FF,$FF,$FF,$FF,$FF,$F7,$9F,$FF,$FF,$FF
 .db $FF,$0F,$30,$07,$E0,$1F,$FF,$EE,$3F,$E0,$00,$00,$00,$00,$00,$00
 .db $0E,$EF,$FF,$FF,$FF,$FF,$FF,$FF,$F3,$00,$00,$34,$FF,$C0,$0F,$FF
 .db $FF,$1F,$FE,$00,$00,$00,$00,$00,$8F,$FF,$DC,$C0,$FF,$FF,$FF,$FF
 .db $FF,$FC,$80,$00,$00,$04,$E6,$7F,$FE,$FF,$FF,$FE,$00,$00,$00,$00
 .db $00,$00,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$77,$F3,$FF,$FF,$00,$70
 .db $11,$A3,$FF,$FF,$FF,$10,$00,$00,$00,$18,$C3,$BF,$8F,$FC,$7F,$FF
 .db $FF,$FF,$FF,$FD,$9E,$43,$EF,$FC,$FF,$FF,$CD,$00,$00,$00,$00,$00
 .db $00,$00,$00,$33,$FF,$FF,$FF,$FF,$EF,$FF,$BF,$FF,$FF,$F9,$FD,$8C
 .db $02,$05,$18,$A0,$18,$40,$00,$00,$00,$18,$97,$FF,$FF,$FF,$47,$00
 .db $BD,$DF,$F8,$00,$00,$43,$FF,$30,$03,$FF,$FF,$E0,$00,$00,$FF,$FF
 .db $98,$03,$DF,$FE,$00,$00,$0D,$FF,$FF,$C0,$00,$00,$FE,$80,$03,$FF
 .db $FF,$FF,$38,$08,$00,$00,$00,$00,$00,$07,$7F,$FF,$FF,$FF,$FF,$D8
 .db $00,$00,$0D,$FC,$E6,$06,$77,$7F,$FF,$B9,$CF,$FF,$FF,$FF,$77,$1F
 .db $FF,$FF,$80,$80,$00,$00,$00,$00,$00,$0C,$DE,$EC,$0E,$91,$1F,$F7
 .db $3F,$FF,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$EC,$07,$20,$00,$31,$80,$03
 .db $EE,$33,$CE,$00,$0C,$00,$00,$10,$00,$1F,$FF,$FF,$FF,$FF,$FD,$9F
 .db $F3,$00,$00,$00,$00,$8E,$23,$77,$33,$3D,$BB,$00,$06,$33,$3E,$E7
 .db $E6,$63,$FF,$FF,$E6,$1D,$DE,$FF,$C4,$00,$00,$11,$CF,$BB,$C9,$FF
 .db $EF,$CE,$60,$02,$30,$8F,$FB,$EE,$6F,$F1,$FF,$F6,$C0,$3D,$C7,$30
 .db $00,$00,$1E,$67,$FE,$F3,$1F,$98,$85,$FC,$C2,$1E,$FF,$DF,$FF,$80
 .db $7F,$FF,$FF,$F8,$00,$08,$00,$00,$60,$1F,$FD,$CF,$F9,$E0,$00,$21
 .db $81,$EE,$01,$3C,$E7,$FF,$FF,$79,$FF,$FF,$BE,$E0,$00,$00,$0C,$FF
 .db $E7,$9F,$FF,$FF,$E6,$00,$10,$03,$DF,$C8,$08,$3F,$FE,$FF,$FF,$FE
 .db $60,$60,$00,$00,$00,$47,$9F,$FF,$07,$DF,$9E,$FC,$C0,$80,$27,$F3
 .db $19,$BF,$FF,$FF,$FF,$FF,$F7,$04,$00,$00,$00,$01,$CF,$9D,$EF,$FF
 .db $FF,$F3,$80,$02,$00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$A0,$00
 .db $00,$00,$00,$E7,$FF,$FF,$FF,$E0,$00,$00,$00,$04,$19,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FC,$E4,$00,$00,$00,$00,$0E,$FF,$FF,$FF,$FF,$C0,$00
 .db $00,$0C,$79,$FE,$FF,$FF,$FF,$FF,$FF,$FC,$EC,$00,$00,$00,$01,$8E
 .db $FF,$FF,$FF,$FF,$E7,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FC,$00,$00,$00,$00,$06,$3F,$FF,$FF,$FF,$81,$00,$0F,$00,$00,$11
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$07,$00,$00,$00,$00,$03,$FF,$FF,$FF
 .db $FF,$FE,$00,$00,$00,$01,$1E,$FF,$FE,$FF,$FF,$FF,$FF,$18,$00,$00
 .db $01,$80,$1F,$FE,$01,$FF,$FE,$00,$7E,$00,$07,$EF,$F3,$1B,$FF,$88
 .db $FF,$FF,$F0,$3B,$F0,$00,$1C,$70,$00,$FF,$C0,$3F,$FF,$80,$06,$30
 .db $00,$1F,$FE,$7F,$FF,$FF,$3F,$FF,$FF,$F7,$0E,$00,$00,$06,$80,$0C
 .db $F8,$83,$FF,$FF,$79,$F0,$00,$0C,$E0,$F9,$FF,$FF,$FF,$73,$FF,$E6
 .db $07,$F0,$00,$00,$00,$00,$7F,$FF,$FF,$FE,$38,$C0,$04,$00,$00,$3F
 .db $FF,$DF,$FF,$FF,$FF,$FF,$F8,$08,$10,$00,$00,$00,$17,$FF,$FF,$FF
 .db $E0,$0C,$20,$00,$00,$FC,$1F,$FF,$FF,$FF,$FF,$7F,$FF,$FF,$F0,$00
 .db $00,$00,$01,$FF,$FF,$FF,$FF,$31,$00,$18,$C0,$0C,$60,$7F,$FF,$FF
 .db $FF,$FF,$FF,$FC,$EF,$80,$00,$00,$00,$7F,$FF,$FF,$FF,$E0,$00,$07
 .db $00,$00,$00,$73,$FF,$FF,$FF,$FF,$FD,$CC,$46,$F6,$00,$00,$00,$32
 .db $BF,$FF,$FF,$F8,$08,$00,$FE,$C0,$08,$C1,$E6,$7F,$FF,$FF,$E3,$19
 .db $90,$DF,$F0,$00,$00,$00,$C7,$FF,$FF,$3F,$E4,$02,$18,$00,$01,$18
 .db $1F,$FF,$FF,$FE,$C7,$7F,$FF,$33,$D0,$00,$00,$00,$3F,$F8,$07,$FC
 .db $46,$FF,$F3,$00,$01,$00,$7F,$FE,$FB,$9D,$FF,$FF,$FF,$FC,$60,$00
 .db $00,$00,$71,$86,$7C,$C6,$7F,$EF,$C8,$46,$10,$00,$7F,$FD,$DF,$FF
 .db $E6,$FF,$FF,$FC,$00,$62,$00,$00,$7E,$00,$17,$39,$19,$FF,$F3,$08
 .db $98,$00,$0C,$67,$DC,$E7,$FF,$EF,$7F,$FF,$E0,$00,$40,$00,$00,$79
 .db $04,$5B,$0C,$FF,$FF,$FC,$C0,$00,$00,$0E,$FF,$FB,$CC,$FF,$EF,$FF
 .db $FE,$30,$10,$00,$00,$00,$19,$84,$67,$FF,$FF,$FF,$F2,$00,$00,$01
 .db $9F,$FF,$FD,$EE,$77,$87,$3B,$FF,$EC,$00,$00,$00,$03,$FF,$96,$FB
 .db $FD,$8C,$47,$E4,$02,$0D,$FF,$FF,$FF,$31,$8D,$FF,$FF,$FF,$FF,$00
 .db $00,$00,$00,$07,$F9,$CD,$BF,$F8,$ED,$FF,$00,$66,$01,$0F,$FF,$F3
 .db $BF,$FF,$FF,$FF,$F7,$00,$00,$00,$00,$77,$3F,$FF,$FE,$31,$9D,$80
 .db $62,$10,$00,$7F,$FF,$DF,$F7,$FF,$FF,$FF,$F3,$18,$80,$00,$2F,$B6
 .db $31,$88,$89,$84,$60,$40,$27,$FF,$FF,$FF,$FF,$C0,$06,$00,$00,$00
 .db $00,$03,$10,$3F,$FF,$FB,$EC,$E0,$00,$00,$27,$30,$88,$C0,$00,$67
 .db $FC,$EF,$FF,$FF,$FF,$FF,$DF,$E6,$33,$62,$01,$00,$00,$00,$00,$00
 .db $FF,$F0,$88,$00,$00,$00,$00,$CF,$7F,$FE,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$E4,$71,$00,$4F,$1D,$FF,$10,$00,$01,$00,$0F,$FF,$66,$18
 .db $00,$00,$00,$2F,$FF,$FF,$FF,$FB,$FF,$FF,$9D,$DF,$CC,$00,$C6,$62
 .db $20,$01,$8C,$FF,$CF,$FC,$00,$1D,$FF,$FF,$FF,$FC,$10,$00,$00,$00
 .db $FF,$FF,$73,$FF,$3F,$FF,$FF,$F8,$C6,$00,$06,$67,$F8,$06,$40,$0F
 .db $80,$7F,$F0,$18,$E7,$FF,$FF,$FF,$03,$00,$00,$00,$1B,$FF,$CC,$67
 .db $CE,$FF,$FF,$FF,$B3,$F3,$11,$FB,$FE,$00,$10,$CF,$FE,$1F,$E0,$00
 .db $7F,$FF,$FF,$FF,$00,$80,$00,$00,$00,$66,$00,$00,$FF,$FF,$FF,$FE
 .db $FE,$1C,$23,$FE,$39,$C0,$DC,$FF,$FF,$FE,$7F,$19,$88,$FF,$FF,$F8
 .db $FF,$80,$00,$00,$00,$00,$FF,$7B,$FF,$CE,$04,$DF,$FF,$FF,$FC,$A2
 .db $27,$00,$08,$00,$F6,$7F,$F8,$0D,$EF,$FF,$7F,$FF,$78,$00,$00,$00
 .db $00,$00,$7F,$7F,$FF,$CF,$E6,$FF,$FF,$FF,$FE,$20,$41,$B3,$2B,$1F
 .db $7F,$19,$98,$00,$18,$FF,$DF,$7B,$1E,$C8,$00,$00,$00,$00,$3F,$FF
 .db $FF,$E1,$7E,$AF,$FF,$FF,$FF,$6A,$73,$FE,$80,$42,$18,$80,$80,$00
 .db $0C,$3F,$FF,$DF,$FF,$E0,$00,$00,$00,$00,$07,$FD,$FF,$EF,$7F,$BF
 .db $FF,$FF,$FB,$89,$A8,$13,$BC,$C8,$E6,$E4,$E6,$C0,$21,$87,$FF,$37
 .db $FF,$DD,$60,$00,$00,$10,$03,$FF,$7F,$E2,$0B,$A3,$BF,$FF,$FF,$FD
 .db $DC,$C1,$42,$12,$5B,$62,$24,$00,$00,$63,$FF,$BF,$FF,$FE,$98,$00
 .db $00,$00,$00,$3F,$CF,$FC,$E3,$FD,$FF,$ED,$BF,$E8,$4A,$00,$2F,$DF
 .db $E8,$03,$F7,$ED,$00,$0E,$B5,$81,$BF,$FF,$EF,$04,$00,$01,$00,$00
 .db $00,$0A,$49,$FF,$FC,$10,$00,$FF,$FF,$A0,$00,$30,$00,$1F,$FF,$FF
 .db $F8,$C0,$01,$D9,$8F,$FF,$FF,$F8,$00,$00,$00,$00,$00,$0F,$FF,$FE
 .db $78,$00,$7F,$FF,$EF,$E6,$7B,$7B,$BE,$80,$01,$C6,$FF,$3D,$FB,$8F
 .db $FF,$F0,$1D,$98,$40,$00,$00,$03,$77,$F2,$67,$FF,$FF,$FF,$FC,$00
 .db $00,$6F,$FF,$FF,$E0,$04,$7D,$FF,$F8,$0C,$03,$9F,$FF,$FF,$9E,$80
 .db $00,$01,$0E,$30,$00,$00,$6F,$FF,$FF,$FE,$3E,$14,$FF,$FF,$CC,$E4
 .db $C6,$10,$0F,$70,$60,$18,$E6,$7F,$FF,$FF,$E0,$00,$00,$00,$80,$00
 .db $00,$21,$3F,$FF,$FF,$FF,$CC,$0E,$8F,$FF,$90,$31,$31,$CF,$FF,$FF
 .db $80,$00,$00,$0F,$FF,$FF,$C1,$DC,$00,$40,$22,$30,$00,$00,$00,$EC
 .db $7F,$FF,$FF,$FF,$C9,$FF,$EE,$7D,$DF,$80,$C1,$00,$33,$19,$F8,$04
 .db $FF,$FF,$FF,$D6,$00,$00,$0C,$00,$00,$00,$0F,$FF,$FF,$FF,$FB,$FF
 .db $F9,$FF,$9E,$1C,$FF,$E1,$FE,$74,$02,$00,$47,$90,$78,$7F,$FF,$FF
 .db $D0,$00,$00,$00,$00,$10,$88,$00,$07,$41,$7F,$FB,$FF,$FF,$FF,$00
 .db $00,$70,$61,$10,$00,$0E,$07,$FF,$FF,$FF,$FF,$FF,$B0,$00,$00,$00
 .db $00,$79,$8E,$18,$77,$33,$FF,$DF,$FF,$9F,$FC,$E6,$F4,$3F,$98,$FF
 .db $86,$00,$41,$B8,$7F,$EF,$FF,$FF,$FE,$10,$00,$00,$00,$00,$01,$00
 .db $00,$04,$FF,$FF,$FF,$FF,$FF,$70,$00,$07,$BF,$FF,$F3,$00,$30,$1F
 .db $DF,$7F,$FF,$FF,$FD,$80,$00,$00,$00,$08,$40,$00,$0E,$00,$06,$31
 .db $77,$FF,$FF,$FB,$FF,$FF,$FF,$BF,$E7,$B8,$00,$06,$04,$9C,$57,$FF
 .db $FE,$F7,$C3,$00,$80,$00,$00,$00,$00,$00,$00,$8E,$5F,$FF,$FF,$FF
 .db $EB,$FF,$FF,$FF,$98,$8D,$F0,$00,$C6,$3E,$CF,$1F,$FE,$FF,$21,$80
 .db $20,$04,$08,$00,$01,$00,$80,$01,$00,$08,$00,$3C,$3B,$FF,$FF,$FF
 .db $FF,$F7,$9A,$00,$60,$57,$A1,$47,$F7,$96,$00,$80,$00,$00,$00,$00
 .db $19,$BF,$FE,$FF,$D0,$00,$08,$0C,$08,$00,$07,$FF,$FF,$FE,$00,$00
 .db $80,$FD,$90,$87,$FF,$FF,$FF,$FE,$00,$00,$00,$00,$00,$00,$7F,$FF
 .db $FF,$DC,$31,$91,$81,$8C,$08,$CF,$CE,$3F,$73,$99,$23,$BF,$FF,$FF
 .db $FF,$FF,$FF,$FB,$83,$98,$01,$80,$00,$00,$08,$00,$03,$F0,$00,$08
 .db $00,$09,$E3,$3F,$FF,$FF,$FF,$FF,$9F,$FF,$C0,$FF,$E6,$5F,$FE,$0F
 .db $FF,$C4,$01,$FD,$00,$1B,$80,$07,$E4,$01,$A0,$00,$00,$00,$01,$FF
 .db $FC,$FF,$FC,$1F,$FF,$98,$FF,$FF,$0D,$FF,$80,$7F,$DC,$06,$3F,$90
 .db $33,$C8,$03,$FF,$18,$7F,$80,$03,$03,$00,$0F,$FF,$FF,$FF,$F0,$3F
 .db $F8,$7F,$FF,$93,$F7,$F9,$BD,$C6,$10,$04,$00,$08,$C6,$00,$0F,$EC
 .db $0D,$C2,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$FF,$FE,$3B
 .db $FC,$18,$27,$BB,$33,$9F,$00,$00,$00,$03,$18,$00,$00,$00,$04,$3F
 .db $E3,$FF,$F8,$CF,$FE,$EF,$FF,$E7,$FF,$FD,$DF,$FC,$E6,$03,$B0,$00
 .db $F8,$00,$7F,$F2,$0F,$80,$00,$00,$DC,$9F,$FF,$E7,$FF,$11,$FF,$80
 .db $FF,$FF,$FD,$F7,$FE,$23,$F0,$02,$78,$01,$DC,$00,$0B,$62,$00,$1B
 .db $00,$0F,$80,$1F,$FC,$47,$FF,$FF,$FB,$FF,$7F,$FF,$F3,$7F,$C0,$3F
 .db $C0,$08,$E0,$01,$CC,$00,$01,$E4,$01,$E0,$03,$FE,$01,$FF,$FB,$FF
 .db $FF,$FF,$FF,$FF,$FF,$C8,$07,$E0,$03,$9C,$41,$9E,$E3,$19,$C0,$00
 .db $F0,$00,$7F,$00,$FF,$9F,$FF,$BF,$CD,$FF,$EE,$7F,$C4,$3F,$F8,$09
 .db $BC,$00,$07,$80,$0E,$F3,$04,$F8,$00,$60,$00,$03,$FD,$B3,$FF,$E7
 .db $FF,$EF,$FF,$F6,$39,$FF,$30,$DF,$00,$0F,$80,$7F,$F8,$C6,$00,$86
 .db $01,$C6,$03,$FE,$01,$FF,$00,$08,$38,$E6,$78,$C0,$7F,$C1,$3F,$F2
 .db $3F,$F6,$3F,$EF,$FF,$FF,$FE,$F7,$F8,$00,$00,$00,$00,$C0,$07,$FF
 .db $8C,$FF,$80,$7F,$80,$37,$3F,$30,$7F,$F8,$5F,$FC,$00,$00,$06,$63
 .db $FB,$BF,$FF,$FF,$FF,$C0,$43,$00,$0C,$7F,$98,$1F,$80,$3F,$E0,$00
 .db $00,$00,$87,$FF,$8F,$FF,$03,$FF,$C0,$FF,$FE,$1C,$C6,$00,$04,$00
 .db $5F,$FF,$FF,$FF,$FB,$BF,$C0,$00,$00,$00,$04,$00,$7F,$FF,$FF,$FF
 .db $E3,$FF,$00,$FE,$C0,$00,$00,$46,$3F,$E4,$3F,$E4,$1F,$FF,$FF,$FF
 .db $FE,$E7,$F8,$00,$38,$01,$3C,$00,$00,$00,$00,$77,$80,$5F,$80,$27
 .db $FE,$27,$FF,$FF,$FF,$F9,$8F,$F9,$87,$FF,$E6,$1C,$02,$18,$FF,$00
 .db $7F,$80,$7F,$FC,$01,$80,$01,$1C,$E0,$0F,$E0,$0F,$FF,$99,$38,$0E
 .db $33,$FE,$63,$FE,$00,$FF,$D9,$8E,$10,$E7,$3B,$C0,$7F,$C4,$DF,$FF
 .db $10,$60,$00,$27,$FC,$07,$FC,$E1,$FF,$F0,$FF,$E3,$EE,$3B,$C4,$3F
 .db $8C,$1B,$FE,$01,$00,$00,$67,$F8,$07,$FC,$83,$FF,$C0,$7D,$02,$2E
 .db $F3,$30,$7F,$98,$3F,$F8,$C7,$00,$02,$FF,$F6,$7F,$FF,$87,$FB,$8C
 .db $FD,$CF,$FF,$3E,$60,$BF,$8C,$3F,$C0,$00,$00,$06,$FF,$C6,$67,$FC
 .db $03,$FF,$98,$F3,$88,$EE,$7E,$E6,$7F,$20,$3F,$F8,$06,$00,$0F,$FF
 .db $FF,$03,$FB,$07,$FF,$C4,$CF,$FC,$FF,$FF,$C8,$3F,$C0,$7F,$E1,$80
 .db $00,$00,$0F,$FF,$81,$FF,$03,$3F,$7F,$80,$39,$C0,$07,$FF,$E7,$11
 .db $FF,$01,$00,$00,$03,$FF,$7C,$3F,$FF,$F8,$4F,$F8,$86,$E4,$4F,$3F
 .db $C7,$FC,$03,$EE,$10,$00,$00,$1F,$F0,$1F,$FF,$FE,$FF,$81,$70,$1F
 .db $BC,$FF,$FF,$FB,$03,$1F,$81,$FC,$00,$00,$20,$84,$00,$FF,$F7,$FF
 .db $FF,$FF,$80,$73,$8C,$3F,$FF,$7C,$FF,$00,$C0,$00,$43,$1E,$00,$07
 .db $F9,$C0,$64,$3F,$FF,$F1,$FC,$3C,$0C,$FF,$D8,$3F,$FF,$F2,$00,$00
 .db $03,$30,$1F,$FC,$FF,$FF,$78,$03,$9F,$9D,$F8,$06,$FC,$37,$21,$FE
 .db $00,$40,$03,$FF,$FF,$00,$FF,$00,$7F,$81,$FE,$3F,$20,$7F,$01,$FF
 .db $80,$FF,$FC,$00,$00,$00,$0F,$00,$FF,$F8,$0F,$C0,$37,$F9,$3F,$FF
 .db $C0,$1F,$C0,$66,$0F,$FC,$C0,$00,$00,$07,$E0,$F3,$FF,$00,$FE,$04
 .db $FF,$FF,$9F,$F8,$3F,$C3,$9C,$7F,$F8,$BE,$01,$C0,$10,$03,$FF,$DF
 .db $C1,$BE,$01,$F1,$FF,$98,$E0,$9F,$80,$3E,$3F,$E3,$C0,$02,$00,$10
 .db $07,$FF,$F1,$F3,$82,$06,$0F,$FF,$F8,$3B,$F0,$BE,$0C,$FF,$F8,$80
 .db $00,$00,$84,$BD,$FE,$E7,$7C,$64,$83,$FF,$FE,$36,$78,$3F,$F0,$0F
 .db $FF,$03,$1E,$18,$20,$00,$03,$E7,$CF,$C0,$78,$0F,$FE,$FC,$58,$C1
 .db $FF,$F0,$6B,$BF,$0F,$80,$00,$00,$00,$EF,$CC,$F3,$C3,$C0,$39,$FB
 .db $F8,$7E,$0D,$FC,$C3,$BF,$3F,$03,$80,$04,$00,$60,$7F,$F8,$7C,$81
 .db $C0,$03,$FF,$FE,$07,$CF,$BF,$B0,$E0,$FF,$E0,$FF,$00,$40,$0E,$3C
 .db $FE,$07,$00,$1F,$83,$FF,$FF,$E7,$FE,$07,$C0,$18,$7F,$CC,$1F,$C0
 .db $38,$07,$83,$F7,$0B,$FC,$1F,$C1,$FC,$1F,$F0,$3F,$83,$FC,$3F,$FF
 .db $E6,$07,$00,$38,$03,$C0,$FB,$87,$FE,$1F,$E3,$FE,$3F,$E1,$FF,$C1
 .db $E0,$0F,$EF,$F8,$F8,$00,$30,$00,$73,$FC,$3F,$60,$3F,$08,$FC,$7F
 .db $0F,$F9,$1F,$D8,$FF,$FF,$01,$F0,$01,$E0,$01,$C8,$05,$F0,$43,$FF
 .db $7F,$FF,$E0,$F2,$00,$70,$80,$03,$F0,$FF,$FC,$08,$00,$03,$1C,$7F
 .db $FF,$FF,$FF,$F9,$B8,$00,$00,$00,$00,$80,$07,$EF,$FF,$1F,$F3,$FF
 .db $07,$F0,$07,$80,$08,$00,$8F,$FE,$7B,$FF,$FF,$FF,$FF,$FF,$FF,$FE
 .db $00,$00,$00,$00,$00,$02,$00,$01,$80,$00,$0F,$83,$FE,$0F,$F0,$39
 .db $CF,$F9,$FF,$C1,$3E,$01,$C1,$FF,$CF,$FC,$07,$F3,$FF,$FF,$F0,$C7
 .db $00,$00,$00,$00,$CF,$C6,$00,$01,$01,$F0,$3F,$FF,$38,$4F,$FC,$FF
 .db $FF,$FB,$FF,$9F,$E8,$00,$E3,$6E,$31,$00,$1E,$00,$07,$FE,$FF,$FC
 .db $4F,$FF,$F9,$FF,$EF,$FF,$E6,$10,$00,$0F,$FE,$FF,$00,$00,$FA,$00
 .db $FD,$C0,$33,$C4,$43,$E0,$0F,$FE,$7F,$FD,$80,$00,$03,$FC,$C3,$06
 .db $00,$80,$18,$0F,$FF,$11,$C8,$F7,$FF,$FF,$FF,$FF,$E6,$30,$00,$07
 .db $FF,$EC,$C0,$00,$00,$60,$1F,$98,$F8,$86,$7F,$20,$3F,$F8,$FF,$E4
 .db $00,$38,$03,$FF,$F8,$00,$08,$00,$3F,$E0,$00,$3F,$FF,$FF,$CC,$FF
 .db $FF,$13,$DF,$F1,$11,$FE,$1B,$F8,$00,$74,$00,$3F,$F9,$0C,$FF,$FF
 .db $80,$04,$1B,$EE,$7F,$FC,$00,$E7,$7F,$F6,$00,$20,$08,$00,$03,$FF
 .db $F8,$20,$80,$07,$FF,$FB,$00,$FF,$FE,$61,$8A,$7D,$FF,$60,$00,$08
 .db $87,$FE,$CF,$A0,$40,$1F,$FE,$6F,$73,$9F,$FE,$FF,$43,$8F,$9D,$E7
 .db $FC,$00,$70,$07,$8E,$7F,$FB,$00,$FF,$FE,$7D,$FF,$FF,$FC,$C1,$00
 .db $1F,$37,$FF,$E0,$01,$C8,$05,$EC,$03,$FF,$F0,$FD,$E8,$FC,$DD,$FF
 .db $EF,$BB,$18,$7F,$FE,$FF,$C0,$00,$00,$01,$FF,$9F,$C0,$88,$8F,$FF
 .db $FF,$FB,$1F,$FE,$00,$00,$27,$FF,$F8,$00,$00,$00,$3F,$FF,$FE,$03
 .db $22,$3F,$C0,$1D,$FF,$FF,$88,$18,$E0,$FF,$FF,$FE,$00,$00,$00,$00
 .db $03,$FF,$74,$7F,$FF,$FF,$9F,$FF,$00,$7B,$FF,$F0,$04,$1F,$FF,$00
 .db $00,$00,$01,$01,$F8,$9F,$FF,$FF,$E4,$03,$FF,$FF,$FF,$F0,$07,$FF
 .db $FF,$F0,$00,$00,$00,$03,$07,$F8,$00,$3E,$FF,$FF,$FF,$FF,$81,$F2
 .db $00,$00,$0F,$FF,$FE,$00,$30,$00,$00,$0F,$FC,$01,$F3,$9F,$F0,$FF
 .db $FF,$FB,$FF,$98,$00,$3F,$FF,$E0,$00,$00,$00,$08,$3F,$F8,$00,$61
 .db $FF,$FF,$FF,$FF,$11,$02,$03,$B8,$FF,$FF,$F0,$00,$00,$00,$00,$3F
 .db $D0,$03,$86,$3F,$E3,$3F,$FF,$FF,$FC,$40,$06,$FF,$FF,$F8,$01,$00
 .db $00,$00,$0F,$FE,$2F,$8F,$FF,$FF,$FD,$FE,$67,$FE,$00,$00,$FF,$FF
 .db $FC,$00,$00,$00,$43,$FF,$F0,$0E,$00,$70,$43,$FF,$FF,$FF,$F7,$30
 .db $03,$FF,$FF,$E0,$08,$00,$00,$00,$3F,$FF,$7C,$03,$E4,$EF,$FF,$FC
 .db $FF,$FC,$00,$03,$CC,$FF,$E0,$00,$00,$00,$1D,$FD,$C0,$18,$3B,$CF
 .db $1F,$FF,$FF,$FF,$FC,$00,$1F,$FF,$FF,$80,$30,$00,$00,$00,$3F,$FC
 .db $04,$F3,$FF,$FF,$FF,$F9,$F7,$C8,$08,$FF,$40,$EF,$08,$00,$00,$3E
 .db $1F,$B8,$8F,$00,$03,$FF,$EF,$0F,$7F,$7F,$F0,$00,$38,$1F,$FB,$FF
 .db $80,$7D,$80,$00,$00,$39,$9F,$FF,$FF,$FE,$7F,$E0,$00,$00,$00,$00
 .db $03,$6E,$DF,$FF,$FF,$FE,$FF,$00,$20,$00,$7F,$CC,$60,$01,$FF,$FF
 .db $F0,$EF,$EE,$7F,$FF,$8E,$7F,$F9,$97,$00,$00,$40,$00,$64,$00,$00
 .db $22,$7F,$72,$01,$FF,$80,$73,$C6,$3F,$FF,$FF,$FF,$31,$FF,$B8,$0C
 .db $F8,$0C,$80,$8F,$FE,$FB,$1F,$FE,$00,$00,$02,$00,$02,$79,$90,$89
 .db $FF,$9D,$CC,$CC,$66,$1F,$FF,$F3,$D8,$DF,$FB,$8C,$00,$18,$81,$FF
 .db $FF,$22,$33,$FE,$7F,$80,$01,$80,$00,$3F,$E7,$E7,$FF,$EF,$39,$80
 .db $48,$31,$0E,$E7,$00,$27,$F8,$7F,$88,$00,$08,$00,$DF,$73,$8F,$FF
 .db $B8,$E0,$02,$00,$C6,$13,$F7,$00,$27,$F9,$FF,$CC,$20,$00,$21,$3F
 .db $BF,$FF,$FF,$DF,$E8,$CE,$00,$C6,$33,$BB,$20,$1F,$FC,$F7,$CC,$00
 .db $00,$01,$9F,$73,$03,$FF,$DE,$00,$C8,$03,$3A,$23,$F3,$01,$1F,$FF
 .db $EF,$98,$00,$01,$03,$BF,$EF,$3F,$FF,$FF,$F3,$10,$80,$50,$0F,$D8
 .db $00,$7F,$FF,$FE,$60,$00,$00,$13,$FF,$FC,$C7,$FF,$CE,$18,$00,$19
 .db $E3,$3F,$60,$01,$FF,$FF,$F3,$00,$02,$00,$1B,$DC,$FF,$FF,$FF,$FF
 .db $63,$00,$00,$01,$99,$80,$06,$3F,$FF,$FC,$00,$00,$06,$7F,$67,$FB
 .db $0F,$FF,$FF,$00,$02,$40,$3F,$F8,$80,$30,$FF,$FE,$62,$10,$00,$01
 .db $BB,$9F,$FE,$73,$FF,$FF,$20,$10,$08,$FC,$C8,$00,$01,$FF,$FE,$60
 .db $00,$00,$0F,$B3,$1D,$E0,$67,$FF,$CE,$42,$31,$37,$FF,$B1,$09,$86
 .db $7F,$FF,$88,$00,$00,$19,$98,$FF,$F7,$EF,$FF,$FF,$00,$C0,$1F,$B3
 .db $18,$00,$00,$FF,$FE,$60,$00,$01,$B3,$79,$FE,$E2,$37,$FF,$F6,$00
 .db $00,$7F,$FF,$88,$00,$03,$FF,$FF,$20,$00,$00,$80,$CC,$67,$FB,$FF
 .db $FF,$FC,$47,$E0,$00,$0F,$90,$00,$03,$FF,$FF,$C8,$00,$00,$01,$FF
 .db $FF,$F1,$00,$7F,$F0,$DF,$88,$00,$1F,$FF,$FE,$1D,$FF,$EC,$00,$03
 .db $00,$00,$13,$7F,$FF,$FF,$FF,$F0,$0C,$00,$00,$19,$FE,$00,$07,$FF
 .db $FF,$81,$8F,$00,$00,$04,$3F,$CF,$7F,$FF,$80,$00,$10,$01,$FF,$FB
 .db $98,$3F,$FF,$8C,$00,$00,$00,$0C,$FE,$FD,$98,$0F,$FF,$E7,$FF,$E0
 .db $80,$66,$00,$00,$37,$FF,$FE,$00,$00,$00,$19,$FD,$CE,$FC,$EF,$FF
 .db $01,$9F,$F8,$89,$CC,$00,$02,$3F,$FF,$F0,$00,$00,$00,$07,$FC,$FF
 .db $FF,$FF,$FF,$08,$0C,$00,$02,$10,$00,$04,$7F,$FF,$FC,$00,$00,$00
 .db $04,$D0,$EF,$FF,$FF,$FE,$40,$1E,$00,$00,$48,$B8,$39,$FF,$FF,$80
 .db $00,$00,$00,$19,$87,$FF,$FF,$FF,$FF,$C0,$FC,$80,$00,$00,$00,$03
 .db $FF,$FF,$F0,$0C,$00,$00,$00,$00,$0C,$FF,$FF,$FF,$3B,$FB,$00,$00
 .db $00,$C1,$0F,$FF,$FF,$E0,$00,$00,$00,$0F,$3F,$FF,$FF,$FF,$E3,$01
 .db $F0,$00,$11,$A7,$8F,$E3,$FF,$FF,$80,$44,$00,$03,$FE,$00,$5F,$F3
 .db $FF,$CF,$BF,$FC,$00,$71,$E0,$03,$FF,$FF,$FE,$00,$76,$00,$19,$F8
 .db $07,$F8,$07,$FF,$81,$FF,$86,$00,$C0,$1E,$00,$47,$FF,$FF,$EC,$00
 .db $60,$07,$C3,$BC,$7F,$81,$FC,$00,$FE,$0F,$E0,$F8,$0F,$80,$FF,$FF
 .db $EF,$FE,$00,$00,$0F,$C3,$3F,$7F,$9B,$FC,$0F,$EE,$18,$01,$E0,$0E
 .db $03,$E3,$FF,$9F,$F0,$20,$80,$3C,$0F,$F1,$FE,$C7,$E0,$3F,$9E,$0F
 .db $07,$30,$78,$0F,$FE,$7F,$F3,$81,$00,$00,$70,$27,$9F,$C7,$FF,$FF
 .db $FF,$1C,$04,$00,$41,$80,$3F,$FF,$FF,$FE,$08,$60,$03,$38,$1F,$FF
 .db $8D,$FC,$0F,$CF,$F1,$C0,$F0,$1F,$81,$FF,$3F,$FF,$FE,$00,$00,$01
 .db $03,$97,$FF,$C5,$FE,$1F,$EF,$FE,$06,$30,$01,$00,$38,$FF,$FF,$FF
 .db $81,$80,$07,$10,$72,$4F,$9F,$F9,$F1,$FF,$BC,$0C,$47,$0C,$18,$3F
 .db $FB,$FF,$FF,$C0,$00,$00,$3E,$6F,$DF,$FF,$FF,$FF,$38,$C0,$01,$01
 .db $90,$01,$CF,$FF,$DE,$F8,$40,$00,$38,$13,$C0,$FF,$FF,$E7,$FF,$87
 .db $F8,$00,$3B,$F0,$77,$FF,$FF,$FF,$E0,$00,$00,$18,$33,$E1,$67,$FF
 .db $F3,$FF,$87,$00,$00,$00,$70,$07,$E7,$FF,$FF,$F8,$3C,$00,$70,$63
 .db $C3,$FE,$7F,$87,$3C,$FE,$C0,$00,$03,$C1,$DF,$CB,$FF,$FF,$E1,$F0
 .db $01,$E1,$FF,$02,$7C,$FF,$FF,$FC,$FE,$00,$00,$00,$00,$18,$1F,$FF
 .db $FB,$F8,$40,$03,$4E,$E6,$73,$FF,$F0,$F9,$FF,$FE,$38,$00,$00,$06
 .db $41,$CF,$FF,$FF,$FF,$00,$00,$39,$BF,$06,$7F,$C3,$FF,$FF,$FC,$40
 .db $00,$00,$00,$01,$1F,$FF,$FF,$F0,$00,$87,$CE,$60,$3F,$D3,$3C,$3B
 .db $EF,$FF,$00,$20,$00,$06,$04,$3F,$E7,$FF,$E0,$08,$00,$0F,$F0,$9F
 .db $F0,$FF,$FF,$FF,$F8,$00,$0C,$00,$00,$00,$FF,$FF,$FF,$88,$79,$07
 .db $FE,$00,$1F,$C6,$1F,$FC,$FF,$E7,$18,$60,$02,$00,$03,$F9,$DF,$FC
 .db $00,$40,$02,$3F,$E6,$3F,$03,$FD,$FF,$FF,$F8,$01,$80,$0C,$00,$6F
 .db $FF,$FF,$F8,$03,$80,$7F,$E0,$70,$3E,$23,$FE,$C7,$FF,$63,$0E,$80
 .db $0C,$80,$1F,$FF,$FF,$F0,$09,$00,$03,$FF,$79,$DE,$01,$FF,$FF,$FF
 .db $80,$0F,$00,$08,$00,$0D,$FF,$FF,$F0,$0F,$00,$7F,$E7,$23,$FE,$01
 .db $FF,$9C,$FF,$98,$EF,$00,$32,$00,$3F,$B1,$FF,$F8,$47,$E0,$03,$FF
 .db $80,$FF,$80,$7F,$E7,$FF,$F0,$0F,$E0,$00,$00,$03,$FF,$FF,$FE,$01
 .db $FF,$D9,$97,$00,$1F,$E0,$1F,$FF,$C7,$FC,$00,$10,$00,$3F,$F0,$0F
 .db $FF,$03,$E6,$01,$FF,$FC,$87,$00,$3F,$7F,$FF,$FF,$00,$60,$00,$00
 .db $03,$F3,$FF,$FF,$00,$FE,$01,$FF,$90,$07,$D0,$0F,$F9,$0F,$FF,$81
 .db $18,$00,$13,$C8,$7F,$FE,$E6,$F8,$00,$0E,$F0,$FF,$C0,$07,$FF,$FF
 .db $FF,$88,$3B,$00,$00,$00,$07,$FF,$3F,$FE,$00,$7E,$FF,$FF,$C8,$00
 .db $8E,$FF,$FF,$FB,$FF,$F8,$00,$00,$00,$1F,$FF,$FF,$FA,$03,$E0,$01
 .db $FE,$30,$00,$00,$4F,$FF,$FF,$FF,$00,$C0,$00,$00,$07,$01,$FF,$FF
 .db $30,$60,$00,$FF,$80,$3F,$F8,$0F,$FF,$00,$FF,$C0,$01,$80,$09,$FF
 .db $FF,$FF,$80,$00,$3F,$9F,$E3,$80,$00,$7F,$FF,$FF,$FF,$00,$00,$00
 .db $00,$FF,$FF,$FF,$F0,$00,$00,$03,$FF,$E0,$1F,$FD,$FF,$FF,$0B,$FF
 .db $08,$03,$FB,$E0,$07,$FE,$00,$FF,$FE,$00,$00,$04,$3F,$FF,$00,$0F
 .db $FE,$FF,$FC,$00,$1F,$E1,$00,$03,$FF,$FF,$FF,$F0,$00,$00,$FE,$6E
 .db $67,$A0,$0F,$FF,$FF,$FE,$CC,$00,$07,$E0,$01,$F1,$07,$FF,$FB,$80
 .db $03,$E0,$00,$7F,$FF,$FF,$FF,$FF,$9C,$00,$00,$0C,$00,$DF,$CF,$FF
 .db $FF,$F8,$00,$03,$C8,$18,$FF,$FE,$63,$3F,$FF,$F4,$01,$30,$00,$00
 .db $1F,$FF,$FF,$FF,$FC,$00,$07,$00,$FF,$FF,$FB,$8C,$DF,$FF,$F0,$00
 .db $70,$00,$00,$17,$FF,$FF,$FF,$F9,$80,$0C,$C0,$02,$F7,$E7,$FF,$7F
 .db $FF,$C0,$00,$C0,$00,$00,$FF,$E7,$FF,$FD,$F8,$00,$1F,$FF,$FF,$FF
 .db $8C,$37,$FF,$FF,$E0,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$E0,$00,$3C
 .db $01,$07,$1C,$75,$FD,$FF,$FF,$C0,$06,$00,$00,$03,$FD,$07,$FF,$FF
 .db $F0,$00,$06,$70,$7F,$FF,$F3,$FF,$FF,$FF,$80,$00,$00,$00,$07,$F7
 .db $FF,$FF,$FF,$F0,$00,$00,$80,$4F,$FB,$99,$83,$FF,$FF,$F8,$01,$00
 .db $00,$00,$60,$0F,$FF,$FF,$E0,$00,$00,$81,$FF,$FF,$FB,$1F,$FF,$FF
 .db $00,$00,$00,$00,$1F,$FF,$FF,$FF,$FF,$E0,$00,$02,$00,$38,$0C,$7F
 .db $DF,$FF,$FF,$C0,$00,$00,$00,$73,$F9,$0F,$FF,$FF,$00,$00,$4F,$FF
 .db $FF,$F0,$71,$FF,$FF,$FE,$01,$90,$00,$00,$07,$FF,$FF,$FF,$FF,$80
 .db $00,$18,$00,$EF,$08,$F3,$EF,$FF,$FF,$C7,$70,$00,$00,$0F,$C0,$03
 .db $FF,$3F,$80,$03,$FF,$FF,$FF,$E7,$03,$FF,$FF,$F8,$07,$C0,$00,$00
 .db $37,$F0,$9F,$FF,$FE,$00,$00,$64,$01,$8E,$61,$07,$DF,$FF,$FE,$1E
 .db $00,$00,$00,$06,$00,$7F,$FF,$FC,$00,$01,$FF,$D0,$5F,$FE,$DF,$FF
 .db $FF,$E0,$02,$00,$00,$00,$1F,$FF,$FF,$FF,$F8,$00,$00,$06,$00,$3F
 .db $FF,$FE,$3F,$FF,$FD,$EE,$20,$00,$00,$00,$01,$FF,$FF,$F8,$00,$00
 .db $33,$00,$3F,$FF,$FF,$FF,$FE,$00,$0C,$00,$00,$00,$7F,$FF,$FF,$FF
 .db $E0,$00,$00,$30,$00,$20,$8F,$F7,$FF,$FF,$F6,$78,$20,$00,$00,$00
 .db $07,$FF,$FF,$80,$00,$01,$FF,$01,$FF,$FF,$FF,$FF,$FC,$00,$20,$00
 .db $00,$00,$01,$FF,$FF,$FF,$F0,$00,$00,$00,$00,$CF,$FF,$FF,$FF,$FF
 .db $00,$30,$7F,$C0,$00,$00,$1F,$FF,$FC,$00,$00,$07,$FF,$F3,$C3,$BF
 .db $FF,$FF,$FE,$40,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$80,$00,$00,$00
 .db $00,$3F,$FC,$79,$FF,$FF,$F8,$10,$C0,$00,$00,$00,$BF,$FF,$FF,$E0
 .db $18,$00,$38,$00,$04,$FF,$FF,$FF,$FB,$FF,$9E,$00,$00,$00,$07,$FF
 .db $9F,$FE,$03,$FF,$FF,$38,$60,$00,$00,$23,$7F,$FF,$FF,$FF,$22,$00
 .db $00,$00,$3F,$FF,$FF,$00,$00,$FF,$FE,$00,$00,$FF,$FF,$FF,$E6,$0C
 .db $7F,$F8,$00,$00,$0F,$FF,$FF,$FE,$01,$0F,$BF,$FF,$03,$38,$00,$00
 .db $7F,$F3,$DF,$98,$FF,$E0,$E0,$18,$40,$0E,$00,$00,$03,$FF,$FF,$C6
 .db $7F,$FF,$F7,$FF,$00,$00,$FD,$80,$00,$00,$1F,$FF,$FC,$00,$00,$0F
 .db $DF,$84,$07,$FD,$F8,$07,$FF,$FF,$FF,$FF,$FE,$00,$00,$00,$7F,$FF
 .db $FF,$C0,$00,$1F,$80,$00,$FF,$C1,$FF,$FF,$FF,$FF,$FF,$F0,$00,$00
 .db $0F,$FF,$FF,$C7,$FF,$FF,$F0,$00,$00,$00,$00,$1F,$00,$FF,$FF,$C0
 .db $00,$10,$00,$07,$FF,$81,$C3,$80,$00,$03,$FF,$FF,$FF,$F0,$1F,$F1
 .db $FC,$00,$FF,$00,$00,$00,$7F,$FF,$FF,$00,$00,$F0,$00,$7F,$FF,$FF
 .db $FE,$00,$03,$FF,$C1,$FF,$F8,$01,$DC,$00,$07,$3F,$FF,$C0,$00,$07
 .db $FC,$47,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$00,$07,$FF,$FF,$FF
 .db $FF,$C0,$00,$00,$3F,$FF,$C8,$00,$03,$FF,$FD,$FF,$FF,$FF,$F9,$CC
 .db $E0,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00
 .db $00,$07,$FF,$FF,$E0,$00,$00,$07,$FF,$FF,$84,$00,$00,$01,$FF,$FF
 .db $FF,$F8,$02,$00,$03,$00,$00,$03,$FF,$FF,$FF,$FF,$C0,$00,$00,$00
 .db $00,$C1,$C0,$C7,$FF,$EF,$FF,$E4,$CF,$87,$39,$3F,$00,$00,$38,$3F
 .db $FF,$E7,$F7,$FE,$1F,$FF,$F3,$F9,$00,$03,$00,$39,$00,$00,$00,$0F
 .db $E8,$00,$C0,$00,$0C,$3C,$F0,$FF,$DF,$EF,$FC,$F5,$DF,$DF,$FF,$F8
 .db $E4,$FF,$0F,$FF,$FB,$FF,$EC,$04,$E0,$C3,$DA,$01,$01,$80,$C0,$00
 .db $00,$01,$FF,$CF,$FF,$E4,$FF,$F1,$02,$38,$23,$9F,$FF,$BC,$BD,$E3
 .db $0F,$3C,$00,$FC,$83,$FE,$6C,$7E,$E8,$01,$6C,$FF,$BD,$FF,$9E,$5F
 .db $E1,$00,$00,$00,$31,$E3,$FF,$FE,$7E,$C3,$80,$20,$1E,$30,$FF,$C0
 .db $7D,$C4,$9D,$C3,$0E,$7E,$7D,$FD,$07,$B0,$00,$10,$03,$9E,$3D,$FF
 .db $FF,$FF,$FF,$7F,$7C,$F3,$CE,$1F,$43,$28,$F1,$06,$9C,$00,$F8,$6C
 .db $FE,$04,$16,$00,$00,$0C,$1C,$96,$FD,$E3,$DF,$FC,$85,$90,$01,$F8
 .db $0F,$30,$60,$8F,$FB,$FB,$01,$7B,$FF,$FF,$F3,$FF,$E0,$00,$00,$00
 .db $73,$FF,$BD,$FF,$FC,$01,$C2,$00,$7F,$81,$FF,$F0,$1F,$FF,$C0,$00
 .db $00,$C1,$FF,$C2,$0B,$E0,$00,$08,$00,$3F,$FF,$FF,$FF,$FF,$BB,$F8
 .db $00,$9F,$00,$3F,$B0,$01,$BF,$00,$00,$08,$71,$FF,$FF,$3D,$F0,$00
 .db $00,$00,$07,$FF,$FF,$FF,$FF,$FF,$F9,$60,$01,$03,$FF,$F0,$00,$3D
 .db $FF,$F2,$1E,$F0,$FF,$FF,$F2,$78,$00,$00,$00,$01,$FF,$FF,$86,$3F
 .db $FF,$FF,$F0,$80,$00,$3F,$FF,$F8,$00,$08,$00,$67,$FC,$67,$8F,$C7
 .db $FF,$C0,$00,$00,$00,$1F,$FF,$FF,$FF,$DC,$FF,$FE,$7C,$00,$02,$33
 .db $FF,$BC,$04,$00,$01,$FE,$7F,$FF,$E0,$77,$70,$10,$00,$00,$0D,$FF
 .db $FF,$3F,$F0,$1B,$FB,$3F,$E1,$83,$18,$71,$DF,$FF,$E0,$00,$30,$3B
 .db $FF,$F8,$00,$00,$18,$C0,$00,$00,$7F,$FF,$FF,$FB,$FF,$9E,$0F,$FF
 .db $FF,$FC,$00,$00,$0F,$FE,$00,$00,$00,$FF,$FC,$FF,$40,$00,$00,$C0
 .db $E4,$1F,$F0,$1F,$FF,$F9,$DE,$63,$06,$7F,$FF,$F8,$80,$0B,$83,$1F
 .db $FE,$00,$0F,$E7,$FF,$F0,$0F,$C0,$07,$F0,$FF,$80,$BF,$F1,$F7,$F0
 .db $78,$F0,$33,$FC,$10,$FE,$00,$7F,$0C,$3E,$78,$40,$3F,$FF,$B0,$78
 .db $00,$0F,$D9,$B4,$7E,$C1,$FC,$DD,$90,$FE,$C0,$FF,$DD,$BC,$F8,$03
 .db $C0,$1C,$1C,$DC,$81,$FF,$FF,$80,$F8,$00,$87,$9C,$F0,$FC,$01,$C1
 .db $1E,$08,$FD,$E5,$FF,$BF,$F0,$FC,$06,$C0,$1C,$00,$7E,$00,$FF,$FF
 .db $00,$F6,$00,$FF,$FF,$E0,$3C,$00,$02,$37,$30,$13,$E1,$7F,$FF,$FE
 .db $FB,$90,$0E,$23,$C8,$0F,$80,$3F,$FF,$E9,$8D,$80,$1F,$BF,$F0,$06
 .db $80,$00,$00,$E7,$97,$FA,$7F,$FF,$F2,$C3,$60,$04,$E0,$3E,$23,$F0
 .db $0F,$FF,$FD,$20,$B0,$03,$FF,$FC,$10,$90,$00,$29,$0F,$B8,$F9,$BF
 .db $F7,$FE,$0C,$58,$F0,$FF,$8F,$0F,$78,$3C,$FF,$C7,$06,$3E,$30,$FF
 .db $FF,$07,$10,$00,$1B,$07,$F3,$FF,$3F,$E7,$FF,$9F,$CF,$D8,$3F,$F7
 .db $83,$F0,$0E,$0F,$F1,$C0,$23,$00,$3F,$FF,$C9,$88,$00,$00,$00,$C1
 .db $FE,$9F,$B3,$FF,$ED,$EE,$9C,$80,$00,$00,$64,$1F,$FF,$FF,$FF,$FE
 .db $00,$00,$00,$00,$04,$00,$08,$03,$E3,$FF,$BF,$FF,$FF,$E1,$8F,$84
 .db $1E,$03,$C1,$FD,$00,$3F,$FF,$FB,$FF,$FF,$FF,$FF,$E3,$B9,$80,$00
 .db $00,$00,$18,$01,$9A,$7F,$83,$0F,$C0,$3F,$2F,$87,$FF,$61,$3F,$FF
 .db $FE,$7F,$C9,$FF,$FF,$FE,$FF,$E0,$34,$00,$00,$3E,$40,$FF,$FF,$0C
 .db $0C,$C0,$7F,$06,$04,$7C,$C0,$BF,$FF,$FF,$7F,$C0,$CC,$1F,$FD,$FF
 .db $80,$10,$00,$00,$3C,$C7,$FF,$FF,$BD,$FF,$E0,$7F,$DE,$0F,$FF,$64
 .db $7F,$FF,$3E,$1E,$00,$07,$3F,$FF,$FF,$C0,$1E,$00,$00,$0F,$04,$7F
 .db $F3,$FC,$1F,$F8,$0F,$FE,$60,$F7,$C0,$01,$FF,$FF,$01,$FF,$C0,$03
 .db $FF,$F9,$FF,$0E,$20,$10,$8E,$EF,$FE,$7E,$6F,$F7,$FF,$7F,$70,$00
 .db $7F,$FF,$E0,$02,$1E,$01,$FF,$F8,$00,$27,$FC,$1C,$7F,$C0,$00,$01
 .db $01,$FF,$FF,$BF,$FE,$3F,$DF,$C0,$00,$1F,$FF,$FF,$C4,$03,$03,$04
 .db $FF,$FF,$FF,$FF,$00,$00,$00,$02,$04,$FF,$F8,$07,$E7,$1F,$98,$19
 .db $00,$3B,$FC,$07,$FF,$08,$3F,$30,$00,$07,$80,$3F,$F8,$77,$FE,$00
 .db $00,$00,$FF,$FF,$5E,$FF,$F8,$FF,$FE,$0C,$FE,$C0,$01,$8E,$08,$5B
 .db $DB,$81,$FC,$08,$FF,$FF,$FF,$80,$10,$00,$00,$03,$FD,$F7,$FF,$E3
 .db $FF,$F8,$3F,$F9,$10,$7B,$72,$02,$10,$79,$F7,$F0,$03,$80,$37,$FF
 .db $E0,$4C,$00,$00,$03,$E6,$67,$FF,$FF,$FF,$F1,$FF,$FC,$03,$FC,$E4
 .db $06,$E0,$00,$07,$F0,$17,$FE,$07,$FF,$F0,$00,$40,$00,$07,$FF,$F9
 .db $FF,$F6,$3F,$FF,$FF,$FF,$10,$7F,$0C,$00,$0F,$1F,$9E,$C0,$80,$0F
 .db $FF,$FF,$F8,$00,$00,$00,$1B,$FF,$FF,$FF,$FF,$F9,$FF,$FE,$3E,$F8
 .db $EF,$FE,$40,$8E,$FF,$FA,$00,$00,$00,$07,$FF,$FF,$10,$00,$00,$00
 .db $7F,$FF,$FF,$CB,$06,$7B,$FF,$DF,$F3,$1F,$FF,$EC,$33,$F0,$00,$00
 .db $06,$06,$67,$3F,$FD,$84,$00,$00,$00,$07,$1F,$FF,$E7,$FB,$FF,$FF
 .db $E7,$FF,$EE,$60,$70,$07,$23,$EF,$CC,$7E,$00,$00,$FF,$FB,$FC,$00
 .db $00,$00,$00,$2F,$F3,$FF,$01,$FF,$BF,$FF,$FF,$FF,$E4,$00,$13,$00
 .db $00,$00,$33,$FF,$FD,$FF,$FF,$80,$00,$00,$00,$00,$1F,$F9,$8C,$17
 .db $FF,$FF,$F8,$3D,$8C,$CE,$00,$1E,$E2,$35,$1D,$DE,$00,$00,$9F,$FF
 .db $FE,$1C,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$3F,$30,$FF,$FF,$FE,$0F
 .db $E6,$00,$00,$46,$20,$07,$03,$FF,$FF,$80,$0E,$18,$E0,$01,$80,$00
 .db $40,$1F,$FF,$FF,$FF,$FF,$C7,$C0,$3F,$FF,$FC,$00,$C4,$00,$00,$13
 .db $FF,$FF,$FF,$7F,$E0,$00,$00,$00,$7F,$FF,$FF,$FF,$FF,$DF,$FE,$7F
 .db $83,$1F,$F9,$80,$00,$E3,$FF,$FD,$8C,$E0,$00,$C0,$C6,$3E,$00,$00
 .db $00,$00,$00,$EF,$FF,$FF,$FF,$FF,$EF,$01,$FF,$BF,$E0,$07,$30,$17
 .db $80,$01,$FE,$FF,$00,$F8,$00,$00,$00,$07,$FC,$E2,$7F,$E0,$00,$7E
 .db $FF,$FF,$D0,$7F,$FE,$49,$67,$83,$3F,$F0,$02,$0E,$00,$03,$80,$02
 .db $FF,$FF,$FF,$FD,$FF,$C0,$00,$00,$00,$00,$0F,$F3,$FF,$FC,$27,$FC
 .db $03,$FF,$6C,$E4,$80,$03,$00,$08,$B0,$1F,$FF,$F7,$9B,$FF,$FE,$FF
 .db $FF,$A1,$FF,$00,$03,$A4,$00,$26,$00,$19,$9E,$00,$13,$00,$03,$73
 .db $C3,$7F,$F3,$FF,$FF,$F7,$FF,$FF,$FF,$FF,$F8,$F7,$E3,$18,$7C,$CE
 .db $00,$F3,$00,$00,$00,$00,$6E,$C0,$43,$18,$F3,$8F,$BF,$FF,$FF,$FC
 .db $DB,$FF,$0C,$70,$47,$30,$FB,$F9,$00,$88,$00,$04,$20,$FF,$FF,$FB
 .db $EF,$FC,$7F,$FF,$FC,$F7,$CE,$37,$F8,$1F,$00,$7B,$F9,$1F,$E3,$80
 .db $00,$00,$00,$3B,$C4,$3F,$FE,$3F,$FF,$F9,$F9,$9C,$F0,$E3,$5C,$01
 .db $DC,$01,$8F,$FF,$FC,$0C,$00,$00,$30,$07,$FE,$67,$FF,$FF,$FE,$7F
 .db $FB,$FF,$FC,$C0,$E0,$06,$30,$7C,$02,$7F,$E3,$7F,$60,$00,$00,$00
 .db $FF,$F6,$7F,$FF,$9F,$FF,$C4,$3F,$C0,$7F,$FF,$30,$7B,$C6,$3F,$FC
 .db $0F,$E8,$04,$70,$00,$01,$9C,$C7,$FF,$CF,$FF,$EE,$FF,$F8,$1C,$10
 .db $83,$1F,$F0,$01,$F8,$19,$FF,$81,$9C,$01,$00,$00,$00,$30,$63,$7F
 .db $F3,$FF,$FE,$3F,$FF,$87,$1C,$31,$9F,$FC,$00,$66,$0F,$FE,$E3,$C0
 .db $00,$00,$00,$00,$1F,$73,$FF,$FF,$CF,$E0,$03,$C6,$F7,$E7,$FE,$1C
 .db $FF,$80,$10,$03,$FF,$FC,$00,$00,$00,$02,$E2,$79,$FF,$EF,$FF,$DF
 .db $D9,$89,$1F,$FE,$30,$00,$00,$7B,$E3,$7F,$FF,$87,$CC,$00,$00,$00
 .db $0F,$FF,$9D,$BF,$B1,$FF,$FF,$FF,$F9,$C3,$8F,$F8,$27,$C0,$0F,$FF
 .db $FF,$FF,$00,$00,$00,$00,$3D,$81,$FF,$FB,$3F,$BD,$FF,$FF,$E6,$07
 .db $E0,$0F,$7F,$81,$81,$01,$3B,$FF,$0E,$20,$00,$00,$F0,$01,$A0,$0E
 .db $FF,$E3,$FF,$FF,$FF,$FF,$06,$00,$01,$FF,$F8,$00,$3C,$64,$7F,$F0
 .db $F0,$80,$00,$3F,$83,$87,$00,$3F,$FF,$EF,$FE,$67,$7C,$78,$39,$F8
 .db $00,$FF,$E0,$E3,$E0,$EF,$FC,$00,$00,$00,$0F,$FE,$9F,$FC,$F7,$FF
 .db $F0,$E0,$C8,$3D,$FF,$C1,$FF,$E0,$22,$20,$07,$FF,$62,$07,$00,$00
 .db $00,$1D,$FF,$EF,$FF,$FE,$7F,$FF,$11,$FE,$1C,$1F,$FC,$00,$0C,$00
 .db $FF,$F0,$78,$F0,$00,$00,$00,$02,$00,$6F,$FF,$FF,$FF,$FF,$FF,$D8
 .db $00,$2F,$09,$FF,$CC,$7F,$06,$3C,$FF,$08,$00,$00,$03,$FC,$1D,$FF
 .db $FF,$FF,$FF,$3F,$FF,$10,$FF,$81,$F0,$E0,$4F,$E7,$01,$FF,$C0,$7F
 .db $C0,$00,$00,$00,$3F,$C6,$1F,$FE,$3F,$FF,$FF,$FF,$FC,$1C,$FF,$01
 .db $F8,$00,$3F,$FF,$FC,$FF,$90,$00,$00,$00,$00,$07,$FF,$FF,$FB,$FF
 .db $FF,$FF,$86,$07,$03,$FF,$C0,$1F,$0E,$0E,$7F,$DC,$7C,$00,$00,$00
 .db $02,$18,$C7,$FF,$FF,$9F,$FF,$E3,$FF,$C8,$FD,$B1,$C7,$E3,$00,$01
 .db $C1,$FF,$FF,$0F,$00,$00,$00,$00,$1E,$38,$FF,$FF,$FF,$FF,$F9,$FF
 .db $FC,$00,$11,$F0,$CC,$70,$7F,$FF,$F3,$FF,$C0,$00,$00,$1F,$8F,$80
 .db $83,$FF,$FF,$FF,$FF,$FF,$63,$9E,$78,$60,$00,$03,$9F,$FD,$83,$FC
 .db $00,$00,$00,$00,$00,$71,$FF,$F7,$3B,$FF,$E7,$FF,$E0,$FF,$60,$00
 .db $18,$00,$0F,$F8,$7F,$FF,$C0,$00,$00,$00,$00,$C3,$8F,$E3,$FF,$FF
 .db $FF,$FF,$FF,$1E,$7C,$0B,$78,$86,$00,$7F,$FF,$E6,$06,$20,$00,$00
 .db $18,$00,$00,$07,$FF,$FF,$FC,$FF,$FF,$FC,$23,$F1,$EB,$FC,$00,$0E
 .db $1D,$DF,$FF,$FA,$00,$00,$00,$1F,$19,$58,$07,$FF,$FF,$FF,$FF,$EE
 .db $3E,$02,$30,$01,$FF,$F6,$7F,$F0,$3F,$01,$F0,$01,$00,$00,$00,$00
 .db $07,$FF,$FF,$FF,$E7,$02,$07,$FF,$FF,$BC,$60,$00,$03,$FF,$FF,$FF
 .db $FE,$00,$00,$00,$00,$03,$FF,$FF,$FF,$8F,$FF,$FF,$FF,$FF,$FE,$00
 .db $00,$01,$FF,$FF,$FF,$0E,$3F,$80,$00,$00,$00,$00,$07,$FB,$7F,$FF
 .db $FF,$FF,$FB,$F9,$BC,$FE,$7F,$FF,$80,$30,$0F,$DC,$7F,$F0,$00,$00
 .db $00,$01,$FF,$27,$9F,$83,$FF,$FF,$FF,$D1,$7F,$D8,$03,$F8,$07,$C3
 .db $F1,$F1,$83,$F3,$8F,$03,$03,$00,$06,$06,$1E,$1C,$7E,$3B,$FF,$FF
 .db $F8,$61,$F8,$C3,$E3,$CF,$C0,$06,$01,$9F,$39,$FF,$30,$78,$00,$00
 .db $01,$F1,$3F,$FC,$7F,$FC,$1F,$C1,$BF,$84,$C5,$E1,$FF,$0F,$FF,$7F
 .db $FC,$40,$00,$00,$00,$00,$06,$7F,$C7,$FF,$DF,$FF,$FF,$FF,$07,$9E
 .db $38,$E0,$F6,$7C,$1F,$F1,$03,$00,$F1,$F0,$FF,$94,$06,$03,$01,$00
 .db $00,$0E,$FF,$FF,$FF,$FF,$FE,$DE,$FE,$1F,$FF,$07,$F8,$18,$00,$02
 .db $0E,$0F,$40,$0E,$64,$FC,$FF,$1F,$FD,$C3,$C4,$E0,$00,$0D,$83,$FF
 .db $BF,$FF,$F8,$7D,$33,$43,$9E,$39,$F0,$21,$13,$1B,$B1,$E3,$E0,$00
 .db $64,$FF,$DF,$FB,$F7,$FF,$00,$00,$00,$03,$C0,$FF,$3F,$F9,$F7,$F7
 .db $07,$F8,$3F,$E3,$DF,$5C,$18,$00,$EC,$0C,$F8,$F1,$FF,$FF,$FF,$FF
 .db $EF,$C1,$C0,$00,$00,$00,$3B,$1F,$FF,$FE,$FD,$FD,$D8,$79,$C3,$8F
 .db $70,$F1,$E3,$CE,$7E,$71,$E7,$FE,$04,$77,$CF,$BF,$F9,$F0,$30,$00
 .db $00,$00,$03,$83,$FF,$FE,$70,$FF,$FE,$7F,$F9,$FF,$FE,$7F,$60,$66
 .db $07,$00,$9F,$FF,$26,$60,$EF,$CF,$3C,$71,$21,$80,$00,$00,$01,$CF
 .db $FF,$FF,$FF,$FF,$FE,$60,$E0,$00,$00,$00,$00,$27,$87,$9F,$FF,$FF
 .db $8E,$3C,$FB,$C7,$9F,$FE,$24,$E0,$00,$00,$3F,$3F,$FF,$FF,$FF,$FF
 .db $FF,$F3,$FF,$00,$01,$80,$00,$00,$00,$00,$00,$01,$E7,$02,$73,$FF
 .db $FF,$BF,$FF,$7C,$60,$02,$78,$F3,$FD,$FF,$FF,$FF,$C1,$BF,$F3,$DF
 .db $04,$7C,$00,$02,$C0,$18,$00,$00,$26,$1E,$20,$FF,$77,$FF,$FF,$F8
 .db $00,$00,$00,$00,$03,$E3,$FE,$E1,$FC,$7F,$FF,$1F,$FF,$F9,$F8,$B1
 .db $F9,$03,$70,$1F,$F6,$0F,$C8,$FF,$FC,$EF,$CC,$FC,$80,$00,$00,$00
 .db $07,$E6,$7F,$E0,$67,$FE,$7E,$E6,$04,$0E,$7C,$C1,$CC,$00,$40,$00
 .db $0F,$F8,$C7,$9C,$ED,$FF,$FF,$9F,$F8,$00,$00,$01,$F3,$3F,$F7,$7F
 .db $FF,$FF,$7F,$E7,$80,$00,$42,$C4,$8E,$EC,$01,$DD,$18,$93,$10,$11
 .db $FF,$FF,$9E,$78,$C0,$00,$00,$31,$03,$19,$11,$FF,$FF,$3B,$FF,$E5
 .db $10,$61,$FB,$FF,$FE,$A0,$00,$3F,$F0,$FF,$00,$1C,$F8,$F3,$1F,$FF
 .db $80,$00,$00,$00,$13,$FF,$83,$FF,$B1,$1F,$F9,$3D,$C0,$0F,$FC,$FB
 .db $9F,$10,$3B,$F0,$01,$80,$13,$FF,$7F,$F9,$1F,$FF,$C0,$00,$00,$00
 .db $FF,$C0,$05,$87,$DF,$D9,$F9,$BF,$FF,$F9,$80,$33,$90,$3C,$FF,$88
 .db $00,$40,$C7,$FF,$FF,$FF,$FF,$EC,$6C,$27,$80,$00,$30,$03,$FF,$FE
 .db $79,$C6,$C6,$3F,$FF,$E6,$06,$7F,$78,$07,$FF,$10,$60,$40,$07,$DF
 .db $FF,$FF,$9F,$FF,$FF,$FF,$80,$00,$00,$01,$FF,$F8,$07,$FF,$33,$FF
 .db $FF,$90,$3F,$E1,$9C,$01,$FB,$87,$00,$10,$10,$BF,$FF,$FF,$FF,$7F
 .db $7F,$FB,$00,$00,$00,$03,$86,$3C,$7F,$FF,$77,$FF,$E3,$E2,$07,$FF
 .db $FF,$F4,$00,$23,$C0,$0C,$07,$C1,$1F,$FF,$FF,$FF,$FC,$C0,$C0,$00
 .db $00,$01,$E4,$07,$CE,$7F,$FF,$FF,$FC,$EE,$C0,$1F,$FF,$F8,$00,$00
 .db $00,$07,$FF,$E4,$08,$4D,$FF,$FF,$FE,$00,$40,$00,$00,$00,$E0,$02
 .db $60,$7F,$FF,$FF,$FB,$FF,$C8,$01,$FF,$BC,$00,$81,$80,$03,$1F,$FF
 .db $C0,$46,$EF,$FF,$FF,$FE,$00,$00,$00,$31,$3B,$00,$00,$1F,$FF,$FF
 .db $FF,$FC,$03,$C7,$7F,$FE,$00,$00,$46,$11,$C7,$3E,$18,$0F,$FF,$FF
 .db $FF,$E6,$30,$08,$00,$00,$21,$BB,$80,$06,$1C,$FF,$FF,$FF,$F0,$00
 .db $0F,$FF,$F9,$E0,$00,$00,$07,$FF,$9E,$20,$7F,$FF,$FF,$FF,$C0,$00
 .db $00,$00,$28,$FD,$80,$00,$07,$FF,$FF,$FF,$FF,$E0,$01,$FF,$FF,$FC
 .db $00,$00,$00,$03,$FF,$BF,$BF,$7F,$FF,$FF,$FC,$00,$00,$00,$00,$06
 .db $EE,$60,$03,$9F,$FF,$FF,$FF,$FF,$80,$FF,$BF,$FF,$09,$00,$00,$00
 .db $0F,$F9,$CF,$FF,$F8,$0F,$F8,$03,$FC,$00,$00,$00,$3F,$80,$1F,$CF
 .db $FF,$FF,$FF,$FF,$FF,$EF,$BC,$7F,$80,$1C,$C0,$00,$00,$0C,$3F,$FF
 .db $FF,$FF,$FC,$80,$18,$C0,$00,$30,$03,$FD,$80,$DF,$E0,$1F,$FF,$9F
 .db $FF,$C2,$7F,$DC,$09,$F0,$00,$3E,$20,$73,$3F,$3F,$FF,$8B,$BF,$80
 .db $03,$C0,$04,$F0,$01,$1F,$10,$61,$7F,$FF,$FF,$FF,$FC,$00,$00,$00
 .db $00,$00,$00,$04,$00,$7F,$FF,$FF,$FF,$FF,$CC,$00,$00,$20,$00,$00
 .db $01,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$FF,$00,$F7,$11,$02,$00,$00,$00
 .db $00,$01,$80,$0F,$FB,$BF,$FF,$FB,$FF,$D8,$0B,$C4,$11,$FE,$FF,$FE
 .db $7F,$FF,$FF,$FD,$FF,$F0,$EE,$4E,$38,$23,$8C,$00,$00,$00,$00,$02
 .db $67,$FF,$FF,$FF,$B3,$7F,$80,$00,$00,$01,$E6,$24,$E7,$F9,$DF,$F9
 .db $BF,$FC,$01,$FF,$C4,$FE,$CE,$6F,$CC,$30,$03,$00,$7F,$FF,$FF,$FF
 .db $1F,$C0,$C0,$00,$10,$00,$F6,$03,$FF,$00,$FF,$FF,$FF,$FF,$E0,$6F
 .db $F8,$0F,$E0,$0F,$20,$00,$39,$80,$FF,$FF,$FF,$F9,$C1,$FF,$F0,$01
 .db $88,$00,$01,$FB,$DF,$6E,$7F,$FF,$E7,$FF,$FF,$64,$FF,$DF,$18,$80
 .db $01,$01,$12,$30,$00,$0B,$FF,$FB,$FF,$E2,$60,$00,$00,$00,$00,$03
 .db $FF,$FF,$FF,$FF,$FF,$FF,$F8,$8F,$FF,$FF,$FF,$FD,$80,$00,$00,$7F
 .db $3F,$FF,$FF,$F1,$FF,$C6,$00,$00,$00,$00,$00,$1F,$FF,$FF,$FF,$F9
 .db $FF,$FF,$FC,$87,$83,$10,$00,$00,$FE,$7F,$FF,$FF,$80,$01,$0F,$FF
 .db $F7,$BC,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$9F,$78,$00
 .db $00,$00,$3F,$FF,$FF,$FF,$FF,$FF,$40,$00,$00,$00,$03,$00,$F0,$50
 .db $3F,$FF,$1F,$FF,$FF,$FF,$F8,$1C,$00,$00,$10,$00,$30,$FF,$FF,$FF
 .db $FF,$F0,$00,$00,$00,$00,$00,$01,$FB,$FF,$FF,$FF,$FF,$FF,$F0,$E2
 .db $3F,$B0,$1C,$FF,$CE,$77,$FF,$FE,$06,$1B,$E1,$80,$00,$40,$00,$00
 .db $00,$00,$17,$FF,$FF,$FF,$FF,$FB,$00,$7F,$E0,$00,$07,$9F,$FF,$FF
 .db $FD,$FF,$F1,$00,$00,$00,$80,$00,$00,$3F,$FB,$97,$FF,$C0,$00,$06
 .db $1E,$1F,$FC,$7F,$FF,$FF,$F8,$FF,$81,$BD,$81,$C0,$0E,$78,$1F,$C0
 .db $02,$00,$00,$5E,$FC,$FF,$E4,$7F,$F4,$C3,$9E,$1F,$FF,$06,$38,$60
 .db $03,$78,$33,$B7,$00,$00,$00,$0E,$19,$FF,$FF,$FF,$F0,$20,$00,$00
 .db $00,$06,$1C,$7C,$FF,$FC,$FC,$0E,$44,$C4,$CC,$38,$FF,$0E,$D9,$C1
 .db $FF,$F9,$FF,$FF,$FF,$FF,$FF,$FF,$CF,$60,$00,$00,$00,$00,$00,$70
 .db $03,$00,$60,$47,$01,$CD,$1E,$FF,$FC,$3F,$F3,$E7,$F1,$F0,$FF,$9F
 .db $BF,$FF,$DF,$FC,$7C,$1D,$FF,$67,$F0,$00,$0E,$1C,$3D,$83,$20,$70
 .db $40,$02,$01,$87,$9F,$BF,$FC,$FE,$7F,$F8,$7F,$E0,$07,$89,$E1,$BF
 .db $FF,$0C,$1C,$00,$C0,$44,$67,$FF,$1F,$FF,$FF,$FF,$7C,$FF,$C7,$E0
 .db $E0,$E3,$FF,$1F,$07,$18,$00,$00,$18,$9D,$EE,$67,$E0,$C6,$1F,$F8
 .db $FF,$FC,$F9,$C7,$E1,$E3,$FE,$00,$70,$00,$00,$0F,$BF,$FE,$3F,$F9
 .db $F1,$FF,$FD,$FF,$CF,$C0,$1F,$F1,$BF,$FC,$0F,$E0,$00,$40,$02,$1F
 .db $87,$8F,$98,$F8,$7E,$7F,$78,$FF,$90,$F3,$80,$47,$E3,$0E,$00,$00
 .db $00,$18,$FF,$FF,$FF,$E7,$83,$1F,$FF,$8F,$DF,$CC,$FE,$7E,$3F,$98
 .db $20,$C0,$10,$60,$83,$C7,$C7,$E3,$9C,$42,$0F,$FE,$E7,$FF,$27,$F8
 .db $E0,$1F,$D8,$0F,$00,$06,$0E,$3C,$F8,$7D,$F8,$79,$C1,$FF,$F7,$E7
 .db $F7,$1F,$8E,$0F,$1F,$D0,$38,$00,$00,$10,$73,$F1,$8F,$F1,$FE,$07
 .db $FF,$FF,$CF,$E8,$7F,$83,$F3,$1F,$B0,$70,$00,$00,$3C,$7F,$C1,$FF
 .db $E1,$FA,$07,$1F,$FB,$9F,$AF,$9E,$41,$F4,$3E,$F8,$01,$80,$00,$03
 .db $8F,$8F,$EF,$E7,$DF,$0F,$FF,$FF,$1F,$FC,$3C,$F0,$3C,$7F,$80,$F0
 .db $00,$00,$3F,$C1,$CF,$DF,$E7,$F0,$0F,$FF,$FF,$BF,$88,$F0,$0F,$3C
 .db $3F,$00,$18,$00,$00,$0F,$E0,$1F,$E1,$DC,$39,$DF,$BF,$FF,$F0,$FF
 .db $C0,$01,$FF,$F9,$FF,$80,$00,$00,$E1,$8F,$FF,$8F,$FF,$E0,$3F,$F9
 .db $CF,$FF,$F8,$F8,$FC,$08,$FF,$FC,$C0,$00,$00,$06,$3F,$87,$0C,$60
 .db $03,$FF,$FF,$FF,$FF,$FE,$4C,$F8,$01,$FC,$30,$00,$1C,$04,$0C,$00
 .db $0F,$FF,$CC,$01,$FD,$FF,$FF,$C7,$3F,$83,$E1,$8F,$FF,$8F,$C0,$00
 .db $00,$01,$FC,$E0,$14,$C0,$3B,$FF,$FF,$FB,$FE,$50,$47,$E0,$3F,$E0
 .db $FC,$00,$3C,$00,$1C,$18,$1F,$FF,$F0,$03,$FF,$E0,$FF,$FC,$31,$CF
 .db $1C,$7D,$FF,$C2,$0C,$80,$00,$E3,$F0,$E3,$FD,$21,$1F,$FE,$71,$FE
 .db $F0,$7C,$73,$80,$3F,$B8,$1C,$01,$00,$0F,$86,$03,$DE,$7C,$C1,$3F
 .db $F3,$9F,$FF,$98,$7E,$60,$3F,$FF,$E3,$CE,$00,$00,$0C,$1E,$01,$FD
 .db $C0,$06,$FF,$FE,$1F,$FF,$F1,$E7,$FF,$90,$7F,$F0,$00,$00,$07,$10
 .db $06,$3F,$FF,$BF,$E1,$3F,$1C,$EF,$FF,$FF,$9F,$FF,$E0,$3F,$83,$F4
 .db $00,$00,$00,$08,$3B,$FB,$00,$01,$FF,$FB,$FF,$FF,$FF,$3F,$F2,$01
 .db $FF,$00,$00,$00,$00,$00,$00,$3F,$FE,$06,$01,$FF,$FF,$FF,$FF,$FC
 .db $4F,$FF,$03,$FF,$C7,$F8,$00,$00,$00,$47,$FF,$C0,$00,$07,$FF,$FF
 .db $FF,$FF,$FC,$FF,$CE,$1F,$FC,$C2,$00,$00,$00,$00,$00,$FF,$FF,$7F
 .db $38,$F3,$3F,$FF,$DF,$F1,$1F,$FE,$33,$FE,$0F,$E0,$00,$00,$00,$03
 .db $FE,$71,$E4,$3D,$E7,$9F,$FE,$EF,$EF,$FF,$F0,$9F,$FE,$01,$00,$00
 .db $00,$7B,$87,$E0,$80,$20,$87,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00,$00
 .db $00,$00,$00,$00,$77,$FF,$FF,$F8,$03,$FE,$00,$3F,$F1,$0F,$F8,$03
 .db $E7,$FF,$FF,$FF,$FF,$FC,$C0,$6F,$E0,$0F,$C0,$00,$1C,$00,$3F,$00
 .db $00,$00,$07,$C0,$17,$C0,$2F,$E0,$03,$FE,$00,$FF,$FD,$3F,$F8,$7F
 .db $FF,$FF,$FF,$C1,$FF,$80,$3F,$BE,$00,$F0,$00,$00,$00,$00,$C0,$16
 .db $03,$C0,$3F,$FB,$FF,$FF,$F6,$F2,$7F,$78,$FF,$C1,$F7,$80,$30,$00
 .db $0B,$F8,$3D,$FC,$1F,$C0,$7F,$FF,$F7,$FF,$1F,$F8,$1F,$FF,$E0,$C2
 .db $00,$40,$00,$63,$3C,$BF,$FC,$1E,$00,$7F,$FF,$9C,$1C,$0F,$E3,$FF
 .db $FF,$E1,$FE,$00,$00,$00,$0F,$CC,$1E,$60,$C0,$7F,$FF,$FF,$87,$D9
 .db $FF,$CD,$FB,$FF,$F0,$F8,$00,$00,$00,$00,$3E,$1F,$EF,$87,$0F,$FF
 .db $FF,$81,$E0,$87,$FA,$7F,$FF,$FE,$78,$00,$07,$78,$3E,$1C,$00,$07
 .db $03,$9F,$FF,$FF,$80,$00,$F8,$13,$FF,$FF,$FC,$00,$00,$00,$07,$9C
 .db $DC,$FF,$FF,$FF,$C3,$E7,$FA,$00,$F9,$FF,$CF,$FF,$E1,$0C,$F8,$00
 .db $00,$00,$07,$FF,$FF,$80,$3F,$FF,$E7,$FC,$07,$FF,$FE,$03,$FF,$FF
 .db $FF,$E0,$00,$00,$00,$7F,$E1,$FE,$83,$BB,$FF,$DF,$E0,$30,$0F,$FC
 .db $3F,$FF,$FC,$1F,$80,$00,$00,$02,$7E,$07,$EE,$1F,$A7,$FF,$FF,$83
 .db $F8,$1F,$F1,$FF,$FF,$E0,$7E,$02,$00,$00,$00,$F8,$1F,$FA,$0F,$05
 .db $FF,$FF,$83,$C0,$4F,$E7,$FF,$FF,$E0,$F8,$00,$00,$00,$04,$F0,$3F
 .db $F0,$0F,$DF,$EF,$FF,$CF,$FF,$FF,$CE,$9F,$F3,$C0,$F8,$00,$20,$00
 .db $3F,$F0,$3F,$E0,$1F,$06,$3F,$FF,$0F,$F0,$3F,$FF,$FF,$FF,$E0,$F0
 .db $00,$00,$00,$1F,$DE,$0F,$E0,$07,$FF,$FF,$FF,$E0,$FE,$DC,$7F,$FF
 .db $FF,$FF,$80,$C0,$00,$00,$3F,$FF,$F0,$FC,$04,$7F,$8F,$FF,$FC,$03
 .db $C4,$03,$FF,$FE,$3F,$E0,$1C,$00,$00,$07,$E1,$FF,$80,$03,$FF,$FF
 .db $FF,$F3,$FE,$1F,$E3,$7F,$E0,$3E,$7F,$80,$00,$00,$07,$7E,$3F,$FE
 .db $03,$F8,$FF,$FF,$E0,$07,$F9,$FF,$FF,$F0,$FC,$1F,$C0,$00,$00,$1C
 .db $7C,$07,$EE,$C0,$7F,$FF,$FF,$F8,$5F,$FF,$03,$FF,$80,$7D,$1F,$80
 .db $00,$00,$1C,$FF,$1F,$FF,$76,$1F,$FF,$FF,$F8,$07,$FF,$C3,$FF,$C0
 .db $7F,$3F,$80,$00,$00,$60,$66,$7E,$39,$0F,$3F,$FF,$FF,$F8,$1F,$FF
 .db $03,$FF,$08,$FF,$FE,$00,$00,$00,$06,$FF,$FF,$78,$00,$3F,$FF,$DF
 .db $F0,$07,$FF,$7F,$FF,$F1,$FF,$F8,$00,$00,$01,$F7,$FF,$FD,$E0,$0F
 .db $FF,$FF,$FF,$C0,$FF,$FF,$E7,$FC,$0F,$FF,$DC,$00,$00,$00,$BE,$0F
 .db $FE,$03,$7F,$03,$FF,$FE,$7F,$C3,$3F,$FA,$03,$FF,$C7,$FC,$00,$00
 .db $00,$07,$FF,$00,$1F,$C3,$EF,$FF,$FF,$E6,$3F,$7F,$03,$FF,$FF,$FF
 .db $E0,$00,$00,$00,$FC,$01,$F8,$16,$0F,$FF,$FE,$0F,$EC,$F0,$03,$F1
 .db $C3,$E7,$FF,$99,$C0,$38,$00,$23,$30,$1C,$01,$E0,$0F,$FE,$1F,$1F
 .db $FF,$1F,$E4,$00,$00,$87,$83,$F1,$FF,$FF,$FF,$E0,$C0,$00,$00,$00
 .db $40,$38,$7D,$FF,$FF,$F8,$0D,$7C,$0F,$F6,$D8,$1F,$00,$18,$1F,$18
 .db $1F,$FC,$FF,$FF,$FE,$FF,$FF,$FC,$FC,$00,$00,$00,$40,$00,$00,$00
 .db $20,$40,$00,$01,$E3,$1F,$FF,$FF,$8F,$FF,$EF,$C6,$3E,$1F,$FF,$F8
 .db $39,$F8,$3C,$E1,$F1,$E1,$E0,$E3,$07,$C3,$8F,$07,$FF,$3F,$00,$00
 .db $11,$F8,$61,$E5,$E0,$FF,$FF,$E3,$03,$03,$78,$7F,$CF,$FF,$3F,$FF
 .db $FC,$00,$18,$7F,$E6,$07,$3F,$81,$F8,$B3,$DC,$0E,$07,$C7,$FF,$FF
 .db $FE,$3F,$FF,$FC,$00,$00,$3B,$B8,$20,$0E,$01,$E3,$EF,$B0,$01,$0F
 .db $87,$F6,$EF,$7E,$3F,$FF,$F0,$00,$98,$FE,$E0,$C0,$78,$01,$C1,$DF
 .db $E0,$36,$0F,$47,$FF,$FC,$FF,$3F,$FF,$F8,$C0,$0C,$7F,$01,$C0,$00
 .db $20,$07,$FF,$C0,$00,$07,$2F,$87,$F9,$FB,$9F,$7F,$20,$C0,$7C,$7E
 .db $03,$03,$A0,$A0,$1F,$FF,$C8,$06,$0E,$7F,$F7,$F9,$FE,$3F,$FF,$83
 .db $C0,$F0,$F8,$0F,$03,$83,$83,$FF,$BE,$00,$0C,$7C,$7E,$01,$FF,$F0
 .db $FD,$FF,$0F,$83,$C7,$FE,$1E,$0F,$04,$00,$38,$FE,$8E,$01,$F1,$F8
 .db $9F,$FF,$CF,$E7,$FC,$7E,$04,$3F,$E3,$70,$00,$30,$00,$FF,$FE,$00
 .db $07,$C7,$EC,$3C,$FF,$1F,$3F,$F1,$FC,$38,$7F,$C7,$C0,$E0,$40,$27
 .db $8F,$9E,$60,$13,$3C,$3D,$E3,$FC,$FD,$FF,$EE,$F0,$E0,$FF,$1F,$83
 .db $01,$80,$0E,$3E,$F0,$00,$18,$78,$77,$87,$FC,$F3,$FF,$FF,$83,$C1
 .db $FF,$1E,$04,$00,$C0,$0F,$FF,$D0,$40,$02,$7C,$03,$8F,$FF,$F3,$FF
 .db $FE,$66,$03,$F2,$F8,$00,$00,$00,$F0,$FF,$F0,$01,$8F,$FC,$00,$FF
 .db $FF,$FF,$FF,$FF,$80,$07,$FF,$F3,$00,$00,$00,$07,$FF,$E0,$04,$30
 .db $10,$E0,$FF,$FF,$7F,$FF,$FF,$00,$13,$FF,$9C,$00,$00,$00,$1F,$FF
 .db $E0,$01,$3F,$91,$83,$7F,$FF,$7F,$FF,$FE,$80,$7F,$FE,$18,$00,$00
 .db $00,$7F,$FE,$F0,$00,$01,$82,$0F,$FF,$FF,$FF,$FF,$FB,$00,$0F,$FF
 .db $F8,$00,$00,$00,$FF,$F0,$00,$00,$CE,$18,$3F,$FF,$F9,$FF,$FF,$FE
 .db $01,$FF,$F9,$E0,$00,$20,$01,$1F,$E7,$C0,$00,$10,$04,$1F,$FF,$FF
 .db $FF,$FF,$F8,$00,$FF,$FF,$00,$00,$00,$0C,$7F,$07,$00,$01,$CC,$20
 .db $3F,$FF,$FF,$FF,$FF,$E0,$03,$FF,$9C,$00,$00,$00,$01,$FF,$FF,$00
 .db $01,$00,$C0,$3F,$FB,$FF,$FF,$FF,$CC,$03,$FF,$F8,$E0,$00,$00,$03
 .db $FC,$38,$00,$06,$23,$33,$BF,$FF,$FF,$FF,$FF,$30,$0F,$CD,$F6,$00
 .db $07,$00,$1F,$FF,$F0,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$E0,$0F
 .db $7F,$E2,$00,$00,$00,$1B,$99,$E0,$00,$00,$FF,$3F,$FF,$FF,$FF,$FF
 .db $FE,$00,$1F,$3F,$FC,$00,$7E,$00,$7E,$FF,$30,$00,$00,$10,$3D,$FF
 .db $FF,$FB,$FF,$FF,$80,$0C,$FF,$FC,$00,$00,$00,$00,$7F,$E3,$E0,$03
 .db $FB,$C0,$1F,$FF,$3F,$FF,$7E,$38,$27,$F7,$06,$C0,$07,$FE,$40,$7F
 .db $C0,$00,$03,$E3,$91,$FF,$FF,$FF,$F1,$FF,$EC,$07,$FF,$E0,$00,$80
 .db $00,$CF,$DF,$9C,$00,$0F,$C2,$03,$FF,$FE,$3C,$FF,$E0,$06,$7F,$FF
 .db $20,$1F,$E0,$07,$DF,$9F,$98,$00,$04,$0E,$66,$FF,$EC,$3F,$FB,$03
 .db $FC,$03,$FF,$80,$1C,$00,$0F,$00,$3C,$40,$0C,$7C,$3F,$E7,$FF,$B0
 .db $FF,$E4,$04,$FC,$C7,$FF,$00,$7F,$00,$1F,$50,$7F,$40,$00,$F0,$11
 .db $9F,$FF,$E7,$9F,$FF,$87,$7E,$47,$FE,$40,$3F,$80,$01,$F9,$89,$80
 .db $00,$7F,$E3,$FF,$FF,$9F,$31,$FF,$10,$7F,$CE,$3F,$E6,$20,$E0,$00
 .db $7F,$E0,$04,$00,$00,$19,$FF,$FF,$FF,$F6,$7F,$FE,$1C,$7F,$A0,$38
 .db $C2,$04,$00,$D0,$08,$0E,$00,$0F,$C0,$7F,$FF,$3F,$FF,$FF,$E3,$FF
 .db $C0,$0F,$F0,$00,$3F,$00,$3F,$C0,$30,$00,$00,$07,$FF,$FF,$FF,$E7
 .db $7F,$E1,$06,$FF,$18,$00,$3C,$00,$1F,$79,$9C,$40,$00,$70,$01,$FF
 .db $F8,$C1,$FF,$FB,$1B,$BF,$FD,$84,$40,$40,$01,$3F,$FB,$00,$30,$04
 .db $71,$1F,$FF,$09,$FF,$FC,$FF,$3F,$E6,$38,$C3,$00,$C0,$00,$CC,$00
 .db $0F,$40,$0F,$FB,$CF,$FF,$C6,$7F,$FF,$FF,$CC,$67,$7A,$03,$8E,$60
 .db $00,$20,$11,$01,$04,$E7,$C4,$33,$FF,$1F,$FF,$FF,$FF,$10,$9F,$C0
 .db $07,$3D,$C0,$00,$00,$04,$27,$80,$FF,$40,$3F,$FC,$07,$FF,$FF,$F9
 .db $04,$FF,$E0,$0C,$7F,$80,$00,$C0,$00,$07,$00,$FE,$60,$1F,$FC,$13
 .db $FF,$FF,$FE,$33,$9D,$C1,$80,$7F,$00,$00,$26,$00,$FE,$61,$FF,$EC
 .db $67,$38,$00,$7F,$FF,$FF,$E6,$21,$1F,$E0,$60,$00,$0C,$02,$00,$67
 .db $72,$11,$FF,$FF,$18,$DC,$7F,$FF,$FF,$FD,$80,$0F,$FC,$E0,$00,$00
 .db $C0,$01,$3C,$07,$FD,$FF,$FC,$00,$01,$BF,$FF,$E7,$FF,$80,$07,$7F
 .db $80,$00,$07,$80,$C4,$1E,$00,$00,$1F,$FE,$00,$00,$37,$FF,$FF,$FF
 .db $C0,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$FF,$80,$18,$00,$00,$00,$01
 .db $FF,$3F,$FF,$FF,$FF,$F3,$00,$00,$3E,$FE,$00,$00,$00,$1F,$FF,$FF
 .db $FE,$FF,$FF,$FF,$FF,$FF,$D8,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $0F,$FF,$FF,$E0,$03,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$C0,$00,$C7,$FC
 .db $BF,$C4,$00,$03,$FF,$FF,$CC,$E1,$80,$00,$40,$1C,$3B,$FF,$F0,$00
 .db $00,$02,$21,$FF,$FC,$FF,$FF,$FF,$80,$00,$7F,$FF,$FF,$F8,$00,$01
 .db $FF,$FF,$00,$00,$00,$64,$1F,$00,$04,$7F,$FF,$FD,$9F,$7F,$FF,$FF
 .db $E7,$63,$0F,$FF,$FF,$00,$00,$00,$00,$40,$00,$10,$FF,$FF,$30,$03
 .db $FF,$FF,$FF,$80,$00,$07,$FF,$FC,$00,$00,$00,$00,$08,$04,$3F,$FF
 .db $FF,$F0,$FF,$FF,$FF,$FF,$FF,$C2,$0E,$73,$90,$00,$00,$00,$03,$60
 .db $00,$03,$FF,$FF,$80,$21,$FF,$FF,$FE,$7B,$00,$3F,$FF,$80,$00,$00
 .db $00,$00,$C6,$71,$5F,$FF,$E0,$01,$FF,$FF,$FF,$FE,$00,$10,$03,$FF
 .db $FF,$00,$00,$00,$00,$01,$C8,$07,$FF,$C0,$0F,$FF,$FF,$E1,$FF,$FF
 .db $FF,$FF,$C0,$00,$00,$00,$00,$0F,$FF,$FF,$FF,$F3,$00,$00,$01,$00
 .db $3F,$FF,$F8,$2F,$FF,$E0,$00,$00,$1F,$80,$00,$01,$1F,$FF,$FF,$A0
 .db $00,$01,$06,$DF,$FF,$F1,$FF,$FF,$C0,$00,$00,$00,$31,$FF,$FF,$7F
 .db $FF,$80,$00,$3B,$9F,$F8,$0F,$FF,$F3,$FF,$FF,$E0,$00,$00,$00,$00
 .db $7F,$FD,$FF,$FF,$F8,$00,$20,$7F,$68,$FF,$FF,$C1,$FF,$FF,$C0,$00
 .db $00,$00,$03,$E7,$FB,$FF,$FF,$E0,$00,$00,$E0,$42,$3F,$FF,$FF,$BF
 .db $FE,$00,$00,$00,$00,$01,$FF,$E0,$7F,$FF,$FC,$00,$03,$E1,$CF,$FF
 .db $FF,$C0,$FF,$FF,$80,$00,$00,$00,$01,$FF,$FF,$FF,$FF,$E0,$00,$03
 .db $FF,$FF,$FF,$FF,$B1,$FF,$FF,$E0,$00,$00,$00,$03,$FE,$10,$FF,$FF
 .db $E0,$00,$07,$FF,$FF,$FE,$F1,$01,$FF,$FC,$00,$06,$3E,$00,$03,$FF
 .db $F0,$FF,$FF,$80,$00,$19,$FF,$FF,$FF,$FF,$C3,$FF,$F8,$00,$80,$00
 .db $00,$0F,$FF,$C0,$FF,$FF,$FC,$09,$E7,$FE,$BF,$FF,$00,$0F,$FF,$F8
 .db $00,$01,$00,$00,$1F,$FF,$81,$FF,$FC,$00,$00,$FF,$FF,$FF,$FF,$FC
 .db $07,$FF,$E0,$02,$00,$00,$00,$3F,$F2,$00,$FF,$FF,$D0,$04,$0E,$74
 .db $FF,$90,$00,$3F,$FF,$F8,$00,$00,$00,$00,$7F,$FE,$00,$3F,$FF,$00
 .db $03,$FF,$98,$FF,$FF,$F7,$37,$FF,$F0,$00,$00,$00,$00,$FF,$F0,$13
 .db $FF,$FE,$00,$00,$7F,$F1,$FF,$FF,$80,$0F,$FF,$C0,$00,$00,$00,$00
 .db $3B,$F0,$7F,$FF,$FE,$00,$01,$E6,$07,$FF,$FF,$FF,$3F,$FF,$C0,$1C
 .db $00,$00,$00,$FF,$60,$3F,$FF,$F8,$00,$01,$FF,$8F,$FE,$F3,$06,$7F
 .db $FF,$80,$00,$02,$00,$0E,$DE,$C0,$1F,$FF,$F0,$00,$0F,$F8,$07,$FF
 .db $FF,$DF,$FF,$FF,$00,$60,$00,$00,$06,$79,$80,$FF,$FF,$E0,$00,$01
 .db $F3,$1F,$FF,$FC,$F9,$FF,$FE,$00,$00,$00,$00,$04,$0E,$00,$7F,$FF
 .db $C1,$09,$9F,$C0,$39,$FF,$FF,$F3,$FF,$FA,$00,$00,$00,$00,$11,$A2
 .db $81,$FF,$FF,$80,$00,$03,$FF,$7F,$FF,$CC,$4C,$FF,$FE,$00,$00,$00
 .db $18,$CC,$02,$19,$FF,$F0,$00,$02,$07,$C8,$7F,$FF,$FF,$FF,$E3,$80
 .db $00,$00,$00,$61,$E6,$79,$F3,$7F,$F6,$10,$00,$07,$FC,$FF,$FF,$37
 .db $FF,$FF,$F8,$00,$00,$00,$C7,$FC,$80,$00,$3F,$C8,$30,$03,$BD,$FE
 .db $7F,$FF,$FD,$C7,$DF,$FE,$00,$00,$00,$00,$03,$83,$C0,$3F,$FF,$F0
 .db $00,$06,$00,$FF,$FF,$F0,$03,$FF,$FF,$80,$00,$00,$0C,$00,$37,$00
 .db $03,$3F,$FF,$FF,$F0,$00,$0F,$FF,$FF,$CF,$FF,$88,$00,$00,$00,$00
 .db $02,$0F,$00,$0F,$FF,$FF,$FF,$F3,$06,$3F,$FF,$C0,$01,$F7,$F8,$00
 .db $07,$FF,$E2,$00,$00,$00,$1F,$EF,$FF,$FD,$FF,$FB,$FF,$FF,$F8,$3B
 .db $FF,$D8,$00,$00,$00,$01,$1F,$F0,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$F0,$00,$00,$00,$00,$07,$F9,$DF,$C0,$38,$01,$FB,$0F,$38,$1F
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$10,$E0,$00,$7F
 .db $FF,$FF,$F0,$CD,$9F,$FF,$FF,$80,$43,$3F,$F0,$00,$14,$00,$10,$00
 .db $80,$00,$2E,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$C3,$FF,$C0,$3E,$FF
 .db $C0,$00,$1F,$C0,$00,$7F,$FF,$FF,$FF,$FF,$FF,$F9,$00,$1F,$FF,$C0
 .db $00,$00,$01,$FF,$30,$00,$00,$FF,$FF,$FF,$FF,$03,$FF,$D8,$00,$7F
 .db $FF,$E0,$03,$FF,$FF,$FF,$00,$00,$01,$F8,$00,$01,$FF,$FF,$FF,$FC
 .db $00,$04,$70,$CC,$3F,$FE,$00,$78,$00,$00,$00,$01,$07,$7F,$FF,$FF
 .db $F0,$00,$00,$00,$3F,$FF,$FF,$FE,$40,$00,$13,$80,$00,$00,$00,$00
 .db $0F,$FF,$FF,$FF,$FF,$BC,$FF,$FF,$FF,$FF,$FF,$FC,$00,$00,$00,$00
 .db $00,$01,$07,$FF,$FF,$FF,$00,$0F,$FF,$FF,$FF,$FF,$FF,$F0,$00,$00
 .db $3F,$90,$00,$00,$00,$00,$00,$03,$FF,$FF,$FF,$FF,$FF,$FF,$E8,$C0
 .db $00,$30,$00,$00,$00,$00,$1F,$FF,$F9,$EC,$00,$3F,$E0,$00,$FF,$C3
 .db $FF,$F8,$85,$FF,$00,$FF,$C0,$01,$E0,$03,$FE,$00,$6E,$40,$3F,$F0
 .db $00,$64,$01,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$00,$00,$02,$00,$07
 .db $FF,$FC,$FF,$FF,$C0,$FF,$FF,$00,$01,$F0,$00,$FF,$F8,$01,$FF,$81
 .db $FF,$FF,$FF,$0F,$F0,$00,$7F,$A0,$5F,$C0,$08,$68,$00,$00,$70,$02
 .db $77,$E0,$1F,$FF,$81,$FF,$F0,$FF,$FF,$7D,$FF,$FE,$07,$DF,$80,$7B
 .db $FF,$9F,$FF,$80,$FE,$80,$01,$81,$C0,$73,$F8,$00,$FF,$FE,$FF,$FE
 .db $03,$CF,$80,$FF,$FF,$80,$80,$00,$01,$FF,$BF,$FF,$F9,$FF,$FC,$07
 .db $FF,$80,$FE,$6E,$01,$9F,$81,$DF,$F8,$01,$80,$C0,$3F,$FF,$1F,$F8
 .db $00,$00,$7F,$3F,$FF,$C0,$3F,$F9,$00,$3F,$80,$1F,$80,$03,$83,$EF
 .db $E4,$F8,$00,$7C,$00,$7F,$FF,$1F,$7E,$00,$00,$07,$FF,$FF,$FF,$FF
 .db $FF,$E8,$FF,$C0,$5F,$F4,$06,$FC,$1F,$FC,$E0,$04,$00,$00,$07,$FD
 .db $FE,$FF,$00,$03,$C0,$7F,$FF,$FF,$FF,$F9,$FF,$F0,$FD,$84,$78,$00
 .db $7F,$FC,$FF,$E4,$01,$9E,$00,$1F,$CF,$FF,$F7,$F8,$00,$00,$2F,$FF
 .db $FF,$FF,$1D,$F7,$CE,$7F,$E0,$00,$07,$7F,$FF,$FE,$F8,$00,$00,$00
 .db $00,$79,$FF,$FF,$F8,$00,$00,$1F,$FF,$FF,$7F,$FF,$F3,$FF,$FF,$FA
 .db $06,$00,$1C,$F9,$EF,$FE,$00,$00,$00,$00,$3F,$FF,$FF,$F3,$00,$00
 .db $0D,$FF,$FC,$67,$FF,$FF,$FF,$98,$C8,$18,$00,$1D,$FB,$FF,$7F,$00
 .db $00,$00,$00,$01,$FF,$FF,$FF,$80,$00,$00,$FF,$FC,$9C,$FF,$FF,$FC
 .db $FF,$FE,$1F,$6F,$03,$83,$FF,$FF,$80,$10,$00,$00,$00,$FF,$FF,$FF
 .db $70,$00,$00,$3F,$FF,$3F,$FF,$FF,$FF,$07,$FF,$00,$19,$81,$DE,$7F
 .db $FF,$80,$08,$00,$00,$00,$3F,$FF,$DF,$FC,$00,$00,$0F,$FF,$7F,$FF
 .db $FF,$F8,$03,$7C,$08,$0E,$7C,$44,$FF,$FF,$F8,$04,$00,$00,$00,$1F
 .db $FF,$FF,$FF,$00,$00,$07,$FD,$39,$CF,$FF,$FF,$CF,$FF,$E1,$0F,$FF
 .db $CC,$40,$0C,$E0,$21,$00,$00,$00,$3B,$FF,$FF,$FC,$C0,$00,$00,$3F
 .db $FF,$EE,$16,$7F,$FF,$F8,$00,$0F,$FF,$C0,$01,$FF,$FE,$00,$00,$E6
 .db $00,$19,$FF,$F0,$1D,$C0,$02,$00,$FF,$FF,$C0,$7F,$FF,$70,$01,$ED
 .db $FF,$80,$07,$08,$03,$CC,$01,$E0,$19,$FE,$1F,$F3,$BF,$F9,$99,$00
 .db $03,$FF,$E6,$7B,$23,$FF,$E2,$1B,$76,$7F,$FC,$C1,$00,$00,$23,$88
 .db $03,$CC,$18,$EE,$F7,$FE,$7E,$23,$C1,$09,$9D,$9E,$FF,$EE,$FF,$E0
 .db $0C,$77,$1F,$F0,$03,$01,$00,$18,$69,$80,$C8,$0F,$90,$7F,$F9,$FB
 .db $27,$10,$18,$33,$FE,$3F,$9B,$7F,$E1,$00,$3F,$9B,$FF,$85,$C4,$00
 .db $00,$38,$80,$08,$3F,$C3,$1F,$FF,$FE,$FF,$C0,$04,$0D,$8D,$F9,$C7
 .db $FF,$C1,$9C,$1D,$E5,$FF,$CF,$00,$60,$00,$07,$C0,$08,$FD,$E1,$FF
 .db $FF,$DE,$7F,$E0,$00,$0C,$1F,$FF,$C7,$FF,$C7,$DC,$E4,$E4,$E7,$C6
 .db $9C,$18,$40,$06,$00,$00,$1C,$E0,$C7,$EF,$FF,$9E,$70,$60,$03,$8F
 .db $BE,$E6,$DF,$E8,$8D,$0D,$E0,$FF,$EC,$0E,$70,$40,$13,$80,$1C,$1A
 .db $C0,$C7,$DF,$BF,$FF,$E0,$C3,$40,$0F,$BF,$E1,$FB,$EC,$EE,$3C,$C0
 .db $9F,$FC,$DF,$FD,$80,$00,$00,$00,$DF,$C1,$87,$C9,$F0,$7F,$E0,$87
 .db $80,$7F,$7C,$F1,$8F,$80,$CE,$1F,$FF,$FF,$FF,$FF,$F8,$C0,$00,$00
 .db $00,$00,$20,$DF,$FF,$FF,$FF,$FC,$E7,$83,$07,$38,$70,$43,$C0,$EF
 .db $9F,$F7,$FF,$FF,$FF,$FF,$FC,$FE,$20,$00,$00,$00,$00,$00,$00,$8B
 .db $70,$00,$00,$00,$88,$79,$F9,$F9,$FF,$FF,$FC,$7F,$FF,$FF,$FF,$FE
 .db $10,$70,$01,$07,$8E,$30,$F1,$E3,$F7,$FE,$40,$40,$00,$00,$3E,$04
 .db $FC,$DF,$FF,$7F,$0F,$BE,$FE,$FF,$CF,$00,$80,$00,$00,$C7,$03,$90
 .db $39,$FB,$FF,$BF,$B8,$00,$61,$FF,$0F,$7F,$7F,$FC,$DE,$0F,$BE,$F1
 .db $83,$8E,$48,$00,$00,$81,$FC,$08,$58,$03,$FF,$FC,$B8,$70,$03,$BF
 .db $FC,$BD,$FB,$07,$CE,$38,$20,$A3,$CF,$CF,$F9,$E1,$E0,$00,$C8,$F0
 .db $E0,$60,$07,$FD,$FF,$FF,$CC,$04,$3F,$E3,$CF,$FF,$C7,$FF,$C0,$00
 .db $00,$FF,$F7,$81,$00,$00,$00,$67,$F0,$00,$00,$FF,$FF,$FF,$F8,$00
 .db $46,$0C,$FF,$FF,$EF,$C0,$7F,$E0,$0F,$FB,$FF,$FF,$40,$44,$88,$08
 .db $00,$40,$8F,$80,$00,$3F,$EF,$8C,$00,$1E,$1F,$8F,$FF,$F8,$7F,$FC
 .db $00,$00,$00,$7F,$FF,$A0,$C8,$03,$E1,$F8,$00,$FF,$81,$80,$70,$FF
 .db $FF,$DF,$F8,$60,$60,$0F,$FF,$FF,$E0,$06,$00,$0C,$3F,$E3,$E7,$8E
 .db $1C,$03,$C1,$81,$88,$10,$73,$83,$FF,$1C,$3F,$FF,$93,$C2,$02,$7F
 .db $FF,$96,$3E,$00,$0F,$FF,$07,$BF,$02,$3F,$FC,$04,$00,$00,$0C,$FE
 .db $12,$FF,$C0,$3B,$FE,$04,$86,$1F,$FF,$FF,$7F,$00,$00,$03,$FE,$0F
 .db $FE,$C1,$FD,$86,$00,$38,$00,$3F,$F6,$0C,$3F,$F3,$FF,$FE,$0C,$00
 .db $01,$FF,$FF,$DE,$3C,$00,$00,$FC,$0D,$FC,$09,$FF,$E6,$07,$3E,$00
 .db $41,$86,$0F,$9F,$D0,$7F,$EF,$60,$86,$01,$FF,$FF,$FD,$BE,$00,$06
 .db $0F,$FF,$FF,$04,$1F,$81,$07,$FF,$20,$00,$C1,$06,$3E,$0D,$7F,$FF
 .db $97,$86,$24,$7F,$FF,$E3,$CE,$00,$61,$DF,$F3,$FF,$08,$7F,$03,$80
 .db $0F,$00,$03,$91,$80,$0F,$F5,$FF,$FF,$FB,$C8,$00,$0F,$3F,$FF,$FF
 .db $D0,$02,$01,$C0,$FF,$93,$FF,$64,$E0,$01,$80,$1E,$09,$E0,$03,$FE
 .db $0F,$1E,$F1,$D3,$C4,$0F,$FF,$FF,$F1,$F0,$00,$00,$F0,$79,$FE,$46
 .db $9F,$10,$7F,$B0,$78,$07,$F8,$01,$FE,$F9,$BF,$F8,$00,$7C,$00,$FF
 .db $FF,$FF,$FC,$00,$00,$19,$80,$7F,$FC,$FF,$FC,$00,$00,$00,$3F,$FE
 .db $00,$01,$DC,$0F,$FF,$2C,$7F,$C0,$3F,$FF,$67,$FE,$00,$00,$07,$87
 .db $F7,$7F,$FF,$FF,$80,$0F,$80,$03,$3C,$00,$07,$FF,$9F,$E7,$FE,$00
 .db $F8,$C3,$FF,$FE,$8C,$F0,$00,$00,$DF,$FF,$FF,$F0,$30,$00,$00,$00
 .db $47,$DF,$BC,$FF,$C0,$3F,$80,$3F,$FF,$C0,$0F,$CF,$FF,$FB,$FF,$00
 .db $00,$00,$03,$FF,$F0,$0F,$80,$01,$7F,$F1,$FC,$00,$7F,$9F,$FF,$FF
 .db $80,$7E,$44,$FF,$F8,$FE,$00,$00,$02,$07,$FF,$F2,$0F,$E6,$00,$18
 .db $03,$F8,$27,$FF,$1C,$FB,$FF,$02,$20,$7F,$FE,$F8,$00,$00,$03,$80
 .db $7F,$3F,$FF,$B8,$11,$C0,$07,$00,$3F,$E7,$FF,$01,$E0,$1F,$83,$FF
 .db $FF,$FF,$F8,$C0,$00,$00,$00,$00,$07,$00,$3E,$07,$FF,$DF,$FD,$EF
 .db $DC,$FF,$03,$F0,$33,$FB,$03,$90,$3E,$9F,$F8,$FF,$FF,$FF,$88,$3F
 .db $03,$C1,$8F,$00,$00,$00,$00,$83,$80,$06,$01,$E0,$FF,$E3,$FF,$C0
 .db $70,$63,$C7,$FF,$9F,$FF,$FF,$E6,$DF,$C6,$F9,$3F,$E7,$FF,$DF,$F8
 .db $C1,$C1,$80,$0F,$F8,$30,$00,$00,$00,$0E,$3F,$E0,$FE,$FF,$FE,$0F
 .db $E0,$77,$E7,$FF,$BF,$F0,$78,$00,$0F,$E7,$F8,$7F,$80,$60,$00,$70
 .db $7F,$18,$73,$DF,$B8,$1E,$1F,$EF,$C3,$FF,$BF,$FD,$C0,$C1,$FF,$DF
 .db $FF,$F8,$C0,$00,$00,$00,$79,$FF,$FF,$1F,$F0,$00,$01,$C7,$8F,$BF
 .db $BF,$FF,$FB,$C3,$C6,$3F,$FF,$FF,$E0,$20,$00,$00,$3F,$F9,$9F,$F8
 .db $3F,$C3,$9C,$1C,$C6,$C7,$66,$7E,$7F,$F0,$00,$7F,$FF,$BE,$FE,$41
 .db $80,$00,$00,$3B,$80,$0C,$33,$99,$9C,$7F,$FB,$FD,$8B,$DF,$E7,$FF
 .db $E7,$9F,$FF,$FF,$FF,$30,$00,$00,$01,$F3,$FE,$39,$63,$80,$19,$F0
 .db $13,$E7,$03,$FF,$F3,$FF,$00,$10,$FF,$CF,$FF,$F3,$07,$20,$00,$01
 .db $1B,$F9,$FD,$FF,$FB,$20,$7F,$86,$7E,$30,$1F,$FF,$39,$F3,$B1,$BB
 .db $F3,$FF,$F8,$00,$00,$00,$71,$00,$B1,$F9,$9D,$98,$03,$FF,$18,$ED
 .db $87,$F9,$FD,$8F,$FC,$67,$FF,$DD,$FC,$80,$00,$00,$8C,$FE,$63,$F7
 .db $00,$37,$C0,$1F,$9C,$43,$FF,$F7,$FF,$E6,$3B,$B8,$3F,$FF,$FF,$FE
 .db $00,$00,$00,$00,$FF,$03,$FF,$CC,$7F,$9E,$13,$FE,$61,$3D,$80,$DF
 .db $FB,$0C,$FE,$FF,$FF,$D8,$06,$00,$00,$0E,$21,$99,$F0,$01,$F8,$04
 .db $FE,$E7,$FE,$E6,$33,$3B,$00,$FF,$98,$FF,$FF,$FE,$66,$00,$00,$00
 .db $1F,$F3,$1C,$F3,$08,$07,$FE,$73,$98,$03,$CF,$CC,$EE,$77,$7C,$3F
 .db $FF,$BF,$D8,$08,$00,$04,$40,$00,$27,$F7,$19,$98,$1F,$FC,$EE,$C0
 .db $7F,$81,$FF,$FF,$E6,$20,$FF,$FF,$F3,$9C,$80,$00,$00,$46,$73,$F3
 .db $01,$3F,$98,$CE,$40,$0C,$E6,$73,$3F,$FF,$3F,$F8,$6F,$F7,$FF,$FF
 .db $E0,$00,$00,$02,$3F,$F6,$FF,$C8,$18,$FB,$98,$70,$61,$0F,$EC,$67
 .db $FB,$9B,$3B,$FB,$DF,$FE,$80,$00,$00,$00,$19,$BF,$FF,$00,$1E,$A0
 .db $8D,$CC,$E6,$3A,$63,$7F,$F3,$98,$5E,$47,$FF,$FE,$FF,$00,$00,$00
 .db $01,$1F,$20,$3F,$98,$CE,$61,$9F,$FF,$C0,$13,$84,$23,$FF,$FB,$FE
 .db $EF,$FF,$FF,$F0,$00,$00,$06,$DE,$6F,$31,$1D,$DE,$61,$3C,$C0,$03
 .db $99,$CC,$FF,$F3,$FF,$FF,$BF,$FC,$FE,$E7,$2C,$00,$00,$01,$FD,$FF
 .db $80,$10,$03,$B3,$FF,$E6,$66,$17,$73,$7F,$FC,$00,$05,$FF,$FF,$FF
 .db $F0,$00,$00,$00,$00,$08,$04,$37,$77,$FF,$FF,$C2,$20,$03,$FF,$F9
 .db $F8,$84,$7F,$FF,$FF,$FF,$FE,$00,$00,$00,$18,$81,$87,$A2,$FF,$F1
 .db $FF,$38,$80,$03,$3B,$FD,$3F,$FF,$FF,$DF,$FF,$FB,$FB,$00,$00,$00
 .db $00,$04,$01,$80,$DF,$C7,$3F,$89,$F7,$09,$F7,$63,$71,$FF,$DC,$FF
 .db $FF,$FF,$FF,$F9,$C0,$00,$00,$00,$01,$FF,$FF,$FF,$00,$23,$9D,$F0
 .db $BF,$FF,$F7,$00,$00,$CF,$FF,$FF,$FF,$FF,$00,$00,$00,$08,$7F,$FE
 .db $73,$80,$00,$03,$FF,$FF,$FC,$20,$80,$3F,$FF,$FF,$FF,$FF,$BF,$F0
 .db $10,$40,$00,$00,$20,$00,$C4,$00,$03,$BF,$F7,$FF,$F0,$C0,$0D,$FF
 .db $FF,$FF,$FE,$71,$F7,$9F,$FF,$FE,$00,$00,$00,$00,$0F,$FD,$8E,$26
 .db $7F,$BE,$F0,$00,$1F,$FF,$1B,$FF,$FD,$FF,$8F,$FF,$FF,$FC,$E4,$00
 .db $00,$00,$0F,$EF,$C0,$27,$40,$3B,$E3,$00,$01,$C7,$0F,$FF,$DF,$FD
 .db $FF,$FF,$FF,$FF,$F8,$00,$00,$00,$02,$62,$FF,$DF,$CE,$C0,$62,$08
 .db $F0,$8F,$FF,$DF,$FD,$D8,$8E,$7F,$C7,$FF,$E6,$80,$00,$0C,$04,$03
 .db $00,$03,$9E,$00,$06,$FF,$73,$FF,$FF,$F8,$7F,$FF,$F8,$00,$FF,$C2
 .db $00,$06,$20,$01,$EE,$40,$47,$FE,$E4,$06,$CE,$00,$37,$FE,$01,$FE
 .db $01,$FF,$FE,$62,$3F,$FF,$FF,$FF,$EE,$00,$3C,$00,$00,$00,$01,$DF
 .db $80,$7F,$FF,$FC,$C7,$BF,$44,$FF,$F9,$8F,$F8,$01,$FF,$EE,$23,$FF
 .db $31,$FC,$03,$CC,$77,$E6,$00,$00,$00,$01,$F8,$00,$FF,$FF,$7F,$F9
 .db $BF,$09,$FF,$FE,$0F,$FF,$00,$7F,$E0,$01,$F2,$01,$9F,$F9,$C6,$7B
 .db $FF,$D8,$03,$F8,$00,$1C,$60,$07,$FF,$EF,$7F,$FF,$3F,$BF,$FF,$63
 .db $17,$F0,$0C,$FF,$F2,$01,$B3,$00,$07,$FF,$00,$FF,$FE,$EC,$F0,$D8
 .db $00,$00,$90,$23,$FF,$E6,$31,$FF,$F3,$3F,$FF,$F1,$8F,$FE,$01,$FC
 .db $F0,$00,$00,$00,$01,$3F,$FC,$3B,$FF,$F8,$7F,$FC,$00,$00,$00,$00
 .db $7F,$99,$9F,$FF,$F6,$67,$3F,$FC,$01,$FF,$00,$3B,$FE,$00,$1E,$60
 .db $23,$FF,$F7,$3F,$FF,$FC,$13,$FE,$00,$00,$00,$00,$7F,$E3,$3D,$FB
 .db $D8,$EF,$FF,$F3,$8F,$F9,$8C,$FF,$F0,$09,$BF,$00,$1F,$72,$73,$FF
 .db $F7,$E7,$3F,$E2,$00,$00,$00,$00,$6C,$EF,$FF,$FF,$FF,$FC,$00,$00
 .db $00,$00,$00,$79,$8E,$FF,$E6,$7F,$FF,$33,$FF,$B8,$CF,$F0,$02,$70
 .db $00,$00,$07,$FE,$E7,$FF,$FF,$DF,$FF,$C0,$7F,$F1,$09,$84,$00,$40
 .db $00,$00,$00,$31,$84,$03,$E3,$19,$FF,$FF,$FF,$FF,$A1,$08,$00,$04
 .db $31,$E7,$FF,$FF,$FF,$F7,$FF,$F9,$9F,$FF,$E2,$01,$B0,$00,$00,$00
 .db $00,$C7,$10,$FF,$FF,$FF,$FF,$FD,$80,$00,$00,$00,$03,$F2,$0C,$FF
 .db $E2,$33,$FF,$D1,$FF,$FF,$FF,$9F,$FC,$73,$00,$03,$CC,$37,$F7,$1F
 .db $FF,$FF,$73,$DF,$10,$00,$00,$00,$00,$0C,$47,$FE,$E3,$F3,$3C,$F7
 .db $FC,$FF,$FF,$CC,$77,$F9,$00,$80,$06,$31,$93,$1F,$BF,$FF,$FF,$E6
 .db $7F,$20,$00,$08,$00,$03,$73,$9F,$F9,$F7,$B8,$5F,$FF,$9C,$FF,$F8
 .db $86,$FF,$60,$03,$30,$00,$9F,$F0,$0F,$FB,$FF,$E9,$87,$C0,$00,$39
 .db $C0,$01,$80,$07,$FF,$FE,$6F,$E7,$3F,$F7,$FF,$EC,$34,$FF,$E0,$00
 .db $7F,$EE,$F8,$00,$00,$7F,$FC,$7F,$FE,$00,$40,$00,$00,$00,$00,$7C
 .db $7F,$F8,$13,$FF,$FF,$80,$F8,$07,$FD,$FF,$FE,$FF,$E0,$00,$3F,$C0
 .db $6F,$FF,$F1,$FD,$BB,$08,$71,$00,$00,$3F,$00,$02,$3F,$FE,$7F,$FF
 .db $FF,$FE,$F2,$00,$7F,$DF,$FF,$FE,$40,$04,$00,$0E,$3B,$FF,$FF,$FF
 .db $FF,$80,$33,$00,$1D,$C0,$00,$0C,$01,$9F,$7B,$FF,$FF,$FF,$06,$63
 .db $7F,$FF,$FF,$FF,$00,$07,$00,$3F,$FB,$3F,$FF,$FF,$FF,$F3,$00,$00
 .db $00,$01,$E7,$1C,$00,$0F,$3C,$1F,$FF,$FF,$FF,$C0,$3F,$FF,$FF,$FF
 .db $FC,$00,$00,$00,$01,$BF,$DD,$FF,$FF,$FF,$38,$00,$00,$00,$00,$00
 .db $00,$8E,$EF,$87,$FF,$FF,$FF,$FF,$F1,$33,$DE,$27,$FF,$01,$F8,$00
 .db $00,$1F,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$00,$00,$07,$1F,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FC,$EF,$F0,$3F,$00,$4E,$00,$7F,$47,$FC,$FF
 .db $FF,$FF,$C0,$0C,$00,$00,$00,$00,$00,$83,$1E,$7F,$FF,$FF,$FF,$FF
 .db $CF,$FE,$33,$0F,$FF,$E0,$77,$00,$08,$01,$FF,$FF,$FF,$FF,$F0,$00
 .db $00,$00,$00,$00,$00,$60,$06,$7F,$FE,$7F,$FB,$FF,$F3,$F3,$BF,$EA
 .db $FF,$F0,$00,$00,$07,$0C,$FF,$7F,$FF,$FF,$FC,$3A,$00,$00,$00,$00
 .db $00,$00,$03,$FB,$FF,$7F,$FF,$FF,$FC,$FD,$88,$C0,$7F,$FE,$1F,$FC
 .db $04,$C0,$7F,$FF,$FF,$FF,$FE,$44,$00,$00,$00,$00,$00,$00,$02,$7F
 .db $FF,$DF,$FF,$FF,$FF,$FF,$BC,$FC,$C2,$3F,$8C,$EE,$17,$F0,$01,$FF
 .db $FF,$FF,$FF,$1F,$80,$00,$00,$00,$00,$00,$01,$FF,$DF,$FF,$7F,$FF
 .db $FF,$FF,$FC,$C6,$03,$BF,$FC,$FF,$FF,$00,$00,$4F,$FF,$FF,$FF,$9F
 .db $00,$00,$00,$00,$00,$C0,$00,$20,$03,$7F,$A7,$FF,$FF,$FF,$FE,$C6
 .db $4E,$64,$7F,$F7,$CC,$00,$46,$00,$2E,$63,$CE,$7F,$F6,$06,$40,$01
 .db $04,$30,$00,$00,$FC,$C4,$CF,$20,$7F,$FE,$7F,$F6,$0E,$7A,$6E,$66
 .db $FF,$B0,$03,$DC,$C3,$FC,$0F,$DF,$F9,$90,$80,$00,$00,$20,$0C,$21
 .db $87,$9F,$FD,$9F,$FE,$07,$FF,$19,$F9,$81,$39,$FC,$C7,$7C,$80,$FF
 .db $B0,$03,$18,$F3,$F7,$FE,$67,$60,$00,$00,$00,$00,$20,$87,$7F,$31
 .db $FF,$73,$7F,$FF,$7B,$E7,$E2,$1E,$FC,$DF,$9C,$33,$C1,$9C,$03,$FD
 .db $0F,$FD,$E1,$00,$00,$00,$00,$00,$1E,$40,$7D,$CF,$FF,$BF,$FF,$FF
 .db $FF,$CD,$BC,$00,$9D,$FF,$99,$1F,$F8,$03,$9F,$01,$FF,$F9,$B1,$FE
 .db $00,$20,$00,$00,$02,$77,$FE,$42,$7F,$FF,$FF,$FF,$FF,$FF,$F9,$08
 .db $33,$F3,$DF,$FD,$81,$F2,$30,$FD,$FF,$FE,$08,$00,$00,$00,$00,$00
 .db $00,$1E,$7F,$FB,$FF,$FE,$7F,$FF,$FD,$E6,$0F,$FF,$FF,$FF,$9C,$10
 .db $BF,$8F,$3E,$F0,$FB,$98,$00,$C0,$00,$00,$00,$06,$46,$1F,$FF,$FF
 .db $FF,$E0,$1B,$FC,$DF,$FC,$C7,$E7,$E7,$FF,$EF,$FE,$3F,$27,$32,$00
 .db $11,$F8,$30,$00,$00,$00,$C5,$9F,$FC,$FF,$FF,$3F,$FF,$FF,$FF,$F9
 .db $CD,$B8,$C3,$9F,$CE,$4D,$80,$30,$FE,$67,$20,$00,$00,$00,$01,$A0
 .db $0F,$FD,$D9,$FD,$9F,$F9,$FF,$FF,$EC,$E6,$CF,$FE,$7F,$E3,$26,$33
 .db $93,$03,$01,$31,$98,$00,$00,$00,$0C,$4C,$FF,$CF,$FF,$FF,$FF,$FE
 .db $FE,$67,$F2,$3B,$F3,$F7,$FF,$93,$9F,$80,$00,$00,$80,$00,$00,$07
 .db $8F,$FF,$E7,$FF,$FC,$F8,$F8,$3D,$3F,$EF,$CF,$E0,$F6,$FC,$1E,$EC
 .db $0C,$00,$C1,$82,$00,$00,$04,$00,$00,$07,$FF,$FF,$FF,$FF,$7F,$FF
 .db $2E,$26,$F3,$E7,$70,$67,$8F,$8F,$7F,$06,$10,$00,$00,$00,$00,$F0
 .db $FF,$FF,$DF,$FF,$BF,$FB,$FC,$5C,$7C,$6E,$CF,$E5,$F3,$C2,$62,$7F
 .db $06,$00,$00,$00,$08,$38,$DC,$1F,$FF,$E3,$FE,$FF,$FF,$FF,$BF,$B7
 .db $C1,$81,$F8,$00,$0E,$06,$00,$00,$00,$78,$3F,$FF,$81,$89,$11,$F3
 .db $FF,$7E,$7F,$C7,$0F,$F8,$73,$9C,$1F,$8D,$C3,$0E,$30,$23,$BF,$0C
 .db $1A,$C7,$FC,$FC,$FC,$5E,$73,$E7,$F0,$63,$E0,$01,$88,$01,$C1,$C2
 .db $FF,$FF,$BF,$FF,$DF,$F8,$00,$00,$00,$00,$00,$30,$FF,$FF,$FF,$FF
 .db $E3,$E1,$C0,$C0,$1F,$87,$1E,$0B,$FB,$3E,$3F,$FF,$FF,$3F,$F8,$3F
 .db $F8,$7F,$F0,$E3,$E0,$60,$00,$00,$00,$0F,$87,$91,$0E,$1E,$7F,$E6
 .db $7E,$F8,$FF,$F9,$FF,$F3,$E7,$F7,$E7,$EF,$FF,$8F,$9F,$1D,$3C,$1E
 .db $3F,$7E,$30,$40,$00,$20,$E0,$8E,$00,$E1,$E7,$F6,$77,$0F,$87,$FF
 .db $DB,$F8,$0C,$3E,$FF,$4F,$E0,$70,$71,$FE,$03,$03,$C7,$FF,$80,$00
 .db $07,$1F,$3F,$FF,$FF,$FC,$7F,$FF,$87,$00,$00,$03,$1B,$FF,$8F,$87
 .db $DE,$18,$78,$7F,$0E,$3F,$F3,$BC,$5E,$0F,$F8,$0F,$00,$0C,$02,$72
 .db $40,$20,$7E,$1C,$A0,$84,$9F,$FF,$FF,$FE,$73,$87,$FF,$F9,$FF,$80
 .db $00,$C7,$DC,$3C,$00,$3F,$FF,$FE,$00,$30,$83,$DF,$F9,$C0,$01,$23
 .db $F3,$CF,$00,$00,$00,$1C,$0E,$0F,$FF,$F9,$F0,$10,$48,$0E,$FF,$FF
 .db $FC,$3F,$FF,$FF,$FF,$80,$00,$00,$7C,$FC,$1F,$FF,$F9,$E0,$C1,$A0
 .db $3B,$FF,$C1,$80,$00,$1F,$CF,$CE,$00,$1F,$FD,$B8,$06,$1F,$F1,$00
 .db $00,$0F,$FF,$FF,$FF,$FF,$E3,$3F,$FF,$FF,$FC,$00,$00,$61,$41,$1B
 .db $73,$DC,$0C,$30,$06,$10,$F9,$FF,$90,$00,$1F,$FF,$FF,$FE,$01,$21
 .db $87,$00,$37,$FF,$F8,$00,$00,$8C,$FF,$FF,$FF,$F1,$E4,$7F,$FF,$F9
 .db $00,$00,$02,$0C,$00,$FF,$FF,$FC,$61,$80,$14,$6F,$BF,$FF,$80,$03
 .db $FB,$FF,$FC,$10,$00,$0C,$78,$03,$BF,$7F,$F8,$00,$00,$23,$FF,$FF
 .db $FF,$3F,$86,$7F,$3F,$BC,$C1,$00,$00,$80,$07,$FD,$3F,$E0,$0F,$00
 .db $07,$7F,$FF,$F8,$20,$00,$0F,$FF,$FF,$E6,$00,$27,$B0,$1F,$E1,$BF
 .db $C0,$00,$00,$07,$EF,$FF,$FB,$F0,$6C,$FD,$FF,$F8,$00,$00,$00,$00
 .db $1F,$FF,$FF,$C1,$FC,$00,$16,$7F,$FF,$BF,$F3,$80,$3F,$FF,$F3,$A0
 .db $00,$10,$00,$7F,$FF,$36,$00,$00,$06,$28,$FF,$FE,$0F,$FE,$01,$FF
 .db $FF,$FB,$80,$00,$80,$03,$FF,$F8,$6D,$80,$00,$00,$07,$FF,$10,$7F
 .db $80,$0D,$FF,$FF,$F8,$00,$FF,$00,$07,$F7,$FF,$F0,$27,$80,$00,$FF
 .db $F8,$1F,$FC,$00,$7F,$8F,$FE,$40,$7E,$00,$07,$FF,$FF,$BB,$79,$30
 .db $00,$C7,$FF,$A0,$FF,$F0,$07,$FC,$3F,$F8,$0F,$88,$00,$FF,$3F,$9C
 .db $3F,$F0,$00,$00,$03,$F7,$E7,$FF,$70,$FF,$FF,$FF,$F0,$4F,$80,$00
 .db $E0,$1F,$FB,$9F,$F2,$00,$03,$9F,$87,$3E,$F1,$00,$73,$87,$FF,$C3
 .db $7E,$60,$03,$F8,$1F,$D8,$3E,$CA,$00,$00,$0F,$FF,$CF,$CE,$20,$47
 .db $FE,$FF,$CC,$30,$C0,$00,$00,$7F,$F8,$CF,$E4,$20,$01,$38,$FF,$FE
 .db $3F,$F3,$00,$03,$FF,$7F,$E7,$00,$10,$42,$4E,$7F,$F3,$00,$40,$00
 .db $3F,$FF,$FF,$FC,$C7,$FD,$80,$7F,$E1,$C6,$00,$01,$C0,$3F,$FF,$FE
 .db $00,$00,$00,$03,$FF,$FF,$9D,$C0,$0F,$00,$FF,$FF,$A0,$1B,$61,$80
 .db $38,$CF,$F8,$00,$00,$00,$0F,$FF,$FC,$C3,$EC,$00,$87,$FC,$3F,$20
 .db $1F,$00,$03,$FF,$FF,$F8,$03,$00,$03,$BF,$FF,$DC,$66,$E0,$01,$FF
 .db $FF,$FE,$00,$7F,$00,$06,$00,$27,$3B,$7F,$FF,$FF,$FF,$FF,$80,$00
 .db $00,$00,$00,$D8,$C7,$FF,$FD,$FB,$DD,$DF,$73,$20,$20,$00,$1C,$C3
 .db $9F,$FC,$3F,$EF,$FF,$FF,$FF,$FF,$FF,$D8,$FF,$80,$00,$00,$00,$00
 .db $00,$01,$07,$38,$C0,$00,$07,$FF,$FF,$FE,$33,$7F,$FC,$FF,$FE,$7F
 .db $FF,$FF,$80,$01,$F7,$3F,$FF,$93,$FC,$00,$7F,$C4,$FF,$C0,$01,$80
 .db $00,$00,$0C,$78,$6F,$B0,$03,$FC,$4F,$FF,$E1,$FF,$80,$1F,$FF,$30
 .db $40,$1E,$20,$01,$91,$1F,$FE,$06,$70,$00,$1B,$FF,$FF,$C3,$FF,$FC
 .db $07,$FF,$FF,$FC,$00,$F0,$00,$04,$3B,$FE,$00,$00,$00,$03,$7F,$FF
 .db $C8,$0D,$F8,$01,$FF,$FF,$F8,$00,$00,$00,$1F,$FF,$FF,$C0,$00,$00
 .db $7F,$FF,$FF,$3F,$FF,$F0,$13,$FF,$FF,$FD,$8F,$E0,$00,$00,$00,$00
 .db $E6,$00,$00,$00,$7F,$FA,$07,$FF,$FC,$FF,$FF,$9F,$C0,$00,$00,$01
 .db $EF,$FF,$80,$07,$FF,$FF,$F7,$FB,$F0,$0C,$70,$1F,$FF,$E7,$C0,$1F
 .db $F0,$1F,$F0,$01,$F0,$00,$7F,$00,$00,$01,$FF,$FF,$FF,$FF,$01,$3F
 .db $80,$1F,$C0,$D8,$00,$60,$00,$FF,$FF,$F8,$00,$01,$FF,$FF,$80,$03
 .db $F0,$0C,$3F,$FF,$FF,$F9,$00,$00,$07,$86,$F0,$70,$00,$00,$0F,$1F
 .db $FF,$E3,$FF,$FF,$10,$FF,$F6,$FF,$FF,$E0,$00,$00,$00,$FF,$9F,$F0
 .db $00,$44,$3F,$FF,$FF,$FF,$C0,$00,$0F,$FF,$FF,$FF,$F0,$08,$00,$00
 .db $C1,$87,$F0,$00,$00,$7F,$FF,$FF,$FF,$00,$01,$FF,$FD,$FC,$0D,$E0
 .db $00,$00,$3F,$FF,$FF,$80,$00,$00,$3F,$FF,$EF,$FF,$80,$07,$7A,$FF
 .db $FF,$FF,$80,$00,$00,$0E,$FF,$0F,$C0,$00,$10,$4F,$FF,$FF,$FC,$00
 .db $07,$FF,$FF,$F0,$00,$00,$00,$30,$27,$FF,$FF,$C0,$00,$00,$3F,$FB
 .db $03,$FF,$40,$7F,$FF,$FF,$FF,$CE,$00,$00,$73,$CE,$78,$7F,$80,$00
 .db $40,$07,$FF,$FF,$FF,$C0,$1F,$FF,$FF,$C0,$0E,$80,$00,$20,$FF,$FF
 .db $F8,$00,$00,$21,$FF,$FF,$BF,$FE,$00,$3F,$F9,$FF,$FF,$B8,$00,$00
 .db $80,$7F,$FF,$FC,$00,$00,$01,$1F,$FF,$FF,$FC,$00,$B3,$FF,$FF,$F0
 .db $00,$00,$01,$88,$FF,$FF,$F0,$00,$00,$03,$FF,$FF,$FF,$FE,$00,$3F
 .db $E7,$FF,$FE,$E0,$00,$03,$31,$DF,$C0,$C0,$00,$00,$0E,$FF,$FF,$FF
 .db $F0,$80,$3F,$FF,$FF,$C0,$44,$00,$00,$00,$7F,$FF,$F0,$00,$00,$0C
 .db $FF,$DF,$FF,$FF,$00,$7F,$F7,$FF,$F3,$80,$00,$00,$00,$FF,$FF,$C0
 .db $00,$00,$30,$FF,$9E,$FF,$FC,$00,$FF,$FF,$FF,$00,$00,$00,$08,$80
 .db $7F,$FF,$88,$00,$00,$63,$FF,$FB,$DF,$FF,$80,$FF,$DF,$FF,$FF,$E0
 .db $00,$00,$03,$FF,$DF,$80,$00,$00,$80,$CF,$FF,$FF,$FE,$01,$FC,$CF
 .db $FE,$00,$38,$08,$00,$E4,$06,$F2,$03,$90,$00,$1F,$F1,$FF,$80,$7C
 .db $00,$1F,$FF,$FF,$E0,$0F,$80,$3F,$80,$3F,$E0,$00,$7E,$03,$FB,$60
 .db $7F,$FF,$80,$39,$03,$FF,$F8,$3C,$00,$00,$78,$FF,$07,$FE,$07,$F0
 .db $3F,$FE,$67,$FC,$03,$C0,$01,$FF,$00,$FF,$F0,$FF,$C0,$03,$E4,$07
 .db $FE,$00,$FF,$3F,$3F,$F0,$09,$00,$10,$5F,$F7,$FF,$FF,$FF,$F8,$00
 .db $00,$00,$00,$80,$E0,$00,$3F,$FF,$DF,$FF,$E7,$C8,$05,$F0,$00,$7C
 .db $FE,$63,$02,$FB,$7F,$FF,$FF,$FB,$FF,$FF,$9F,$F0,$01,$80,$00,$00
 .db $00,$00,$03,$F0,$00,$01,$27,$37,$C3,$FF,$07,$2F,$FE,$7F,$FE,$3F
 .db $FD,$F8,$3F,$F9,$FF,$FF,$FF,$F8,$00,$12,$3E,$00,$24,$00,$00,$78
 .db $F3,$80,$26,$E3,$C0,$0F,$FB,$FF,$FF,$BF,$E0,$00,$3C,$F8,$60,$FE
 .db $00,$01,$E1,$FF,$40,$0F,$CF,$9E,$FB,$FF,$07,$FE,$7F,$C0,$00,$3F
 .db $E1,$DF,$86,$00,$77,$C7,$FC,$00,$77,$FE,$08,$70,$FF,$8F,$FC,$FF
 .db $80,$00,$3F,$C1,$0F,$98,$30,$0F,$1F,$FC,$03,$03,$70,$23,$77,$3F
 .db $1F,$FF,$FF,$80,$08,$FF,$00,$3F,$E3,$C2,$39,$FF,$F8,$05,$8F,$C0
 .db $0C,$0C,$98,$3F,$BF,$7C,$00,$00,$F8,$20,$E5,$C4,$80,$E3,$FF,$F0
 .db $10,$1F,$01,$27,$27,$FE,$FF,$FF,$FC,$00,$03,$F0,$05,$FC,$1E,$23
 .db $0F,$FF,$E0,$60,$1C,$00,$11,$83,$F3,$F7,$FF,$C0,$04,$0F,$84,$06
 .db $18,$7F,$04,$3F,$FE,$10,$30,$74,$40,$7E,$F1,$FD,$9F,$FF,$E0,$00
 .db $64,$84,$C2,$C2,$43,$01,$FF,$FF,$03,$0F,$03,$C0,$04,$1F,$7E,$1F
 .db $FF,$10,$0D,$F0,$3E,$18,$1F,$1C,$01,$FA,$70,$60,$3F,$36,$F9,$89
 .db $FF,$F0,$FF,$FE,$40,$01,$C0,$E2,$E0,$3F,$FC,$07,$FF,$C3,$80,$20
 .db $FE,$1E,$03,$07,$80,$FF,$FC,$1C,$7C,$1F,$10,$40,$6C,$F0,$3D,$BF
 .db $80,$F1,$E3,$FC,$1B,$DF,$7F,$0F,$FF,$FF,$01,$F0,$1E,$02,$07,$FC
 .db $80,$7C,$3F,$F8,$1F,$07,$F0,$70,$38,$78,$1F,$E3,$FF,$E1,$F0,$1F
 .db $C0,$01,$FF,$81,$FE,$0F,$7C,$0F,$07,$F0,$3C,$3F,$FE,$07,$F8,$7F
 .db $0F,$F0,$3F,$80,$03,$FE,$00,$3F,$07,$F0,$F1,$FC,$3F,$C1,$C0,$7C
 .db $00,$FF,$F8,$0C,$0F,$CC,$F0,$00,$00,$07,$F8,$1F,$C0,$03,$FE,$7F
 .db $81,$FF,$F0,$3F,$FF,$E0,$7C,$00,$03,$91,$FE,$07,$00,$0F,$FE,$03
 .db $DC,$01,$FE,$03,$F2,$33,$FF,$F7,$FC,$00,$00,$EC,$18,$80,$7E,$03
 .db $19,$FD,$D8,$0D,$C0,$FE,$0F,$FF,$EF,$EF,$FF,$C3,$60,$03,$00,$80
 .db $1F,$DC,$00,$7F,$FF,$80,$03,$9F,$F9,$9F,$BC,$00,$0D,$FF,$FC,$C0
 .db $38,$31,$80,$3B,$80,$80,$CF,$FE,$00,$06,$00,$60,$1F,$FF,$9E,$7F
 .db $FF,$FF,$00,$70,$00,$00,$62,$70,$03,$FF,$FF,$C0,$0C,$F0,$F8,$7F
 .db $8F,$00,$FF,$FF,$F8,$81,$C0,$00,$00,$0E,$FC,$0F,$FF,$FA,$00,$21
 .db $F3,$80,$FE,$1C,$E0,$FF,$FF,$F2,$03,$00,$00,$0D,$91,$E0,$05,$FF
 .db $FF,$F8,$E0,$06,$03,$00,$7F,$80,$FF,$F1,$FF,$FC,$00,$7C,$00,$7F
 .db $01,$FC,$C1,$FC,$21,$FF,$80,$07,$E0,$07,$F9,$FF,$FF,$F8,$00,$C8
 .db $00,$3F,$F0,$38,$E0,$FF,$F0,$F3,$F0,$7F,$C0,$7E,$00,$07,$FF,$7F
 .db $E0,$3F,$03,$E0,$31,$70,$E0,$47,$C1,$FF,$00,$7C,$79,$83,$8C,$7B
 .db $E1,$FF,$97,$E0,$0E,$0E,$E0,$7F,$C3,$C0,$3E,$0F,$F0,$7F,$C1,$F8
 .db $1F,$01,$E0,$7F,$C7,$FE,$00,$8F,$E0,$03,$0E,$CC,$06,$F0,$F3,$E2
 .db $07,$C7,$C0,$7C,$F0,$F0,$67,$FF,$FE,$FE,$79,$B8,$00,$81,$F8,$0E
 .db $38,$7F,$86,$FF,$71,$C1,$C7,$06,$01,$9F,$BF,$FF,$F2,$F3,$62,$02
 .db $27,$E2,$18,$3C,$3C,$91,$C4,$E6,$F8,$0F,$C3,$83,$1F,$FF,$FF,$EF
 .db $FC,$00,$00,$C7,$CC,$7E,$FF,$E6,$47,$E0,$3E,$04,$C1,$8E,$04,$FF
 .db $FF,$FF,$DC,$E0,$00,$03,$C1,$F8,$03,$37,$FF,$07,$F8,$00,$42,$26
 .db $7F,$C0,$FF,$EF,$FC,$C7,$98,$00,$01,$C7,$9F,$8D,$FF,$FF,$3C,$90
 .db $01,$00,$E1,$FF,$8F,$9F,$FF,$FD,$BF,$80,$00,$02,$04,$7C,$21,$FF
 .db $F1,$CF,$16,$10,$19,$07,$F8,$FF,$FE,$1F,$07,$F3,$F8,$00,$1E,$1F
 .db $E0,$E7,$F8,$00,$0F,$81,$C0,$0F,$F8,$FF,$9F,$BC,$7F,$F3,$F8,$00
 .db $00,$00,$07,$F3,$F0,$07,$00,$39,$C1,$CE,$70,$4F,$F8,$7F,$F4,$FF
 .db $E3,$7E,$00,$01,$C0,$3F,$F3,$F7,$00,$00,$64,$03,$C0,$1C,$01,$E3
 .db $FF,$7F,$FB,$CF,$3C,$00,$01,$80,$38,$FF,$82,$00,$00,$1E,$1C,$03
 .db $CC,$0F,$FB,$FF,$BF,$BF,$F8,$00,$00,$03,$87,$E7,$FF,$78,$02,$00
 .db $00,$9C,$00,$8E,$1D,$FF,$FF,$FF,$FF,$DB,$81,$80,$08,$07,$FF,$FF
 .db $E6,$00,$00,$00,$00,$7F,$F9,$FF,$FF,$FD,$FF,$FF,$FF,$80,$00,$00
 .db $0F,$7F,$FF,$F8,$00,$00,$00,$00,$00,$03,$FF,$FF,$CF,$FF,$FF,$FC
 .db $00,$00,$00,$7F,$FF,$E8,$00,$00,$00,$06,$00,$E7,$CF,$FF,$FF,$31
 .db $FF,$FF,$F8,$40,$00,$00,$3F,$FF,$FF,$BE,$00,$00,$00,$00,$08,$05
 .db $FF,$FF,$FF,$EF,$FF,$E3,$98,$00,$00,$8F,$FF,$70,$00,$00,$00,$80
 .db $00,$3C,$1F,$FF,$FF,$FF,$DF,$FF,$E6,$00,$00,$01,$1D,$FF,$FD,$80
 .db $00,$00,$00,$00,$80,$03,$9F,$DD,$FF,$FF,$FF,$FC,$50,$00,$00,$03
 .db $FF,$F7,$F6,$00,$00,$00,$00,$1E,$FF,$FF,$FF,$FF,$FF,$20,$00,$00
 .db $00,$00,$01,$FF,$FF,$FF,$FF,$FB,$35,$00,$00,$04,$84,$60,$21,$FF
 .db $FF,$FF,$FF,$FF,$BF,$FF,$FF,$FF,$D8,$C0,$40,$00,$00,$00,$00,$00
 .db $00,$05,$1F,$CE,$98,$00,$00,$02,$FF,$FF,$FF,$FB,$E3,$F7,$FF,$3F
 .db $9E,$FF,$F7,$FE,$FF,$FF,$FF,$FF,$C0,$00,$00,$01,$08,$00,$00,$00
 .db $00,$00,$08,$45,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$00,$00,$17,$FF
 .db $FF,$A0,$00,$14,$20,$60,$87,$7F,$FF,$A7,$FF,$FF,$FF,$FF,$00,$00
 .db $00,$FF,$FF,$7F,$74,$00,$C0,$00,$00,$00,$12,$FF,$FB,$FF,$FF,$FF
 .db $FD,$00,$00,$00,$7F,$FB,$BC,$80,$00,$00,$00,$00,$3F,$FB,$7F,$FF
 .db $FF,$FF,$FF,$FD,$80,$01,$CF,$FF,$FF,$FC,$00,$00,$00,$00,$00,$DE
 .db $5B,$FF,$FF,$FD,$BF,$FE,$00,$00,$00,$09,$FF,$FF,$F4,$00,$00,$23
 .db $00,$01,$70,$FF,$FF,$FF,$FF,$FF,$FF,$FC,$00,$00,$3F,$FF,$BD,$C0
 .db $00,$3D,$8E,$00,$7F,$C0,$00,$01,$FF,$9F,$FF,$FE,$E0,$00,$0F,$FF
 .db $FF,$FF,$08,$0E,$FF,$FE,$00,$3F,$80,$08,$FF,$AF,$E7,$FF,$FF,$80
 .db $04,$0C,$00,$00,$3F,$FF,$80,$7F,$F4,$00,$06,$00,$0F,$FF,$FF,$07
 .db $FF,$FF,$00,$00,$00,$1B,$FF,$FF,$E8,$00,$50,$EE,$00,$3E,$C2,$06
 .db $3F,$FE,$0F,$FF,$FE,$00,$00,$00,$1F,$FF,$E0,$00,$63,$FF,$C0,$00
 .db $00,$03,$1D,$FF,$FF,$FF,$FF,$F0,$00,$00,$DE,$7E,$EF,$FC,$08,$47
 .db $FE,$00,$00,$18,$00,$30,$7F,$FF,$FF,$FF,$F8,$00,$00,$00,$33,$FF
 .db $8C,$00,$FF,$FF,$70,$00,$3A,$8F,$FF,$FF,$EF,$F7,$FF,$F0,$00,$01
 .db $FB,$FF,$FF,$FD,$80,$0B,$F0,$20,$00,$00,$03,$80,$5F,$FF,$FF,$FF
 .db $F8,$00,$00,$00,$FF,$FF,$90,$01,$F3,$FF,$E0,$03,$F0,$01,$03,$FF
 .db $FF,$FF,$FF,$F0,$00,$00,$07,$FF,$FF,$E6,$00,$1F,$FF,$88,$00,$00
 .db $06,$08,$7F,$FF,$FF,$FF,$F0,$00,$00,$01,$FF,$FC,$40,$00,$3F,$FF
 .db $E0,$04,$00,$07,$3F,$FF,$FF,$FF,$FF,$C0,$00,$0F,$07,$FF,$FD,$F8
 .db $00,$7F,$FF,$E0,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$E0,$00,$00,$07
 .db $FF,$FF,$78,$30,$7F,$FE,$00,$00,$00,$7F,$FF,$EF,$EF,$FF,$FF,$80
 .db $00,$04,$3E,$FF,$FF,$C0,$14,$FF,$FF,$00,$00,$00,$02,$7F,$FF,$FF
 .db $FF,$FF,$00,$00,$67,$F4,$1E,$11,$80,$03,$FF,$FE,$00,$00,$00,$FE
 .db $FF,$FF,$3F,$FF,$FF,$00,$00,$00,$01,$FF,$FF,$F7,$87,$FF,$F0,$00
 .db $04,$06,$60,$7E,$7F,$9F,$FF,$FE,$00,$00,$00,$0F,$FF,$CE,$00,$1F
 .db $FF,$F8,$00,$00,$01,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$0F,$F7
 .db $FF,$72,$7F,$FF,$80,$00,$00,$03,$81,$F9,$DF,$FF,$FF,$FE,$00,$00
 .db $00,$03,$FB,$92,$00,$1F,$FF,$C0,$00,$00,$07,$FE,$7F,$80,$FF,$FF
 .db $F8,$00,$00,$00,$7F,$FF,$FF,$CF,$FF,$F8,$00,$00,$00,$07,$8E,$73
 .db $FF,$FF,$FF,$F9,$80,$00,$00,$27,$FF,$F0,$04,$FF,$FE,$00,$00,$20
 .db $3F,$FF,$FE,$01,$FF,$FF,$F0,$00,$00,$03,$7F,$FF,$F9,$BF,$FF,$F0
 .db $00,$00,$00,$3F,$FC,$7F,$87,$FF,$FF,$FE,$00,$00,$00,$0F,$C3,$38
 .db $73,$FF,$FC,$00,$00,$00,$3F,$FF,$FE,$60,$7F,$FF,$E0,$00,$00,$07
 .db $FF,$FF,$F0,$03,$9F,$F8,$00,$00,$00,$77,$01,$FF,$1F,$FF,$FF,$FF
 .db $00,$00,$01,$FE,$07,$FE,$00,$01,$FF,$F8,$00,$00,$7F,$F7,$FE,$1C
 .db $FF,$FF,$FF,$00,$00,$0F,$FF,$CB,$CF,$78,$3F,$E0,$00,$00,$01,$CC
 .db $00,$00,$8F,$FF,$FF,$FF,$1F,$F8,$00,$1E,$06,$00,$00,$0F,$10,$00
 .db $01,$FF,$FF,$FC,$20,$00,$C1,$FF,$E0,$00,$0F,$FF,$FC,$01,$82,$00
 .db $27,$F0,$00,$00,$07,$FF,$F6,$CF,$FF,$F7,$E0,$00,$01,$00,$3F,$FF
 .db $FD,$C0,$00,$00,$1F,$C0,$00,$3F,$FF,$C7,$FE,$07,$FF,$F8,$00,$00
 .db $00,$7F,$FF,$C0,$1F,$EF,$CF,$F0,$00,$06,$00,$00,$FF,$3F,$FF,$FE
 .db $0F,$FF,$80,$07,$20,$00,$7F,$C0,$07,$C0,$FF,$F8,$00,$3C,$FF,$01
 .db $FC,$9F,$FF,$F0,$07,$AF,$C1,$FF,$00,$80,$00,$0F,$FF,$80,$00,$3E
 .db $7F,$F0,$3E,$00,$7F,$FF,$80,$07,$F0,$00,$0F,$FF,$FF,$FF,$80,$00
 .db $00,$00,$00,$7F,$FF,$F9,$FF,$FF,$FF,$C8,$00,$00,$00,$70,$FF,$F0
 .db $00,$7F,$FF,$E0,$00,$00,$03,$00,$00,$0F,$FF,$FF,$C7,$FF,$C0,$FF
 .db $FF,$FF,$00,$00,$00,$00,$7F,$C7,$87,$FE,$7F,$FF,$E0,$01,$FF,$DD
 .db $F8,$00,$00,$7F,$FF,$FF,$FF,$FF,$FC,$00,$00,$00,$03,$E0,$03,$FF
 .db $FF,$FF,$FF,$FF,$FF,$F8,$00,$FF,$FF,$00,$00,$0F,$E0,$BF,$FF,$0F
 .db $E0,$1F,$80,$FF,$80,$3F,$FF,$80,$37,$FF,$80,$1E,$03,$FC,$07,$F0
 .db $00,$0E,$00,$70,$03,$FD,$FC,$3F,$E1,$F0,$0F,$F8,$78,$3F,$87,$00
 .db $03,$01,$71,$FF,$BF,$00,$3F,$FE,$0F,$DB,$F0,$00,$2F,$81,$FF,$FE
 .db $47,$FF,$00,$3C,$00,$03,$FC,$02,$BC,$03,$C3,$E1,$FF,$FF,$FF,$E3
 .db $FF,$F0,$00,$00,$00,$70,$00,$3F,$FF,$7F,$FF,$9F,$FF,$8C,$0F,$80
 .db $01,$80,$10,$01,$8F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00
 .db $00,$01,$00,$C0,$00,$00,$00,$FF,$9E,$78,$F8,$00,$00,$1F,$FF,$FF
 .db $FF,$9F,$FF,$9F,$FF,$FF,$FF,$CF,$E7,$01,$DF,$C3,$FE,$00,$01,$00
 .db $03,$E7,$F8,$00,$00,$00,$01,$FF,$3F,$FB,$9F,$FF,$FF,$EF,$FF,$B1
 .db $FF,$C0,$0E,$3F,$07,$FE,$3C,$00,$1B,$0F,$FF,$FE,$07,$00,$00,$06
 .db $3E,$3F,$3F,$03,$1F,$FF,$7F,$FF,$87,$FF,$E0,$13,$0F,$01,$FF,$F0
 .db $30,$10,$0F,$FF,$F0,$60,$00,$00,$00,$F0,$77,$F0,$18,$7F,$C0,$FF
 .db $FF,$FF,$FF,$00,$1F,$07,$FF,$FF,$87,$02,$01,$FF,$FF,$FE,$3F,$00
 .db $00,$60,$00,$7E,$21,$84,$C0,$06,$7E,$7F,$FF,$FF,$F0,$3F,$7F,$F3
 .db $E7,$B0,$00,$00,$3F,$FF,$FE,$07,$F8,$00,$00,$00,$0E,$3B,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$C0,$00,$07,$FF,$FF,$80,$00,$03,$BF,$FF,$FC
 .db $23,$20,$00,$00,$00,$00,$1F,$3F,$8F,$FE,$7F,$FF,$FF,$BF,$E0,$04
 .db $03,$7F,$E7,$FF,$F2,$33,$8C,$FF,$FF,$FF,$F8,$00,$00,$00,$01,$8F
 .db $FE,$00,$7F,$FF,$FF,$FF,$8C,$F0,$00,$1F,$FF,$EF,$FF,$20,$01,$8F
 .db $FF,$FF,$FF,$1F,$00,$00,$00,$00,$41,$87,$00,$7F,$FF,$FF,$FF,$C6
 .db $F8,$07,$38,$5F,$E0,$FF,$FF,$00,$47,$BF,$FF,$FF,$BF,$80,$00,$00
 .db $00,$26,$7F,$E6,$3F,$FF,$FF,$FF,$E0,$7A,$01,$7C,$4F,$FD,$FF,$FF
 .db $00,$3F,$BF,$FF,$FF,$9B,$F0,$00,$00,$00,$02,$3E,$C0,$1F,$F3,$FF
 .db $FF,$D0,$FE,$20,$7F,$FF,$10,$7F,$C1,$3F,$98,$19,$F1,$9F,$FF,$FD
 .db $80,$01,$80,$04,$CC,$07,$F7,$9B,$1F,$FF,$F0,$FF,$B0,$17,$F8,$03
 .db $FF,$80,$7D,$E0,$87,$FF,$19,$FB,$C0,$02,$10,$00,$3F,$00,$7F,$E6
 .db $0F,$FE,$0F,$FF,$E7,$1C,$DB,$DC,$3F,$80,$11,$FF,$C7,$FF,$F3,$7C
 .db $60,$06,$10,$02,$32,$60,$08,$EB,$CD,$FF,$FF,$FF,$FF,$EC,$F4,$00
 .db $00,$02,$00,$40,$00,$FF,$FF,$FB,$FF,$F8,$EF,$F8,$00,$00,$00,$03
 .db $FC,$F7,$FF,$FF,$FF,$FF,$FF,$FF,$E3,$BF,$FB,$00,$00,$00,$00,$00
 .db $00,$03,$00,$01,$F8,$00,$01,$00,$1F,$F9,$FF,$FF,$FF,$FF,$FF,$FF
 .db $9F,$FE,$DF,$FF,$E6,$7C,$C1,$1F,$F9,$A2,$03,$67,$22,$30,$00,$00
 .db $00,$01,$78,$67,$FF,$F7,$FF,$FF,$FF,$9F,$FF,$91,$FF,$B0,$98,$80
 .db $1F,$F9,$81,$9B,$DF,$FF,$7B,$C0,$00,$00,$01,$FB,$0E,$FF,$C6,$7F
 .db $F7,$7F,$F1,$CF,$FF,$F7,$FE,$67,$84,$67,$E6,$06,$60,$04,$FF,$C6
 .db $30,$00,$00,$00,$8C,$03,$BF,$82,$FF,$F8,$1F,$F8,$F3,$FF,$F3,$FF
 .db $B8,$04,$7F,$70,$03,$F0,$07,$FF,$73,$9F,$80,$00,$00,$20,$06,$F6
 .db $CC,$FF,$61,$9F,$F6,$CE,$FF,$61,$9E,$72,$00,$67,$64,$04,$F3,$0E
 .db $FF,$66,$44,$80,$00,$00,$04,$27,$FB,$CC,$7F,$E7,$FF,$F7,$FF,$FF
 .db $E4,$2F,$81,$98,$1F,$EE,$60,$44,$00,$7F,$FF,$B7,$80,$00,$00,$00
 .db $03,$FF,$FB,$3F,$F3,$1B,$FF,$FF,$EF,$FF,$9F,$01,$78,$0F,$FC,$00
 .db $81,$1E,$FF,$FF,$FC,$00,$00,$00,$00,$13,$FF,$FC,$1F,$FF,$FF,$E7
 .db $FF,$B1,$FF,$FF,$C0,$F0,$06,$3F,$F6,$00,$00,$1F,$FF,$FF,$E0,$00
 .db $00,$00,$03,$F4,$F6,$0F,$FF,$FF,$FD,$FF,$DF,$7F,$FF,$80,$00,$13
 .db $C6,$24,$00,$00,$3F,$FF,$FF,$FC,$00,$00,$00,$03,$FF,$F0,$01,$FF
 .db $FF,$FF,$FF,$F3,$3F,$BF,$E7,$80,$43,$8F,$1F,$FF,$00,$01,$FF,$FF
 .db $FF,$60,$00,$00,$03,$FF,$30,$00,$FF,$FF,$FF,$FF,$FF,$8F,$FF,$F8
 .db $80,$0F,$D9,$F8,$98,$00,$01,$FF,$FF,$FF,$00,$00,$00,$00,$4C,$00
 .db $00,$67,$FF,$FB,$FF,$F0,$FF,$FF,$FF,$10,$3E,$07,$FF,$C0,$00,$00
 .db $3F,$FF,$FF,$C0,$00,$00,$02,$20,$00,$00,$FF,$FC,$7F,$08,$CF,$FF
 .db $EF,$FF,$FF,$81,$F7,$F3,$80,$01,$47,$FF,$FF,$00,$31,$00,$00,$00
 .db $00,$F3,$DF,$EC,$17,$FF,$30,$0F,$FF,$FF,$BF,$FF,$0F,$FF,$EE,$00
 .db $00,$00,$9F,$FF,$80,$8C,$04,$88,$60,$82,$80,$60,$00,$0C,$FF,$FF
 .db $FF,$FF,$E0,$98,$3F,$FF,$FF,$33,$80,$3E,$63,$7F,$B9,$D2,$00,$10
 .db $03,$B3,$98,$00,$00,$01,$11,$CC,$01,$FF,$FF,$FF,$CC,$FF,$DE,$EF
 .db $B9,$84,$62,$0B,$E7,$3D,$E6,$33,$DE,$40,$08,$84,$00,$00,$00,$06
 .db $72,$63,$FF,$FF,$F7,$7B,$3F,$FF,$BF,$FF,$79,$80,$00,$00,$1F,$FE
 .db $CF,$7B,$30,$06,$F8,$00,$00,$00,$00,$67,$1B,$FF,$EF,$FF,$FF,$FF
 .db $FB,$19,$98,$9C,$80,$7F,$FF,$BD,$FF,$10,$03,$00,$08,$FE,$0C,$01
 .db $20,$00,$06,$01,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$FF,$7F,$00,$20,$C7
 .db $7B,$3F,$FF,$FE,$00,$00,$10,$C4,$00,$00,$00,$00,$00,$7F,$FF,$FF
 .db $FF,$FF,$FF,$CE,$FE,$E0,$00,$07,$FF,$80,$63,$BF,$FC,$00,$03,$33
 .db $D0,$00,$00,$00,$00,$03,$F7,$FF,$FF,$FF,$EF,$FF,$FF,$FF,$FC,$60
 .db $00,$08,$FF,$BF,$FF,$DC,$C0,$00,$00,$FF,$F8,$00,$00,$00,$00,$1E
 .db $7F,$FF,$FF,$C0,$3F,$FF,$FF,$FF,$18,$00,$F3,$FF,$00,$00,$0F,$FB
 .db $10,$01,$FC,$00,$07,$80,$00,$00,$1F,$FF,$FF,$FF,$FF,$FF,$FC,$D0
 .db $1E,$0C,$FF,$FF,$C8,$01,$FF,$9F,$C0,$00,$00,$FF,$EC,$A0,$00,$00
 .db $01,$FF,$FF,$FF,$FF,$FF,$EF,$FF,$FF,$FF,$FF,$80,$02,$02,$1F,$FF
 .db $E0,$E8,$00,$00,$04,$00,$03,$FF,$00,$00,$00,$00,$0F,$FF,$FF,$FF
 .db $BF,$FF,$FE,$C4,$03,$7F,$A6,$64,$11,$01,$FF,$FF,$CC,$80,$08,$00
 .db $E0,$00,$00,$02,$FF,$FF,$FD,$FC,$41,$FF,$FF,$FC,$63,$3D,$EC,$E1
 .db $3E,$61,$0C,$03,$1F,$B2,$60,$07,$80,$04,$CC,$40,$04,$01,$FF,$FE
 .db $FF,$44,$C1,$FF,$D9,$05,$B8,$CF,$FE,$66,$10,$63,$00,$7F,$88,$00
 .db $80,$63,$97,$39,$FF,$98,$33,$DC,$67,$FE,$77,$FE,$61,$9E,$00,$0D
 .db $FB,$85,$FE,$03,$F3,$80,$01,$80,$3F,$FC,$FF,$CC,$00,$60,$44,$78
 .db $6B,$9F,$FF,$FF,$F7,$FE,$30,$00,$00,$00,$00,$03,$0B,$FD,$FF,$FF
 .db $FE,$E4,$C0,$00,$08,$E2,$47,$C0,$EC,$6F,$1F,$FF,$FF,$FF,$FF,$FF
 .db $EC,$00,$60,$40,$00,$08,$40,$00,$00,$00,$00,$19,$BD,$FF,$03,$E3
 .db $FF,$EF,$FF,$CF,$FF,$FF,$3E,$7C,$07,$C7,$F9,$7F,$FF,$9F,$90,$80
 .db $1C,$03,$DE,$36,$30,$24,$03,$7F,$F8,$FF,$83,$18,$08,$C0,$9F,$07
 .db $FF,$FF,$FF,$7E,$06,$00,$60,$3F,$F8,$DF,$DF,$E1,$E7,$FE,$FF,$FF
 .db $C7,$FE,$00,$C7,$98,$00,$C0,$0F,$FF,$F7,$CF,$10,$00,$03,$8F,$3E
 .db $07,$0F,$FC,$7F,$FC,$3F,$E6,$70,$04,$30,$80,$00,$80,$19,$03,$FF
 .db $FF,$2E,$00,$01,$8F,$FC,$7F,$F6,$CF,$FD,$FD,$FF,$C3,$F0,$73,$06
 .db $3E,$C0,$8E,$18,$1B,$FF,$9F,$10,$F0,$07,$00,$2D,$FF,$C9,$8F,$80
 .db $FC,$FF,$3F,$3F,$B0,$B8,$FC,$00,$00,$00,$00,$FF,$FF,$FC,$F1,$E2
 .db $00,$07,$C3,$EF,$FF,$DF,$FF,$FF,$9F,$9E,$00,$E0,$07,$3C,$00,$00
 .db $20,$1F,$FF,$F3,$F9,$80,$08,$1F,$C1,$FF,$B0,$FF,$3F,$27,$FE,$DF
 .db $FF,$FF,$80,$80,$00,$04,$20,$27,$FF,$FF,$FF,$C0,$00,$00,$3F,$FF
 .db $3F,$FD,$97,$FF,$FC,$FF,$E0,$7E,$E1,$E0,$86,$00,$01,$C7,$3F,$FF
 .db $FF,$FF,$98,$00,$00,$7F,$FF,$E1,$FC,$03,$FF,$FE,$7F,$E8,$00,$00
 .db $F0,$02,$00,$01,$B7,$EF,$FF,$F0,$81,$DC,$01,$FB,$08,$77,$F0,$07
 .db $FF,$FF,$FF,$FC,$FE,$00,$0D,$FC,$00,$00,$00,$7F,$FF,$C7,$F0,$00
 .db $00,$FF,$FC,$7C,$01,$FF,$FF,$FF,$F7,$9D,$FE,$00,$73,$FE,$00,$00
 .db $00,$03,$FF,$FF,$FF,$80,$00,$00,$33,$80,$F8,$7F,$FF,$FF,$FF,$FF
 .db $03,$04,$4D,$FF,$80,$00,$00,$00,$3F,$FF,$FF,$FF,$00,$00,$03,$E1
 .db $31,$C0,$73,$FF,$FF,$FF,$FF,$DE,$70,$07,$00,$00,$00,$00,$FF,$FF
 .db $FF,$F9,$80,$00,$00,$C1,$CF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00,$FF
 .db $F8,$00,$00,$00,$19,$FF,$FF,$FF,$C0,$00,$00,$08,$80,$CC,$7E,$FF
 .db $FF,$FF,$FF,$9F,$F1,$80,$98,$00,$00,$00,$00,$07,$FE,$FF,$F2,$20
 .db $01,$0F,$FF,$F9,$30,$01,$1B,$FF,$FF,$FF,$FF,$F8,$0A,$20,$00,$00
 .db $00,$0F,$FF,$FF,$FF,$B8,$00,$00,$F4,$CF,$C8,$FD,$EF,$FF,$FF,$FF
 .db $FD,$0A,$08,$FF,$A0,$00,$00,$00,$1F,$FF,$FF,$FC,$A0,$00,$00,$00
 .db $80,$7F,$FF,$FF,$FF,$FF,$FF,$DF,$00,$B7,$F8,$E0,$00,$00,$03,$FF
 .db $FF,$FF,$F0,$00,$03,$00,$10,$82,$2F,$FF,$FF,$FF,$FF,$FF,$FE,$3B
 .db $E0,$00,$00,$00,$00,$FF,$FF,$FF,$91,$00,$00,$11,$7B,$FE,$BF,$FF
 .db $FF,$FF,$E3,$FF,$FF,$FF,$BB,$E0,$00,$00,$00,$0F,$FF,$CF,$FE,$F8
 .db $00,$30,$01,$8C,$00,$98,$FF,$FF,$FF,$FF,$FF,$E7,$F3,$30,$00,$00
 .db $00,$01,$FF,$FF,$FF,$FF,$40,$00,$08,$00,$42,$1F,$FF,$FF,$FF,$FF
 .db $FF,$F8,$02,$1C,$00,$00,$10,$00,$3C,$4F,$FF,$FF,$E0,$80,$00,$00
 .db $28,$9F,$80,$01,$FF,$FF,$FF,$B6,$9E,$27,$00,$03,$F1,$60,$00,$0F
 .db $9C,$FF,$FF,$E0,$FE,$00,$00,$01,$FF,$CF,$FF,$FF,$FF,$FF,$CE,$FF
 .db $F7,$20,$00,$00,$00,$DF,$F0,$3F,$FF,$FC,$00,$00,$01,$FF,$FF,$FE
 .db $FF,$FF,$FF,$FC,$FE,$FF,$FB,$00,$00,$00,$10,$1F,$F8,$DF,$FF,$FE
 .db $00,$02,$20,$04,$3F,$9F,$E0,$F7,$CF,$FF,$FF,$FF,$FF,$E0,$00,$00
 .db $00,$00,$1F,$FF,$FF,$FF,$FA,$00,$00,$00,$00,$7F,$EF,$FF,$FF,$8E
 .db $33,$FF,$FF,$FC,$00,$00,$00,$00,$00,$FF,$E7,$FF,$FC,$00,$02,$00
 .db $70,$00,$01,$FF,$FF,$FF,$FF,$7F,$F1,$FF,$FC,$00,$00,$00,$00,$1B
 .db $FF,$FF,$FF,$00,$00,$00,$00,$71,$1F,$60,$3F,$FE,$FF,$FF,$FF,$FF
 .db $FE,$20,$00,$00,$00,$07,$FF,$FF,$FF,$BE,$E0,$00,$00,$00,$1B,$F3
 .db $FF,$FB,$1F,$FF,$FF,$FE,$3B,$FF,$F0,$00,$00,$00,$19,$1D,$FF,$FF
 .db $FE,$20,$00,$00,$00,$33,$FF,$FF,$E7,$F1,$8F,$FF,$FF,$FF,$FB,$F0
 .db $00,$00,$00,$00,$00,$0E,$78,$DF,$FF,$FF,$FF,$FF,$FC,$07,$C0,$60
 .db $00,$1C,$FF,$FF,$FF,$FD,$FF,$FE,$7F,$FF,$FF,$FF,$FF,$FB,$00,$00
 .db $00,$00,$00,$00,$04,$34,$FF,$FF,$FF,$FF,$FC,$3C,$00,$00,$01,$FF
 .db $FF,$FF,$FF,$FF,$F8,$80,$00,$00,$6F,$FF,$FF,$FD,$FF,$F8,$FF,$00
 .db $00,$00,$00,$00,$00,$00,$7F,$FF,$FF,$FF,$E1,$B8,$00,$00,$00,$40
 .db $84,$59,$9F,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$23,$3F,$FF,$FF
 .db $FF,$00,$00,$00,$01,$17,$3B,$FF,$FF,$FF,$FF,$FF,$F3,$BD,$CC,$00
 .db $00,$00,$00,$00,$1F,$FF,$FF,$C0,$00,$00,$00,$01,$FC,$3F,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$98,$08,$C0,$00,$00,$0F,$FF,$FF,$FF,$F0,$00
 .db $00,$00,$1F,$B1,$FF,$8F,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$01
 .db $18,$39,$9F,$FF,$E3,$00,$00,$00,$1F,$FF,$FF,$FC,$D3,$FF,$FF,$FF
 .db $FF,$E6,$F8,$00,$00,$00,$00,$01,$FF,$FF,$FC,$C0,$00,$00,$00,$37
 .db $DF,$F6,$3F,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$0D,$D9,$FF,$FF
 .db $FF,$60,$00,$00,$00,$0F,$FF,$77,$01,$FF,$FF,$FF,$FF,$FE,$00,$00
 .db $00,$00,$02,$0F,$F1,$9F,$FB,$CC,$00,$08,$00,$C7,$FF,$39,$80,$00
 .db $7F,$FF,$FF,$FF,$FF,$3E,$00,$00,$00,$00,$00,$F7,$FF,$FF,$1A,$00
 .db $00,$00,$00,$63,$FF,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$19,$FF,$00
 .db $00,$07,$FE,$FF,$C0,$00,$00,$00,$11,$FA,$07,$F9,$FF,$FF,$FF,$FF
 .db $FF,$EF,$00,$00,$07,$00,$10,$10,$00,$7F,$FF,$FF,$00,$00,$00,$01
 .db $00,$09,$FF,$FF,$FF,$FF,$FF,$FC,$03,$00,$0C,$00,$00,$00,$7F,$FF
 .db $FF,$FF,$E0,$00,$00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$8F,$38,$11
 .db $31,$C0,$00,$00,$00,$00,$07,$FF,$CC,$F0,$73,$1F,$FC,$00,$00,$00
 .db $23,$FC,$03,$FE,$07,$FF,$FF,$00,$FF,$00,$07,$FF,$FF,$FF,$E0,$00
 .db $0F,$80,$BF,$FC,$18,$C0,$0F,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00
 .db $FF,$FF,$FF,$FF,$FE,$2F,$A0,$19,$FF,$FF,$00,$00,$6B,$FF,$F8,$0C
 .db $00,$3F,$F2,$3F,$FF,$FF,$F8,$00,$00,$00,$00,$40,$00,$3F,$FF,$FF
 .db $FF,$C0,$00,$00,$7F,$FF,$F0,$80,$FC,$60,$00,$11,$B0,$87,$FF,$FF
 .db $FC,$3C,$00,$00,$00,$00,$00,$00,$1E,$7F,$FF,$FF,$FF,$FC,$06,$00
 .db $00,$00,$F9,$C3,$FF,$FC,$03,$EC,$E0,$07,$FF,$FF,$E2,$17,$FF,$E0
 .db $00,$00,$00,$01,$07,$FF,$FF,$FF,$F7,$EF,$1F,$FF,$C7,$FF,$0E,$7B
 .db $F3,$FE,$00,$00,$1E,$30,$3F,$FF,$FF,$EE,$0F,$FA,$00,$00,$00,$0D
 .db $FF,$FF,$FF,$FF,$FE,$7B,$FF,$FF,$FB,$FF,$C8,$3C,$F0,$67,$80,$00
 .db $00,$00,$1F,$FF,$FF,$FC,$8F,$FF,$80,$00,$00,$00,$04,$7F,$FF,$3F
 .db $00,$3F,$FF,$EF,$C0,$70,$01,$CF,$FF,$FF,$EE,$00,$00,$72,$07,$FF
 .db $FF,$FF,$00,$1F,$C0,$00,$00,$00,$7F,$FF,$FD,$F8,$07,$FF,$FF,$FF
 .db $FF,$BC,$7F,$80,$07,$C4,$5C,$00,$00,$1F,$FF,$FF,$88,$FF,$EC,$7F
 .db $00,$00,$00,$00,$03,$D3,$FF,$FF,$FF,$FF,$EF,$FF,$FF,$FF,$FE,$00
 .db $37,$81,$80,$00,$00,$47,$FF,$79,$FF,$FF,$F9,$9F,$FF,$00,$00,$00
 .db $01,$C7,$FF,$FF,$FF,$19,$FF,$FF,$EF,$FF,$FF,$1C,$00,$00,$00,$B0
 .db $33,$01,$CF,$FF,$FF,$FF,$FF,$FF,$3E,$C0,$00,$00,$01,$FF,$FF,$FF
 .db $E7,$0C,$3F,$FF,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$01,$B3,$BF,$FB
 .db $8F,$FF,$FF,$FF,$F9,$00,$00,$00,$00,$7F,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$B9,$00,$00,$F9,$FF,$F7,$EF,$FE,$70,$03,$00,$00,$1C,$FF,$FF
 .db $FF,$F9,$00,$40,$66,$20,$00,$0C,$FF,$CE,$63,$7F,$FF,$DC,$C6,$40
 .db $62,$23,$3B,$BD,$DC,$66,$02,$63,$11,$39,$9F,$FF,$FF,$E2,$33,$00
 .db $19,$88,$00,$01,$1F,$FB,$D8,$01,$87,$70,$FF,$8F,$FF,$FC,$CF,$E4
 .db $00,$00,$00,$8F,$FF,$FF,$FF,$FF,$F8,$00,$00,$00,$00,$00,$03,$9F
 .db $FF,$FF,$FF,$7F,$F1,$00,$00,$46,$06,$33,$03,$FF,$FF,$FF,$7F,$E3
 .db $3F,$13,$FF,$FF,$FF,$FF,$F3,$00,$00,$00,$00,$00,$03,$FB,$FF,$FF
 .db $FC,$E0,$00,$1F,$F1,$9F,$FD,$FF,$FF,$FF,$FD,$F8,$9C,$C0,$C6,$7F
 .db $FF,$FF,$FF,$E4,$40,$06,$00,$00,$00,$60,$46,$66,$7F,$FF,$FF,$FF
 .db $FF,$F7,$30,$3F,$BF,$DE,$00,$00,$03,$10,$3F,$FF,$FF,$F0,$76,$00
 .db $00,$00,$9C,$0C,$39,$FF,$FF,$FF,$FF,$FF,$E0,$00,$00,$00,$00,$00
 .db $F1,$FF,$FC,$47,$CF,$FF,$FC,$E0,$00,$00,$06,$00,$00,$00,$3F,$F7
 .db $BF,$FF,$FE,$00,$00,$01,$88,$CC,$CF,$E7,$F0,$00,$00,$04,$6E,$FF
 .db $FF,$FF,$3C,$00,$00,$27,$FE,$87,$78,$00,$00,$FE,$00

.end
